/*
	File:		CMComponent.h

	Copyright:	 1984-1994 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __CMCOMPONENT__
#define __CMCOMPONENT__

#ifndef __TYPES__
#include <Types.h>
/*	#include <ConditionalMacros.h>								*/
/*	#include <MixedMode.h>										*/
/*		#include <Traps.h>										*/
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
/*	#include <QuickdrawText.h>									*/
/*		#include <IntlResources.h>								*/
#endif

#ifndef __COMPONENTS__
#include <Components.h>
#endif

#ifndef __CMAPPLICATION__
#include <CMApplication.h>
/*	#include <Printing.h>										*/
/*		#include <Dialogs.h>									*/
/*			#include <Windows.h>								*/
/*				#include <Events.h>								*/
/*					#include <OSUtils.h>						*/
/*				#include <Controls.h>							*/
/*					#include <Menus.h>							*/
/*			#include <TextEdit.h>								*/
#endif

#define CMInterfaceVersion 0

#define kCMInit 0

#define kCMMatchColors 1

#define kCMGamutTest 2

#define kCMMatchPixMap 3

#define kCMCheckPixMap 4

#define kCMConcatenateProfiles 5

#define ProfileResponderInterfaceRev 0

#define kCMGetProfile 0

#define kCMSetProfile 1

#define kCMSetProfileDescription 2

#define kCMGetIndexedProfile 3

#define kCMDeleteDeviceProfile 4

#define kProfileResponderMaxSelector kCMDeleteDeviceProfile

typedef ComponentInstance ProfileResponder;

#ifdef __cplusplus
extern "C" {
#endif

extern pascal CMError CMInit(ComponentInstance CMSession, CMProfileHandle srcProfile, CMProfileHandle dstProfile)
 FIVEWORDINLINE(0x2F3C, 0x0008, 0, 0x7000, 0xA82A);
extern pascal CMError CMMatchColors(ComponentInstance CMSession, CMColorList myColors, long count)
 FIVEWORDINLINE(0x2F3C, 0x0008, 1, 0x7000, 0xA82A);
extern pascal CMError CMCheckColors(ComponentInstance CMSession, CMColorList myColors, long count, CMGamutResult result)
 FIVEWORDINLINE(0x2F3C, 0x000C, 2, 0x7000, 0xA82A);
extern pascal CMError CMMatchPixMap(ComponentInstance CMSession, PixMap *myPixMap, PixMapCallBackUPP progressProc, long refCon)
 FIVEWORDINLINE(0x2F3C, 0x000c, 3, 0x7000, 0xA82A);
extern pascal CMError CMCheckPixMap(ComponentInstance CMSession, PixMap *myPixMap, PixMapCallBackUPP progressProc, BitMap *myBitMap, long refCon)
 FIVEWORDINLINE(0x2F3C, 0x0010, 4, 0x7000, 0xA82A);
extern pascal CMError CMConcatenateProfiles(ComponentInstance CMSession, CMProfileHandle thru, CMProfileHandle dst, CMProfileHandle *newDst)
 FIVEWORDINLINE(0x2F3C, 0x000C, 5, 0x7000, 0xA82A);
extern pascal CMError CMGetProfile(ProfileResponder myProfileResponder, CMProfileHandle aProfile, CMProfileHandle *returnedProfile)
 FIVEWORDINLINE(0x2F3C, 0x0008, 0, 0x7000, 0xA82A);
extern pascal CMError CMSetProfile(ProfileResponder myProfileResponder, CMProfileHandle newProfile)
 FIVEWORDINLINE(0x2F3C, 0x0004, 1, 0x7000, 0xA82A);
extern pascal CMError CMSetProfileDescription(ProfileResponder myProfileResponder, long DeviceData, CMProfileHandle hProfile)
 FIVEWORDINLINE(0x2F3C, 0x0008, 2, 0x7000, 0xA82A);
extern pascal CMError CMGetIndexedProfile(ProfileResponder myProfileResponder, CMProfileSearchRecordHandle search, CMProfileHandle *returnProfile, long *index)
 FIVEWORDINLINE(0x2F3C, 0x000C, 3, 0x7000, 0xA82A);
extern pascal CMError CMDeleteDeviceProfile(ProfileResponder myProfileResponder, CMProfileHandle deleteMe)
 FIVEWORDINLINE(0x2F3C, 0x0004, 4, 0x7000, 0xA82A);
#ifdef __cplusplus
}
#endif

#endif

