
	//
	//	FILE: Gator.H
	//
	//	PURPOSE: Defines values internal to Gator.EXE,
	//			 the ODBC SQLCLI Test Application for Microsoft Windows
	//
	//	     (C) 1990-1992 Microsoft Corporation.  All right reserved.
	//
#ifdef WINDOWS
#define NOMINMAX
#define NORESOURCE
#define NOATOM
#define NOKEYBOARDINFO
#define NOLANGUAGE
#define NOMETAFILE
#define NOGDICAPMASKS
#define NODRAWTEXT
#define NOMETAFILE
#define NOSCROLL
#define NOWH
#define NONCMESSAGES
#define NOKEYSTATES
#define NODEFERWINDOWPOS
#define NOSCROLL
#define NOCOLOR
#define NOICONS
#define NOKANJI
#define NOSOUND
#define NOCOMM
#define NOMDI
#define NOPROFILER
#endif WINDOWS


//#include <windows.h>		// required for all Windows applications

//#include <stdlib.h> 		// C6 function library includes
#include <string.h>

#include <sql.h>			// ODBC includes
#include <sqlext.h>

//#define BASED(expression)   _based(expression)
//#define SEGNAME(expression) _segname(expression)

//	typedef void _huge * HPVOID;
	typedef void * HPVOID;	// mj
	typedef BYTE * LPBYTE;	// mj
	typedef void * DLGPROC;	// mj

	// CSCONST - a storage class specifier (like FAR) which places the
	//           variable in the current module's code space - should
	//           be used only for constants or pointers to constants.
	//
//#define CSCONST BASED(SEGNAME("_CODE"))
#define CSCONST		// mj

#include "odbcstr.h"		// ODBC strings ODBC Test

#define OUTSTRLEN	255 	// Output String length

	// Values for ControlSzWrite() arguments fScreen and fLog:

#define SAME	0	// Don't change
#define DISABLE	1	// Disable writing
#define RESTORE	2	// Restore to state saved before this call
#define ENABLE	3	// Enable writing
#define SAVE	4	// Save the state before this call

	// Function prototypes:
	//
pascal VOID szWrite( LPBYTE lsz, BOOL fEOL );
pascal VOID EchoRetcode( LPBYTE lszFunction, RETCODE retcode );
pascal HANDLE AllocateMemory( UDWORD cb );
//pascal HPVOID LockMemory( HANDLE hmem );	// see adhoc.h
pascal void ReleaseMemory( HPVOID hpb );
pascal BOOL FDoDialogBox(
				LPBYTE lszResourceName, HWND hwnd, DLGPROC lpfnDialogProc );
pascal VOID ControlSzWrite( int fScreen, int fLog );
pascal BOOL FControlWriteLog( VOID * env );
pascal VOID CenterDlg( HWND );
pascal BOOL FAbortCheck( void );
