
	/* Created 3/12/93 4:51 PM by AppMaker */

#include <Types.h>
#include <Quickdraw.h>
#include <Controls.h>
#include <Dialogs.h>
#include <Events.h>
#include <Lists.h>
#include <Menus.h>
#include <TextEdit.h>
#include "Globals.h"

		/* Standard vars:	*/

	Boolean			quittingTime;                             
	Boolean			inBackground;
	EventRecord		curEvent;                          
	WindowPtr		curWindow;
	SysConfigRec	sysConfig;
	WinInfoRec		noCur;
	WinInfoPtr		cur;

#pragma segment Globals 


void InitGlobals()
{
	curWindow			= nil;
	noCur.text			= nil;
	noCur.Scroll5Handle	= nil;
	noCur.vScroll		= nil;
	noCur.hScroll		= nil;
	noCur.fileNum		= 0;
	noCur.volNum		= 0;
	noCur.dirty			= false;
	noCur.windowKind	= noWindow;
	noCur.line9.top		= noCur.line9.bottom	= 0;
	noCur.line9.right	= noCur.line9.left		= 0;

	cur = &noCur;
	return;
}/* end InitGlobals */


void SetInfo( WindowPtr window )
{
	if( window != curWindow )
	{
		curWindow = window;
		if( curWindow != nil )
			 cur = (WinInfoPtr)GetWRefCon( curWindow );
		else cur = &noCur;
	}
	return;
}/* end SetInfo */


void SetNewInfo( WindowPtr window )
{
	WinInfoPtr		infoPtr;

	infoPtr = (WinInfoPtr)NewPtr( sizeof( WinInfoRec ) );
	SetWRefCon( window, (long)infoPtr );
	SetInfo( window );
	return;
}/* end SetNewInfo */


void DiscardInfo( WindowPtr window )
{
	WinInfoPtr		infoPtr;

	if( window == curWindow )
		SetInfo( nil );
	infoPtr = (WinInfoPtr)GetWRefCon( window );
	DisposPtr( (Ptr)infoPtr );
	HideWindow( window );
	DisposeWindow( window );
	return;
}/* end DiscardInfo */
