

	/* Created 3/12/93 4:51 PM by AppMaker	*/

#ifndef _H_Globals
#define _H_Globals

typedef struct pop
{
	short		choice;
	short		menuID;
	MenuHandle	hMenu;
	Rect		popRect;
} windowPop;


typedef struct
{
	short			fileNum;             
	short			volNum;            
	Boolean			dirty;
	StringHandle	filename;

	enum { noWindow, WODBCtest }	windowKind;

	Handle			wictHandle;		/* Window item color table resource	*/

	TEHandle		inFieldHandle;
	TEHandle		outFieldHandle;
	TEHandle		text;			/* current text: inField or outField	*/
	ControlHandle	Scroll5Handle;
	ControlHandle	vScroll;
	ControlHandle	hScroll;
//	ControlHandle	xScroll;		// ??? 4th scroll bar
	Rect			line4;			/* top line under popups			*/
	Rect			line9;			/* dividing line					*/
	Rect			teIn;			/* text edit in						*/
	Rect			teOut;			/* text edit out					*/
} WinInfoRec, *WinInfoPtr;


typedef struct
{
	Boolean			hasGestalt;			/* has Gestalt manager	*/
	Boolean			hasWNE;				/* has WaitNextEvent	*/ 
	Boolean			hasColorQD;			/* has Color QuickDraw	*/
	Boolean			hasAppleEvents;		/* has Apple Events		*/
	Boolean			hasEditionMgr;		/* has Edition Manager	*/
} SysConfigRec;

		/* Standard vars: */

	extern Boolean			quittingTime;                             
	extern EventRecord		curEvent;                          
	extern WindowPtr		curWindow;
	extern WinInfoPtr		cur;
	extern Boolean			inBackground;
	extern SysConfigRec		sysConfig;
	
		/* Application-specific vars:	*/
	
	void	InitGlobals();
	void	SetInfo(		WindowPtr window );
	void	SetNewInfo(		WindowPtr window );
	void	DiscardInfo(	WindowPtr window );

#endif	/* _H_Globals	*/
