
	/* Created 3/12/93 5:01 PM by AppMaker	*/

#include <Types.h>
#include <Quickdraw.h>
#include <Controls.h>
#include <Dialogs.h>
#include <Events.h>
#include <Lists.h>
#include <Menus.h>
#include <TextEdit.h>
#include <Desk.h>
#include <ToolUtils.h>

#include "Globals.h"
#include "ResourceDefs.h"
#include "Miscellany.h"
#include "doMenuItems.h"
#include "MainMenu.h"

#pragma segment MainMenu 

	extern windowPop	STMTpop;
	extern windowPop	DBCpop;

	MenuHandle		menu;
	Boolean			menuBarChanged;

		/* menu handles */

	MenuHandle		AppleMenu;
	MenuHandle		FileMenu;
	MenuHandle		EditMenu;
	MenuHandle		ConnectMenu;
	MenuHandle		StatementMenu;
	MenuHandle		ResultsMenu;
	MenuHandle		CatalogMenu;
	MenuHandle		OptionsMenu;
	MenuHandle		MiscMenu;
	MenuHandle		AutoMenu;
	MenuHandle		HelpMenu;

//	MenuHandle		hDBCMenu,	hSTMTMenu;

	MenuHandle		Qualifier40Menu;		/* #40 SQLColumns		*/
	MenuHandle		Owner40Menu;
	MenuHandle		Name40Menu;
	MenuHandle		ColName40Menu;
	MenuHandle		cbQualifier40Menu;
	MenuHandle		cbOwner40Menu;
	MenuHandle		cbName40Menu;
	MenuHandle		cbColName40Menu;

	MenuHandle		szConnStrIn41Menu;		/* #41 SQLDriverConnect	*/
	MenuHandle		cbConnStrIn41Menu;
	MenuHandle		fDriverCompletionMenu;

	MenuHandle		fOptionPop42Menu;		/* #42 SQLGetConnectOption	*/
	MenuHandle		fCTypePop43Menu;		/* #43 SQLGetData			*/
	MenuHandle		fFunctionPop44Menu;		/* #44 SQLGetFunctions		*/
	MenuHandle		fInfoTypeMenu;			/* #45 SQLGetInfo			*/
	MenuHandle		fOptionPop46Menu;		/* #46 SQLGetStmtOption		*/
	MenuHandle		fSqlType47Menu;			/* #47 SQLGetTypeInfo		*/
	MenuHandle		cbValuePop49Menu;		/* #49 SQLPutData			*/
	MenuHandle		fOptionPop50Menu;		/* #50 SQLSetConnectOption	*/
	MenuHandle		vParamPop50Menu;
	MenuHandle		fOptionPop51Menu;		/* #51 SQLSetStmtOption 	*/
	MenuHandle		vParamPop51Menu;
	MenuHandle		fColTypePop52Menu;		/* #52 SQLSpecialColumns	*/
	MenuHandle		QualifierPop52Menu;
	MenuHandle		OwnerPop52Menu;
	MenuHandle		NamePop52Menu;
	MenuHandle		cbQualifierPop52Menu;
	MenuHandle		cbOwnerPop52Menu;
	MenuHandle		cbNamePop52Menu;
	MenuHandle		fScopePop52Menu;
	MenuHandle		fNullablePop52Menu;
	MenuHandle		QualifierPop53Menu;		/* #53 SQLStatistics		*/
	MenuHandle		OwnerPop53Menu;
	MenuHandle		NamePop53Menu;
	MenuHandle		cbQualifierPop53Menu;
	MenuHandle		cbOwnerPop53Menu;
	MenuHandle		cbNamePop53Menu;
	MenuHandle		fUniquePop53Menu;
	MenuHandle		fAccuracyPop53Menu;
	MenuHandle		Qualifier54Menu;		/* #54 SQLTables			*/
	MenuHandle		Owner54Menu;
	MenuHandle		Name54Menu;
	MenuHandle		Type54Menu;
	MenuHandle		cbQualifier54Menu;
	MenuHandle		cbOwner54Menu;
	MenuHandle		cbName54Menu;
	MenuHandle		cbType54Menu;
	MenuHandle		szConnStrIn55Menu;		/* #55 SQLBrowseConnect		*/
	MenuHandle		cbConnStrIn55Menu;
	MenuHandle		QualifierPop56Menu;		/* #56 SQLColumnPrivileges	*/
	MenuHandle		OwnerPop56Menu;
	MenuHandle		NamePop56Menu;
	MenuHandle		ColumnPop56Menu;
	MenuHandle		cbQualifierPop56Menu;
	MenuHandle		cbOwnerPop56Menu;
	MenuHandle		cbNamePop56Menu;
	MenuHandle		cbColumnPop56Menu;
	MenuHandle		fDirectionMenu;			/* #57 SQLDataSources		*/
	MenuHandle		fFetchTypePop59Menu;	/* #59 SQLExtendedFetch		*/
	MenuHandle		QualifierPop60Menu;		/* #60 SQLForeignKeys		*/
	MenuHandle		OwnerPop60Menu;
	MenuHandle		NamePop60Menu;
	MenuHandle		Qual2Pop60Menu;
	MenuHandle		Owner2Pop60Menu;
	MenuHandle		Name2Pop60Menu;
	MenuHandle		cbQualifierPop60Menu;
	MenuHandle		cbOwnerPop60Menu;
	MenuHandle		cbNamePop60Menu;
	MenuHandle		cbQual2Pop60Menu;
	MenuHandle		cbOwner2Pop60Menu;
	MenuHandle		cbName2Pop60Menu;
	MenuHandle		cbSqlStrInPop62Menu;	/* #62 SQLNativeSQL			*/

	MenuHandle		QualifierPop65Menu;		/* #65 SQLPrimaryKeys		*/
	MenuHandle		OwnerPop65Menu;
	MenuHandle		NamePop65Menu;
	MenuHandle		cbQualifierPop65Menu;
	MenuHandle		cbOwnerPop65Menu;
	MenuHandle		cbNamePop65Menu;
	MenuHandle		QualifierPop66Menu;		/* #66 SQLProcedureColumns	*/
	MenuHandle		OwnerPop66Menu;
	MenuHandle		NamePop66Menu;
	MenuHandle		ColumnPop66Menu;
	MenuHandle		cbQualifierPop66Menu;
	MenuHandle		cbOwnerPop66Menu;
	MenuHandle		cbNamePop66Menu;
	MenuHandle		cbColumnPop66Menu;
	MenuHandle		QualifierPop67Menu;		/* #67 SQLProcedures		*/
	MenuHandle		OwnerPop67Menu;
	MenuHandle		NamePop67Menu;
	MenuHandle		cbQualifierPop67Menu;
	MenuHandle		cbOwnerPop67Menu;
	MenuHandle		cbNamePop67Menu;
	MenuHandle		fRefreshPop68Menu;		/* #68 SQLSetPos			*/
	MenuHandle		fLockPop68Menu;
	MenuHandle		fConcurrencyPop69Menu;	/* #69 SQLSetScrollOptions	*/
	MenuHandle		crowKeysetPop69Menu;
	MenuHandle		QualifierPop70Menu;		/* #70 SQLTablePrivileges	*/
	MenuHandle		OwnerPop70Menu;
	MenuHandle		NamePop70Menu;
	MenuHandle		cbQualifierPop70Menu;
	MenuHandle		cbOwnerPop70Menu;
	MenuHandle		cbNamePop70Menu;

	MenuHandle		fCTypePop22Menu;
	MenuHandle		fSqlTypePop22Menu;
	MenuHandle		rgbValuePop22Menu;
	MenuHandle		XfSqlTypePopMenu;
	MenuHandle		XfUniquePopMenu;
	MenuHandle		szDSNMenu;
	MenuHandle		szUIDMenu;
	MenuHandle		szAuthStrMenu;
	MenuHandle		DataSourceMenu;
//	MenuHandle		XfSqlTypeMenu;
	MenuHandle		UserIDMenu;
	MenuHandle		PasswordMenu;
	MenuHandle		fDescType6Menu;
	MenuHandle		fTypePop23Menu;
	MenuHandle		fOptionPop16Menu;
	MenuHandle		fCTypePop4Menu;
	MenuHandle		szCursorPopMenu;
	MenuHandle		cbCursorPopMenu;
	MenuHandle		cbSqlStrPop19Menu;
	MenuHandle		cbSqlStrPop11Menu;
	MenuHandle		FPpcbValuePopMenu;
	MenuHandle		cbDSNMenu;
	MenuHandle		cbUIDMenu;
	MenuHandle		cbAuthStrMenu;


	static void Enable( short itemNr, Boolean enabled );
	static void EnableTitle( MenuHandle menu, Boolean enabled );
	static void DoApple( short itemNr );


void LoadMenus()
{
	DBCpop.hMenu			= GetMenu( hDBCID );
	STMTpop.hMenu			= GetMenu( hSTMTID );

	AppleMenu				= GetMenu( AppleID );
	FailNilResource( (Handle)AppleMenu );
	AddResMenu( AppleMenu, 'DRVR' );
	FileMenu				= GetMenu( FileID );
	EditMenu				= GetMenu( EditID );
	ConnectMenu				= GetMenu( ConnectID );
	StatementMenu			= GetMenu( StatementID );
	ResultsMenu				= GetMenu( ResultsID );
	CatalogMenu				= GetMenu( CatalogID );
	OptionsMenu				= GetMenu( OptionsID );
	MiscMenu				= GetMenu( MiscID );
	AutoMenu				= GetMenu( AutoID );
	HelpMenu				= GetMenu( HelpID );

	Qualifier40Menu		= GetMenu( QualifierPop40ID		);	/* #40 SQLColumns	*/
	Owner40Menu			= GetMenu( OwnerPop40ID			);
	Name40Menu			= GetMenu( NamePop40ID			);
	ColName40Menu		= GetMenu( ColNamePop40ID		);
	cbQualifier40Menu	= GetMenu( cbQualifierPop40ID	);
	cbOwner40Menu		= GetMenu( cbOwnerPop40ID		);
	cbName40Menu		= GetMenu( cbNamePop40ID		);
	cbColName40Menu		= GetMenu( cbColNamePop40ID		);

	szConnStrIn41Menu		= GetMenu( szConnStrIn41ID	);	/* #41 SQLDriverConnect	*/
	cbConnStrIn41Menu		= GetMenu( cbConnStrIn41ID	);
	fDriverCompletionMenu	= GetMenu( fDriverCompletionID );
	fOptionPop42Menu		= GetMenu( fOptionPop42ID )		/* #42 SQLGetConnectOption*/;
	fCTypePop43Menu			= GetMenu( fCTypePop43ID );		/* #43 SQLGetData		*/
	fFunctionPop44Menu		= GetMenu( fFunctionPop44ID );	/* #44 SQLGetFunctions	*/
	fInfoTypeMenu			= GetMenu( fInfoTypeID );		/* #45 SQLGetInfo		*/
	fOptionPop46Menu		= GetMenu( fOptionPop46ID );	/* #46 SQLGetStmtOption	*/
	fSqlType47Menu			= GetMenu( fSqlTypePop47ID );	/* #47 SQLGetTypeInfo	*/
	cbValuePop49Menu		= GetMenu( cbValuePop49ID );	/* #49 SQLPutData		*/
	fOptionPop50Menu		= GetMenu( fOptionPop50ID );	/* #50 SQLSetConnectOption*/
	vParamPop50Menu			= GetMenu( vParamPop50ID );
	fOptionPop51Menu		= GetMenu( fOptionPop51ID );	/* #51 SQLSetStmtOption	*/
	vParamPop51Menu			= GetMenu( vParamPop51ID );
	fColTypePop52Menu		= GetMenu( fColTypePop52ID );	/* #52 SQLSpecialColumns*/
	QualifierPop52Menu		= GetMenu( QualifierPop52ID );
	OwnerPop52Menu			= GetMenu( OwnerPop52ID );
	NamePop52Menu			= GetMenu( NamePop52ID );
	fNullablePop52Menu		= GetMenu( fNullablePop52ID );
	fScopePop52Menu			= GetMenu( fScopePop52ID );
	cbQualifierPop52Menu	= GetMenu( cbQualifierPop52ID );
	cbOwnerPop52Menu		= GetMenu( cbOwnerPop52ID );
	cbNamePop52Menu			= GetMenu( cbNamePop52ID );
	QualifierPop53Menu		= GetMenu( QualifierPop53ID );	/* #53 SQLStatistics	*/
	OwnerPop53Menu			= GetMenu( OwnerPop53ID );
	NamePop53Menu			= GetMenu( NamePop53ID );
	cbQualifierPop53Menu	= GetMenu( cbQualifierPop53ID );
	cbOwnerPop53Menu		= GetMenu( cbOwnerPop53ID );
	cbNamePop53Menu			= GetMenu( cbNamePop53ID );
	fUniquePop53Menu		= GetMenu( fUniquePop53ID );
	fAccuracyPop53Menu		= GetMenu( fAccuracyPop53ID );
	Qualifier54Menu			= GetMenu( Qualifier54ID );		/* #54 SQLTables		*/
	Owner54Menu				= GetMenu( Owner54ID );
	Name54Menu				= GetMenu( Name54ID );
	Type54Menu				= GetMenu( Type54ID );
	cbQualifier54Menu		= GetMenu( cbQualifier54ID );
	cbOwner54Menu			= GetMenu( cbOwner54ID );
	cbName54Menu			= GetMenu( cbName54ID );
	cbType54Menu			= GetMenu( cbType54ID );
	szConnStrIn55Menu		= GetMenu( szConnStrIn55ID );	/* #55 SQLBrowseConnect	*/
	cbConnStrIn55Menu		= GetMenu( cbConnStrIn55ID );
	QualifierPop56Menu		= GetMenu( QualifierPop56ID );	/* #56 SQLColumnPrivileges*/
	OwnerPop56Menu			= GetMenu( OwnerPop56ID );
	NamePop56Menu			= GetMenu( NamePop56ID );
	ColumnPop56Menu			= GetMenu( ColumnPop56ID );
	cbQualifierPop56Menu	= GetMenu( cbQualifierPop56ID );
	cbOwnerPop56Menu		= GetMenu( cbOwnerPop56ID );
	cbNamePop56Menu			= GetMenu( cbNamePop56ID );
	cbColumnPop56Menu		= GetMenu( cbColumnPop56ID );
	fDirectionMenu			= GetMenu( fDirectionID );		/* #57 SQLDataSources	*/
	fFetchTypePop59Menu		= GetMenu( fFetchTypePop59ID );	/* #59 SQLExtendedFetch	*/
	QualifierPop60Menu		= GetMenu( QualifierPop60ID );	/* #60 SQLForeignKeys	*/
	OwnerPop60Menu			= GetMenu( OwnerPop60ID );
	NamePop60Menu			= GetMenu( NamePop60ID );
	Qual2Pop60Menu			= GetMenu( Qual2Pop60ID );
	Owner2Pop60Menu			= GetMenu( Owner2Pop60ID );
	Name2Pop60Menu			= GetMenu( Name2Pop60ID );
	cbQualifierPop60Menu	= GetMenu( cbQualifierPop60ID );
	cbOwnerPop60Menu		= GetMenu( cbOwnerPop60ID );
	cbNamePop60Menu			= GetMenu( cbNamePop60ID );
	cbQual2Pop60Menu		= GetMenu( cbQual2Pop60ID );
	cbOwner2Pop60Menu		= GetMenu( cbOwner2Pop60ID );
	cbName2Pop60Menu		= GetMenu( cbName2Pop60ID );
	cbSqlStrInPop62Menu		= GetMenu( cbSqlStrInPop62ID );	/* #62 SQLNativeSQL		*/

	QualifierPop65Menu		= GetMenu( QualifierPop65ID );	/* #65 SQLPrimaryKeys	*/
	OwnerPop65Menu			= GetMenu( OwnerPop65ID );
	NamePop65Menu			= GetMenu( NamePop65ID );
	cbQualifierPop65Menu	= GetMenu( cbQualifierPop65ID );
	cbOwnerPop65Menu		= GetMenu( cbOwnerPop65ID );
	cbNamePop65Menu			= GetMenu( cbNamePop65ID );
	QualifierPop66Menu		= GetMenu( QualifierPop66ID );	/* #66 SQLProcedureColumns	*/
	OwnerPop66Menu			= GetMenu( OwnerPop66ID );
	NamePop66Menu			= GetMenu( NamePop66ID );
	ColumnPop66Menu			= GetMenu( ColumnPop66ID );
	cbQualifierPop66Menu	= GetMenu( cbQualifierPop66ID );
	cbOwnerPop66Menu		= GetMenu( cbOwnerPop66ID );
	cbNamePop66Menu			= GetMenu( cbNamePop66ID );
	cbColumnPop66Menu		= GetMenu( cbColumnPop66ID );
	QualifierPop67Menu		= GetMenu( QualifierPop67ID );	/* #67 SQLProcedures		*/
	OwnerPop67Menu			= GetMenu( OwnerPop67ID );
	NamePop67Menu			= GetMenu( NamePop67ID );
	cbQualifierPop67Menu	= GetMenu( cbQualifierPop67ID );
	cbOwnerPop67Menu		= GetMenu( cbOwnerPop67ID );
	cbNamePop67Menu			= GetMenu( cbNamePop67ID );
	fRefreshPop68Menu		= GetMenu( fRefreshPop68ID );	/* #68 SQLSetPos	*/
	fLockPop68Menu			= GetMenu( fLockPop68ID );
	fConcurrencyPop69Menu	= GetMenu( fConcurrencyPop69ID );/* #69 SQLSetScrollOptions	*/
	crowKeysetPop69Menu		= GetMenu( crowKeysetPop69ID );
	QualifierPop70Menu		= GetMenu( QualifierPop70ID );	/* #70 SQLTablePrivileges	*/
	OwnerPop70Menu			= GetMenu( OwnerPop70ID );
	NamePop70Menu			= GetMenu( NamePop70ID );
	cbQualifierPop70Menu	= GetMenu( cbQualifierPop70ID );
	cbOwnerPop70Menu		= GetMenu( cbOwnerPop70ID );
	cbNamePop70Menu			= GetMenu( cbNamePop70ID );

	fCTypePop22Menu			= GetMenu( fCTypePop22ID );
	fSqlTypePop22Menu		= GetMenu( fSqlTypePop22ID );
	rgbValuePop22Menu		= GetMenu( rgbValuePop22ID );
	XfSqlTypePopMenu		= GetMenu( XfSqlTypePopID );	// ??? delete crap
	XfUniquePopMenu			= GetMenu( XfUniquePopID );		// ??? delete crap
	szDSNMenu				= GetMenu( szDSNID );
	szUIDMenu				= GetMenu( szUIDID );
	szAuthStrMenu			= GetMenu( szAuthStrID );
	DataSourceMenu			= GetMenu( DataSourceID );
//	XfSqlTypeMenu			= GetMenu( XfSqlTypeID );		// ??? delete crap
	UserIDMenu				= GetMenu( UserIDID );
	PasswordMenu			= GetMenu( PasswordID );
	fDescType6Menu			= GetMenu( fDescType6ID );
	fTypePop23Menu			= GetMenu( fTypePop23ID );
	fOptionPop16Menu		= GetMenu( fOptionPop16ID );
	fCTypePop4Menu			= GetMenu( fCTypePop4ID );
	szCursorPopMenu			= GetMenu( szCursorPopID );
	cbCursorPopMenu			= GetMenu( cbCursorPopID );
	cbSqlStrPop19Menu		= GetMenu( cbSqlStrPop19ID );
	cbSqlStrPop11Menu		= GetMenu( cbSqlStrPop11ID );
	FPpcbValuePopMenu		= GetMenu( FPpcbValuePopID );
	cbDSNMenu				= GetMenu( cbDSNpopID );
	cbUIDMenu				= GetMenu( cbUIDpopID );
	cbAuthStrMenu			= GetMenu( cbAuthStrPopID );

	InsertMenu( AppleMenu, 0 );
	InsertMenu( FileMenu, 0 );
	InsertMenu( EditMenu, 0 );
	InsertMenu( ConnectMenu, 0 );
	InsertMenu( StatementMenu, 0 );
	InsertMenu( ResultsMenu, 0 );
	InsertMenu( CatalogMenu, 0 );
	InsertMenu( OptionsMenu, 0 );
	InsertMenu( MiscMenu, 0 );
	InsertMenu( AutoMenu, 0 );
	InsertMenu( HelpMenu, 0 );

	DrawMenuBar();
	return;
}/* end LoadMenus */


static void DoAboutODBCtest()
{
	short		itemNr;
	
	itemNr = Alert( AboutID, nil );
	return;
}/* end DoAboutODBCtest */
 


static void DoApple( short itemNr )
{
	Str255			name;
	short			refNum;

	switch( itemNr )
	{
	case AppleAboutODBCtest:	DoAboutODBCtest();		break;
	default:
		GetItem (AppleMenu, itemNr, name);
		refNum = OpenDeskAcc (name);
		break;
	}/* end SWITCH */
	return;
}/* end DoApple*/


void DoMenu( long menuChoice )
{
	short	menuID;
	short	itemNr;

	menuID = HiWord( menuChoice );
	itemNr = LoWord( menuChoice );

	switch( menuID )
	{
	case 0:				/* Do nothing */;			break;
	case AppleID:		DoApple(     itemNr );		break;
	case FileID:		DoFile(      itemNr );		break;
	case EditID:		DoEdit(      itemNr );		break;
	case ConnectID:		DoConnect(   itemNr );		break;
	case StatementID:	DoStatement( itemNr );		break;
	case ResultsID:		DoResults(   itemNr );		break;
	case CatalogID:		DoCatalog(   itemNr );		break;
	case OptionsID:		DoOptions(   itemNr );		break;
	case MiscID:		DoMisc(      itemNr );		break;
	case AutoID:		DoAuto(      itemNr );		break;
	case HelpID:		DoHelp(      itemNr );		break;
	}/* end SWITCH */

    HiliteMenu( 0 );
	return;
}/* end DoMenu */


static void Enable( short itemNr, Boolean enabled )
{
	if( enabled )
		 EnableItem(  menu, itemNr );
	else DisableItem( menu, itemNr );
	return;
}/* end Enable */


static void EnableTitle( MenuHandle menu, Boolean enabled )
{
	if( enabled != ((**menu).enableFlags & 1) )
		menuBarChanged = true;
	if( enabled )
		 EnableItem(  menu, 0 );
	else DisableItem( menu, 0 );
	return;
}/* end EnableTitle */


void UpdateMenus()
{
	WindowPeek		frontPeek;
	Boolean			isFront;			/* is there a front window?			*/
	Boolean			isCur;				/* is there a current window?		*/
	Boolean			isDirty;			/* is it dirty?						*/
	Boolean			hasFile;			/* does it have a file?				*/
	Boolean			isSelected;			/* is anything selected?			*/
	Boolean			isDesk;				/* is the front window a desk acc?	*/
	Boolean			isText;				/* is there a current text field?	*/
	Boolean			isScrap;			/* is there any scrap?				*/


	menuBarChanged = false;

	isFront		= (FrontWindow() != nil );
	isCur		= (curWindow != nil);
	isDirty 	= false;
	hasFile 	= false;
	isSelected	= false;
	if( isCur )
	{
		isDirty =  cur->dirty;
		hasFile = (cur->fileNum != 0 );
	}

	isDesk = false;
	if( isFront )
	{
		frontPeek	= (WindowPeek)FrontWindow();
		isDesk		= (frontPeek->windowKind < 0 );
	}
	isText	= isCur && (cur->text != nil );
	isScrap	= false;
	if( isText )
	{
		isSelected	= ((**(cur->text)).selStart != (**(cur->text)).selEnd);
		isScrap		= (TEGetScrapLen() > 0);
	}

	menu = FileMenu;
	Enable( FileSaveAs,	isCur );

	menu = EditMenu;
	if( isFront )
	{
		Enable( EditCut,		isDesk || isSelected );
		Enable( EditCopy,		isDesk || isSelected );
		Enable( EditPaste,		isDesk || isScrap );
		Enable( EditClear,		isDesk || isSelected );
		Enable( EditSelectAll,	isText );
		
	}
	EnableTitle( EditMenu, isFront );
	
	
	if( menuBarChanged )
		DrawMenuBar();
}/* end UpdateMenus */
