
	/* Miscellany.h */

#include <Packages.h>

	extern Boolean		errorFlag;


void	Acknowledge( short alertID );

Boolean	CheckOS( OSErr resultCode );
void	FailNilResource( Handle resource );
Boolean	FileExists( Str255 fName, short vRefNum );
Boolean	CreateFile( SFReply *sfInfo, Str255 prompt,
						 Str255 suggestion, OSType creator, OSType fileType );
void	ScaleWindow( WindowPtr window, Boolean scaleSize );
void	DrawClippedGrow( short x, short y );
void	PlaySound( MenuHandle soundsMenu, short itemNr );


	/* The following routines implement a linked list of Items.		*/
	/* These routines expect that the first field of every item		*/
	/* is a pointer (Handle ) to the next item. They make no		*/
	/* assumptions about the remainder of each item.				*/

typedef struct LinkedItemRec
{
	struct LinkedItemRec	**next;
} LinkedItemRec, *LinkedItemPtr, **LinkedItem;

void	LinkLast( Handle *listHead, Handle newItem );
Handle	GetNth( Handle listHead, short num );
Handle	UnlinkNth( Handle *listHead, short num );
