
#define SendMessage(w,x,y,z)



	// This module implements the functions
	// in the Send menu which require dialogs.


#include <Types.h>
#include <Quickdraw.h>
#include <ctype.h>

#include "gator.h"
#include "adhoc.h"
#include "send.h"
#include <float.h>
#ifdef DEBUG_FRACT
#include <stdio.h>
#endif

#pragma segment send

#ifdef MACINTOSH
#include <dos.h>			// mj
	LPBYTE	_fstrpbrk( LPBYTE, char* );
	LPBYTE	_fstrchr(  LPBYTE, char );
#endif MACINTOSH


	INIT_ASSERT

	extern char	OutStr[ OUTSTRLEN ];		// One global OutStr!
	extern HCURSOR hSaveCursor;
	extern HCURSOR hHourGlass;

		// These are uneditable input values:
	extern HDBC  hdbc;
	extern UWORD idbc;
	extern HSTMT hstmt;
	extern UWORD istmt;

		// These values are init at launch, then remembered between <func> calls:
//	extern DDAINFO FAR * lpddainfo;

		   UWORD  fOption          = SQL_CLOSE;
//	static SWORD  ibScale          = 0;
			UWORD	ipar				= 1;
//	static UDWORD udwValue         = 0;
	static SWORD  cbColNameMax     = MAX_CBCOLNAME;
//	static UDWORD cbColDef         = 0;
//	static SWORD  cbCursorMax      = 300;
//	static SDWORD cbSqlStrIn       = 0;
	SDWORD cbSqlStr         = 0;
//	static SDWORD cbSqlStrMax      = MAX_CBSQLSTR;
	static SDWORD cbValue_Param    = 0;
//	static SDWORD cbValue_PutData  = 0;
//	static SDWORD cbValueMax_Param = DEFAULT_BUFFER_LEN;
	SWORD  fSqlType         = SQL_CHAR;
//	static SWORD  fCType_Param     = SQL_C_CHAR;
	extern SWORD  fCType_PutData;
//	static UDWORD crow             = 1;
//	static BOOL   fNum_rgbValue    = FALSE;
	static BOOL   fNull_hstmt      = FALSE;
	BOOL   fNull_szSqlStrIn = FALSE;
	BOOL   fNull_szSqlStr   = FALSE;
//	static BOOL   fNull_pcbSqlStr  = FALSE;
	static BOOL   fNull_rgbValue   = FALSE;
//	static BOOL   fNull_prgbValue  = FALSE;
	static BOOL   fNull_pcbValue   = FALSE;
//	static BOOL   fNull_szCursor   = FALSE;
//	static BOOL   fNull_pcbCursor  = FALSE;
	static BOOL   fNull_pcpar      = FALSE;
	static BOOL   fNull_szColName  = FALSE;
	static BOOL   fNull_pcbColName = FALSE;
	static BOOL   fNull_pfSqlType  = FALSE;
	static BOOL   fNull_pcbColDef  = FALSE;
	static BOOL   fNull_pibScale   = FALSE;
	static BOOL   fNull_pfNullable = FALSE;
//	static BOOL   fNull_pirow      = FALSE;

		// These values are needed only between <func> and <func>Dlg:
	BOOL	fNew_lszFromInput;
//	static BOOL fNew_lplrgbValue;
	static BOOL fNew_lpfSqlType;
	static BOOL fNew_lpcbColDef;
	static BOOL fNew_lpibScale;
	static BOOL fNew_lpfNullable;

	SDWORD	cbDefault;
//	static SDWORD cbValueMax_PutData;
	LPBYTE lszFromInput;
//	static HPVOID hrgbValue;

		// These short term variables are shared between modules:
	BOOL fChangedByApp = FALSE;

		// Constants in storage:
	extern UDWORD udwUNTOUCHED;

#define bUNTOUCHED(ib) \
			((BYTE *)&udwUNTOUCHED)[ (UWORD)(ib) & (sizeof( udwUNTOUCHED ) - 1) ]


	static BYTE CSCONST szNullString[]    = "";
	static BYTE CSCONST szEqual[]         = " = ";
	static BYTE CSCONST szColon[]         = ": ";
	static BYTE CSCONST sz_Error[]        = "***Error*** ";
	static BYTE CSCONST szSel_untouched[] = "<untouched>";
	static BYTE CSCONST sz_untouched[]    = "untouched";
	static BYTE CSCONST sz_Error_input[]  = "Error in input";
	static BYTE CSCONST sz_from_async[]   = "from pending async";
	static BYTE CSCONST sz_from_input[]   = "from input window";
	
	static BYTE CSCONST sz_ipar[]      = "ipar";
	static BYTE CSCONST sz_rgbValue[]  = "rgbValue";
	static BYTE CSCONST sz_apcbValue[] = "*pcbValue";

	static BYTE CSCONST sz_FALSE[] = "FALSE";
	static BYTE CSCONST sz_TRUE[]  = "TRUE";

		// Boolean values (works, since "SWORD" and "BOOL" are both really "int"):
	static FNAM CSCONST rgfnam_BOOL[] =
		{
			{ FALSE,	sz_FALSE	},
			{ TRUE,		sz_TRUE		}
		};
	DeclareFinfo( BOOL, "", FINFO_SWORD, GLOBAL );

	static pascal VOID GetLszFromInput( BOOL fNull );
	static pascal BOOL FAFractToBillionths( LPBYTE lszFract, UDWORD *lpbillionths );


	static FNAM CSCONST rgfnam_fOption[] =
	{
		{ SQL_CLOSE,		sz_SQL_CLOSE		},
		{ SQL_DROP,			sz_SQL_DROP			},
		{ SQL_UNBIND,		sz_SQL_UNBIND		},
		{ SQL_RESET_PARAMS,	sz_SQL_RESET_PARAMS	}
	};
	DeclareFinfo( fOption, "SQL_", FINFO_UWORD, static );


pascal VOID NumParams( HWND )
{
	NumRefs( TRUE, &fNull_pcpar );
	return;
}


pascal VOID DisplayParamData( RETCODE retcode, PTR *lplrgbValue )
{
	static BYTE CSCONST sz_aprgbValue[]   = "*prgbValue";
	static BYTE CSCONST sz_pcbValue[]     = "pcbValue";
	static BYTE CSCONST szFormat[]        = "0x%08lX = %lu";
	static BYTE CSCONST sz_also[]         = " also";
	static BYTE CSCONST sz_argument[]     = " argument";
	static BYTE CSCONST sz_cb_wrong[]     = "*pcbValue != SQL_DATA_AT_EXEC";
	static BYTE CSCONST sz_for[]          = " for ";
	static BYTE CSCONST sz_this_par[]     = "this parameter!";
	static BYTE CSCONST sz_no_parameter[] = "no parameter!";
	static BYTE CSCONST sz_null_passed[]  =
							"A null pointer was passed to SQLSetParam for the ";
	BOOL		fGotOne;
	PTR			lrgbValue;
	LPBOUND		*lplpbound = LplpboundFirstFromHstmt( hstmt );
	LPBOUND		lpbound;


	EchoRetcode( sz_SQLParamData, retcode );

	if( retcode == SQL_STILL_EXECUTING || lplrgbValue == NULL ||
		!FCheckArg( sz_aprgbValue,
			(lrgbValue = *lplrgbValue) == (PTR)(UDWORD)UNTOUCHED,
			retcode != SQL_NEED_DATA, TRUE ) )
		return;

	wsprintf( OutStr, szFormat, (UDWORD)lrgbValue, (UDWORD)lrgbValue);
	szWrite( OutStr, FALSE );
	szWrite( szEqual, FALSE );
	szWrite( sz_rgbValue, FALSE );
	szWrite( sz_for, FALSE );

	fGotOne = FALSE;
	if( lplpbound )
		for( lpbound = *lplpbound; lpbound; lpbound = lpbound->par.lpboundNext )
		{
			if( !lpbound->par.fParam
			 || (lpbound->par.fNum_rgb
			 	? lpbound->par.udwValue != (UDWORD)lrgbValue
				: lpbound->par.rgbValue != lrgbValue) )
				continue;

			if( fGotOne )
			{
				szWrite( sz_aprgbValue,	FALSE );
				szWrite( sz_also,		FALSE );
				szWrite( szEqual,		FALSE );
				szWrite( sz_rgbValue,	FALSE );
				szWrite( sz_for,		FALSE );
			}
			szWrite( sz_ipar, FALSE );
			szWrite( szEqual, FALSE );
			ltoa( lpbound->par.ipar, OutStr, 10 );
			szWrite( OutStr, FALSE );
			szWrite( ".", TRUE );

			fCType_PutData = FCTypeFromFCTypeFSqlType(	lpbound->par.fCType,
														lpbound->par.fSqlType );
			if( lpbound->par.fNull_pcb
			 || lpbound->par.cbValue != SQL_DATA_AT_EXEC )
			{
				szWrite( sz_Error, FALSE );
				if( lpbound->par.fNull_pcb )
				{
					szWrite( sz_null_passed, FALSE );
					szWrite( sz_pcbValue, FALSE );
					szWrite( sz_argument, FALSE );
				}
				else
					szWrite( sz_cb_wrong, FALSE );

				szWrite( sz_for, FALSE );
				szWrite( sz_this_par, TRUE );
			}
			fGotOne = TRUE;
		}
	if( !fGotOne )
		szWrite( sz_no_parameter, TRUE );
	return;
}/* end DisplayParamData */


static pascal VOID GetLszFromInput( BOOL fNull )
{
	HANDLE			hasz = NULL;

	extern HWND		hwndTop;

	if( !fNull )
		cbDefault = GetString( hwndTop, &hasz );

	if( hasz == NULL )
	{
		lszFromInput	= NULL;
		cbDefault		= 0;
	}
	else
	{
		lszFromInput = LockMemory( hasz );
		VAssert( lszFromInput );
	}
	return;
}/* end GetLszFromInput */


pascal SDWORD CbFromAToValue(	LPBYTE lszIn, SWORD fCType, HPVOID hrgbValue,
								SDWORD cbValueMax )
{
	static BYTE CSCONST szSepList[]  = " ,;";
	static BYTE CSCONST szSignList[] = "+-";
	static BYTE CSCONST szDigList[]  = "0123456789";
	static BYTE CSCONST szExpList[]  = "DdEe";
	static BYTE CSCONST szFracSeps[] = ".:";
	static BYTE CSCONST szInfinity[] = "1.#inf";

	static double CSCONST dbl_FLT_MAX = FLT_MAX;

	static BYTE szDblTooBig[] = "-1e99999";

	BOOL		fUntouch;
	LPBYTE		lpch;
	LPBYTE		lpchMic;
	LPBYTE		lpch1;
	LPBYTE		lpch2;
	LPBYTE		lpchMac;
	LPBYTE		lpchMax;
	LPBYTE		lpbOut = hrgbValue;
	UWORD		cbData;
	SDWORD		cbValue = -1;	// Flag cbValue unset
	SDWORD		ib = 0;
	double		dblTemp;
	BYTE		rgb[ sizeof( TIMESTAMP_STRUCT ) ];

	if( fCType == SQL_C_CHAR )
	{
		cbValue = lstrlen( lszIn );
		ib = cbValue + 1;
		if( ib > cbValueMax)
			cbValue = ib = cbValueMax;

		_fmemcpy(lpbOut, lszIn, (UWORD)ib );
		lpbOut += (UWORD)ib;
		goto GotValue;
	}
	lpchMic	= &lszIn[0];
	cbData	= CbFromFCType( fCType );
	lpchMax	= &lszIn[ lstrlen( lszIn ) ];
	do
	{
		if( *lpchMic == '"' )
		{
			UWORD	cb;

			lpchMac = _fstrchr( ++lpchMic, '"' );
			if( (SEGMENT)lpchMac == NULL )
				goto IllegalValue;

			cb = lpchMac - lpchMic;
			if( (SDWORD)cb > cbValueMax )
				cb = (UWORD)cbValueMax;

			_fmemcpy( lpbOut, lpchMic, cb );
			lpbOut += cb;
			ib += cb;

			if( ++lpchMac < lpchMax &&
				(SEGMENT)_fstrchr( szSepList, *lpchMac) == NULL )
				goto IllegalValue;

			goto NextTerm;		// lpchMac -> 1st ch of sep
		}
		if( (SEGMENT)(lpch = _fstrpbrk( lpchMic, szSepList )) != NULL )
		{
			lpchMac	= lpch;
			*lpchMac	= '\0';
		}
		else
			lpchMac = lpchMax;		// lpchMac -> 1st ch of sep

		if( ib > 0 )
			goto ConvertInt;

		switch( fCType )
		{
			BOOL	fLeadingZero;	// Check floating point number syntax:
			int		cchSep;
			int		cchExp;

		case SQL_C_FLOAT:
		case SQL_C_DOUBLE:
			if( (cchSep = _fstrspn( lpchMic, szSignList )) > 1 )
				goto IllegalValue;

			lpch1 = lpchMic + cchSep;
			if( _fstricmp( lpch1, szInfinity) == 0 )
			{
				lstrcpy( OutStr, &szDblTooBig[*lpchMic != '-'] );
				break;
				}
			fLeadingZero = *lpch1 == '0';
			lpch1 += cchSep = _fstrspn(lpch1, szDigList);
			if( fLeadingZero && cchSep > 1 && lpch1 == lpchMac)
				goto ConvertInt;		// Treat as octal.

			if( *lpch1 == '.')
				{
				lpch1++;
				lpch1 += _fstrspn(lpch1, szDigList);
				}
			if( (cchExp = _fstrspn(lpch1, szExpList)) > 1 ||
				(cchSep = _fstrspn(lpch1 += cchExp, szSignList)) > cchExp)
				goto IllegalValue;

			lpch1 += cchSep;
			if( cchExp > 0)
				lpch1 += _fstrspn(lpch1, szDigList);

			if( lpch1 != lpchMac)
				goto ConvertInt;		// Not float; might be hex.

			lstrcpy( OutStr, lpchMic);	// Copy to near buf.
			break;
			}
		fUntouch = FALSE;
		switch( fCType )
		{
		case SQL_C_FLOAT:
			dblTemp = atof( OutStr );
			if( dblTemp < -dbl_FLT_MAX || dblTemp > dbl_FLT_MAX )
				dblTemp = atof( &szDblTooBig[ dblTemp >= 0 ] );

			*(SFLOAT *)rgb = (SFLOAT)dblTemp;
			break;

		case SQL_C_DOUBLE:
			*(SDOUBLE *)rgb = atof( OutStr );
			break;

		case SQL_C_DATE:
			if( (SEGMENT)(lpch1 = _fstrchr( lpchMic + 1, '-' ) ) == NULL )
				goto ConvertInt;

			*lpch1++ = '\0';

			if( (SEGMENT)(lpch2 = _fstrchr( lpch1, '-' ) ) == NULL )
				goto IllegalValue;

			*lpch2++ = '\0';

				// Allow one leading zero with a single decimal digit.
				//
			if( lpch1 - lpchMic == 2 + 1 && *lpchMic == '0' )
				lpchMic++;

			else if( lpch1 - lpchMic == 1 + 2 + 1 && *lpchMic == '-' &&
			         *(lpchMic + 1) == '0' )
				*++lpchMic = '-';

			if( lpch2 - lpch1 == 2 + 1 && *lpch1 == '0' )
				lpch1++;

			if( lpchMac - lpch2 == 2 && *lpch2 == '0')
				lpch2++;

			if( !FAToSWord(lpchMic, &((DATE_STRUCT *)rgb)->year) ||
				!FAToUWord(lpch1,   &((DATE_STRUCT *)rgb)->month) ||
				!FAToUWord(lpch2,   &((DATE_STRUCT *)rgb)->day))
				goto IllegalValue;

			break;

		case SQL_C_TIME:
			if( (SEGMENT)(lpch1 = _fstrchr(lpchMic + 1, ':')) == NULL )
				goto ConvertInt;

			*lpch1++ = '\0';

			// Allow h:m[:s]
			//
			((TIME_STRUCT *)rgb)->second = 0;
			if( (SEGMENT)(lpch2 = _fstrchr(lpch1, ':')) == NULL )
				lpch2 = lpchMac + 1;
			else
				{
				*lpch2++ = '\0';

				// Allow one leading zero with a single decimal digit.
				//
				if( lpchMac - lpch2 == 2 && *lpch2 == '0')
					lpch2++;

				if( !FAToUWord(lpch2, &((TIME_STRUCT *)rgb)->second))
					goto IllegalValue;
				}

			// Allow one leading zero with a single decimal digit.
			//
			if( lpch1 - lpchMic == 2 + 1 && *lpchMic == '0')
				lpchMic++;

			if( lpch2 - lpch1 == 2 + 1 && *lpch1 == '0')
				lpch1++;

			if( !FAToUWord(lpchMic, &((TIME_STRUCT *)rgb)->hour) ||
				!FAToUWord(lpch1,   &((TIME_STRUCT *)rgb)->minute))
				goto IllegalValue;

			break;

		case SQL_C_TIMESTAMP:
			if( (SEGMENT)(lpch1 = _fstrchr(lpchMic + 1, '-')) == NULL )
				goto ConvertInt;

			*lpch1++ = '\0';

			if( (SEGMENT)(lpch2 = _fstrchr(lpch1, '-')) == NULL )
				goto IllegalValue;

			*lpch2++ = '\0';

			// Allow one leading zero with a single decimal digit.
			//
			if( lpch1 - lpchMic == 2 + 1 && *lpchMic == '0')
				lpchMic++;

			else if( lpch1 - lpchMic == 1 + 2 + 1 && *lpchMic == '-' &&
				*(lpchMic + 1) == '0')
				*++lpchMic = '-';

			if( lpch2 - lpch1 == 2 + 1 && *lpch1 == '0')
				lpch1++;

			if( lpchMac - lpch2 == 2 && *lpch2 == '0')
				lpch2++;

			if( !FAToSWord(lpchMic, &((TIMESTAMP_STRUCT *)rgb)->year) ||
				!FAToUWord(lpch1,   &((TIMESTAMP_STRUCT *)rgb)->month) ||
				!FAToUWord(lpch2,   &((TIMESTAMP_STRUCT *)rgb)->day))
				goto IllegalValue;

			// Allow y-m-d[ h:m[:s[.f]]]
			//
			((TIMESTAMP_STRUCT *)rgb)->hour     = 0;
			((TIMESTAMP_STRUCT *)rgb)->minute   = 0;
			((TIMESTAMP_STRUCT *)rgb)->second   = 0;
			((TIMESTAMP_STRUCT *)rgb)->fraction = 0;

			if( lpchMac == lpchMax)
				break;

			for( lpch2 = lpchMac; *++lpch2 == ' ';)
				;

			if( (SEGMENT)(lpch1 = _fstrchr(lpch2 + 1, ':')) == NULL )
				break;

			lpchMic = lpch2;
			if( (SEGMENT)(lpchMac = _fstrpbrk(lpchMic, szSepList)) == NULL )
				lpchMac = lpchMax;
			else
				*lpchMac = '\0';		// lpchMac -> 1st ch of sep

			*lpch1++ = '\0';

			if( (SEGMENT)(lpch2 = _fstrchr(lpch1, ':')) == NULL )
				lpch2 = lpchMac + 1;
			else
				*lpch2++ = '\0';

			// Allow one leading zero with a single decimal digit.
			//
			if( lpch1 - lpchMic == 2 + 1 && *lpchMic == '0')
				lpchMic++;

			if( lpch2 - lpch1 == 2 + 1 && *lpch1 == '0')
				lpch1++;

			if( !FAToUWord(lpchMic, &((TIMESTAMP_STRUCT *)rgb)->hour) ||
				!FAToUWord(lpch1,   &((TIMESTAMP_STRUCT *)rgb)->minute))
				goto IllegalValue;

			if( lpch2 == lpchMac + 1)
				break;

			if( (SEGMENT)(lpch1 = _fstrpbrk(lpch2, szFracSeps)) == NULL )
				lpch1 = lpchMac + 1;

			else if( *lpch1 == ':')
				{
				*lpch1++ = '\0';

				if( !FAToUDWord(lpch1,
						&((TIMESTAMP_STRUCT *)rgb)->fraction))
					goto IllegalValue;
				}
			else
				{
				*lpch1++ = '\0';

				if( !FAFractToBillionths(lpch1,
						&((TIMESTAMP_STRUCT *)rgb)->fraction))
					goto IllegalValue;
				}

			// Allow one leading zero with a single decimal digit.
			//
			if( lpch1 - lpch2 == 2 + 1 && *lpch2 == '0')
				lpch2++;

			if( !FAToUWord(lpch2, &((TIMESTAMP_STRUCT *)rgb)->second))
				goto IllegalValue;

			break;

		case SQL_C_BIT:
			{
			int ch = *lpchMic;

			switch( isupper(ch) ? _tolower(ch) : ch)
				{
			case 'n':
			case 'f':
				rgb[0] = (BYTE)0;
				break;

			case 'y':
			case 't':
				rgb[0] = (BYTE)1;
				break;

			default:
				goto ConvertCommon;
				}
			}
			break;

//		case SQL_C_LONG:
//		case SQL_C_SHORT:
//		case SQL_C_BINARY:
//		case SQL_C_TINYINT:
		default:
			goto ConvertCommon;

ConvertInt:
			cbData = 0;
ConvertCommon:
			if( (SEGMENT)(lpch1 = _fstrchr( lpchMic, '(') ) != NULL )
				{
				*lpch1++ = '\0';
				if( (SEGMENT)(lpch2 = _fstrchr(lpch1, ')')) == NULL ||
					lpch2 + 1 != lpchMac )
					goto IllegalValue;

				*lpch2 = '\0';
				if( !FAToUWord( lpch1, &cbData ) || cbData == 0 )
					goto IllegalValue;
				}
			if( *lpchMic == '\0' )
				goto IllegalValue;

			fUntouch = _fstrstr( sz_untouched, lpchMic ) != NULL;
			if( fUntouch )
				break;

				// Get int value and compute its cbData:
			{
			static BYTE CSCONST sz_xX[]		= "xX";
			static BYTE CSCONST sz_oO[]		= "oO";

			BOOL	fNeg = *lpchMic == '-';
			BYTE	*pb = &rgb[ sizeof( UDWORD ) ];
			UWORD	cbByCch = 0;
			UWORD	cbByValue;
			UDWORD	udw;

			if( cbData > sizeof( SDWORD ) ||
				!FAToUDWord(lpchMic + (fNeg ? 1 : 0), &udw) ||
				fNeg && udw > 0x80000000 )
				goto IllegalValue;

			*(UDWORD*)rgb = fNeg ? (udw - 1) << 1 : udw;
			rgb[0] = 1;
			while( *--pb == 0x00 )
				;
			cbByValue = pb - &rgb[0] + 1;

			lpch = _fstrpbrk( lpchMic, sz_xX );
			if( lpch )
				cbByCch = lstrlen(lpch) / 2;

			else if( (lpch = _fstrpbrk( lpchMic, sz_oO )) != NULL ||
				*(lpch = _fstrpbrk( lpchMic, szDigList )) == '0' )
				cbByCch = ((lstrlen( lpch ) - 1 ) * 3 - 2 + 7) / 8;

			if( lpch1 )
			{
				if( cbByCch > cbData || cbByValue > cbData )
					goto IllegalValue;
			}
			else if( cbByCch )
			{
				if( cbByCch > sizeof( SDWORD ) )
					goto IllegalValue;

				cbData = max(cbByCch, cbByValue);
			}
			else if( cbData == 0)
				cbData = cbByValue <= sizeof( SWORD) ?
					sizeof( SWORD) : sizeof( SDWORD);

			else if( cbByValue > cbData)
				goto IllegalValue;

			*(SDWORD *)rgb = fNeg ? -(SDWORD)udw : (SDWORD)udw;
			}
			break;
		}
		if( ib + cbData > cbValueMax)
			cbData = (UWORD)(cbValueMax - ib);

		if( fUntouch)
			{
			if( cbValue < 0)	// The untouched term doesn't count.
				cbValue = 0;

			if( lpchMac == lpchMax)
				goto GotValue;

			if( cbData == 0)
				{
IllegalValue:
				cbValue = -1;	// Flag illegal value
				goto Done;
				}
			while (cbData-- > 0)
				*lpbOut++ = bUNTOUCHED(ib++);
			}
		else
			{
			BYTE * pb;

			for( pb = &rgb[0]; cbData-- > 0; ib++ )
				*lpbOut++ = *pb++;

			if( fCType == SQL_C_BINARY )
				cbValue = ib;	// Except for SQL_C_BINARY, ...
NextTerm:
			if( cbValue < 0)	// ...only the first term counts.
				cbValue = ib;
			}
		if( (lpchMic = lpchMac + 1) >= lpchMax )
			break;

		for( ; *lpchMic == ' '; lpchMic++)
			;

		} while (ib < cbValueMax && lpchMic < lpchMax );
GotValue:
	Untouch( lpbOut, cbValueMax - ib );

#ifdef DEBUG
	if( cbValueMax == 0 )
		strcpy( OutStr, "rgbValue is null." );
	else
	{
		WORD	*lpw = hrgbValue;

		strcpy( OutStr, "rgbValue = ");
		pch = &OutStr[strlen( OutStr )];
		for( ib = 0; ib < cbValueMax - 2; ib += 2 )
		{
			wsprintf( pch, "x%04X ", *lpw++ );

			if( (pch += 6) <= &OutStr[ OUTSTRLEN - 6 ] )
				continue;

			MessageBox( hdlg, OutStr, "Debug Info", MB_OK );
			strcpy( OutStr, "rgbValue (cont'd) = 0x" );
			pch = &OutStr[ strlen( OutStr ) ];
		}
		if( cbValueMax & 1 )
			wsprintf( pch, "x%02X.", *(LPBYTE)lpw );
		else
			wsprintf( pch, "x%04X.", *lpw );
	}
	MessageBox( hdlg, OutStr, "Debug Info", MB_OK );
#endif // DEBUG
Done:
	return cbValue;
}


static pascal BOOL FAFractToBillionths( LPBYTE lszFract, UDWORD *lpbillionths )
{
	int ch;
	UDWORD billionths = 0;
	UDWORD billionthsPlaceValue = 1000000000;

	while( (ch = *lszFract++) != '\0' )
	{
		if( !isdigit(ch))
			return FALSE;

		billionths += (billionthsPlaceValue /= 10) * (ch - '0');
	}
	*lpbillionths = billionths;
	return TRUE;
}


static pascal VOID ValueDisplayCommon( TSD *ptsd, SWORD fCType,
										HPBYTE hrgbValue, SDWORD cbValueMax );

static pascal VOID AFromBillionths( BYTE * sz, UDWORD billionths );


pascal VOID DisplayValue(	HWND hwnd,
							SWORD fCType, HPBYTE hrgbValue, SDWORD cbValueMax )
{
	TSD		tsd;

		// hwnd == NULL means use szWrite.

	if( hwnd )
	{
		SendMessage( hwnd, WM_SETREDRAW, FALSE, 0 );
		SendMessage( hwnd, EM_SETSEL, 0, MAKELPARAM(0, -1));
	}
	tsd.lsz			= NULL;
	tsd.hwnd		= hwnd;
	tsd.cbOutMax	= 0x8000;
	ValueDisplayCommon( &tsd, fCType, hrgbValue, cbValueMax );
	if( hwnd)
	{
		SendMessage( hwnd, EM_SETSEL, 0, MAKELPARAM(0, 0) );
		SendMessage( hwnd, WM_SETREDRAW, TRUE, 0 );
	//	InvalidateRect(hwnd, NULL, TRUE );
	}
}


	// GetValueDisplay - copy the display of a value to a buffer.

pascal VOID GetValueDisplay( TSD *ptsd,
								SWORD fCType, HPBYTE hrgbValue, SDWORD cbTouched )
{
	static BYTE CSCONST sz_NULL[]                    = "NULL";
	static BYTE CSCONST szBeginEmbeddedInitializer[] = "&{";
	static BYTE CSCONST szEndEmbeddedInitializer[]   = "}";

	if( hrgbValue == NULL )
		TakeStringDisplay( ptsd, sz_NULL );
	else
	{
		if( fCType != SQL_C_CHAR )
			TakeStringDisplay( ptsd, szBeginEmbeddedInitializer);

		ValueDisplayCommon( ptsd, fCType, hrgbValue, cbTouched);
		if( fCType != SQL_C_CHAR)
			TakeStringDisplay( ptsd, szEndEmbeddedInitializer);
	}
}/* end GetValueDisplay */


static pascal VOID ValueDisplayCommon(	TSD *ptsd,			SWORD fCType,
										HPBYTE hrgbValue,	SDWORD cbValueMax )
{
	static BYTE CSCONST szDateFormat[] = "%d-%02u-%02u";
	static BYTE CSCONST szTimeFormat[] = "%02u:%02u:%02u";

	static BYTE CSCONST szTimeStampFormat[] = "%d-%02u-%02u %02u:%02u:%02u";

	SDWORD		cbTouched;
	SDWORD		cbExpect;
	HPBYTE		hpb;
	BOOL		fInputBox = ptsd->lsz == NULL
										? ptsd->hwnd != NULL : ptsd->hasz != NULL;

	cbTouched = CbTouchedRgbCbMax( hrgbValue, cbValueMax );
	if( cbTouched == 0 )
	{
		TakeStringDisplay( ptsd,
							LszIfSz(	fInputBox,
										LszIfSz(	fCType == SQL_C_CHAR,
													szSel_untouched, szNullString ),
										sz_untouched ) );
		return;
	}
	if( fCType == SQL_C_CHAR )
	{
		StringDisplayCommon( ptsd, hrgbValue, cbTouched,
								fInputBox
								 ? INPUT_STRING
								 : INPUT_STRING | IN_QUOTES | BLANK_WHITESPACE );
		return;
	}
	if( (cbExpect = CbFromFCType( fCType )) == 0 || cbExpect > cbTouched )
	{
		cbExpect = 0;
		goto AppendHex;
	}
	switch( fCType )
	{
	case SQL_C_LONG:
		ltoa( *(SDWORD HUGE *)hrgbValue, OutStr, 10 );
		break;

	case SQL_C_SHORT:
	//	itoa(*(SWORD HUGE *)hrgbValue, OutStr, 10 );
		break;

	case SQL_C_FLOAT:
	//	gcvt( *(SFLOAT HUGE *)hrgbValue, FLT_DIG + 1, OutStr );
	//	strupr( OutStr );
		break;

	case SQL_C_DOUBLE:
	//	gcvt( *(SDOUBLE HUGE *)hrgbValue, DBL_DIG + 1, OutStr );
	//	strupr( OutStr );
		break;

	case SQL_C_DATE:
		wsprintf( OutStr, szDateFormat,
			((DATE_STRUCT HUGE *)hrgbValue)->year,
			((DATE_STRUCT HUGE *)hrgbValue)->month,
			((DATE_STRUCT HUGE *)hrgbValue)->day );
		break;

	case SQL_C_TIME:
		wsprintf( OutStr, szTimeFormat,
			((TIME_STRUCT HUGE *)hrgbValue)->hour,
			((TIME_STRUCT HUGE *)hrgbValue)->minute,
			((TIME_STRUCT HUGE *)hrgbValue)->second );
		break;

	case SQL_C_TIMESTAMP:
		wsprintf( OutStr, szTimeStampFormat,
			((TIMESTAMP_STRUCT HUGE *)hrgbValue)->year,
			((TIMESTAMP_STRUCT HUGE *)hrgbValue)->month,
			((TIMESTAMP_STRUCT HUGE *)hrgbValue)->day,
			((TIMESTAMP_STRUCT HUGE *)hrgbValue)->hour,
			((TIMESTAMP_STRUCT HUGE *)hrgbValue)->minute,
			((TIMESTAMP_STRUCT HUGE *)hrgbValue)->second);
		TakeStringDisplay( ptsd, OutStr );
		AFromBillionths( OutStr, ((TIMESTAMP_STRUCT HUGE *)hrgbValue)->fraction);
		break;

	case SQL_C_BINARY:
		goto AppendHex;

	case SQL_C_TINYINT:
	//	itoa( *(SCHAR HUGE *)hrgbValue, OutStr, 10 );
		break;

	case SQL_C_BIT:
		if( *(HPBYTE)hrgbValue > 1 )
			/*itoa( *(HPBYTE)hrgbValue, OutStr, 10 )*/;
		else
			lstrcpy(	OutStr,
						LszNameFromFlagArg( &finfo_BOOL, *(HPBYTE)hrgbValue ) );
		break;
	}
	TakeStringDisplay( ptsd, OutStr );
	if( cbExpect < cbTouched )
	{
		static BYTE CSCONST szRepeatedFormat[] = "x%02X ";
		static BYTE CSCONST szByteFormat[]     = "x%02X";

		TakeStringDisplay( ptsd, " " );
AppendHex:
		for( hpb = &hrgbValue[ cbExpect ]; cbExpect < cbTouched - 1;
			 cbExpect++)
		{
			wsprintf( OutStr, szRepeatedFormat, *hpb++ );
			TakeStringDisplay( ptsd, OutStr );
		}
		wsprintf( OutStr, szByteFormat, *hpb );
		TakeStringDisplay( ptsd, OutStr );
	}
	if( cbTouched < cbValueMax )
	{
		TakeStringDisplay( ptsd, " " );
		TakeStringDisplay( ptsd, sz_untouched );
		TakeStringDisplay( ptsd, "( " );
		ultoa(cbValueMax - cbTouched, OutStr, 10 );
		TakeStringDisplay( ptsd, OutStr );
		TakeStringDisplay( ptsd, ")" );
	}
}


static pascal VOID AFromBillionths( BYTE * sz, UDWORD billionths )
{
	static BYTE CSCONST szFormat[] = ":%09lu";

	wsprintf( sz, szFormat, billionths );

	if( billionths <= 999999999 )	// Can be a fraction.
	{
		BYTE * pch = &sz[ 10 ];

		while( *--pch == '0' )		// Get rid of trailing zeros.
			;

		if( *pch == ':' )	 		// Leave at least one digit of fraction.
			pch++;

		*++pch = '\0';
		sz[0] = '.';	 			// Flag that value is a fraction.
	}
	return;
}


pascal BYTE * SzConstDisplay( LPBYTE lszName, SDWORD sdwValue )
{
	BYTE	*pch = OutStr;

	if( (WORD)(DWORD)lszName )
	{
		lstrcpy( pch, lszName );
		lstrcpy( pch += strlen( pch ), szEqual );
		pch += 3;
	}
	ltoa( sdwValue, pch, 10 );
	return OutStr;
}/* end SzConstDisplay */


pascal SWORD FCTypeFromFCTypeFSqlType( SWORD fCType, SWORD fSqlType )
{
	typedef struct
	{
		SWORD fSqlType;
		SWORD fCType;
	} TYPTBL;

	static TYPTBL CSCONST rgtyptbl[] =
	{
			{SQL_CHAR,			SQL_C_CHAR},
			{SQL_NUMERIC,		SQL_C_CHAR},
			{SQL_DECIMAL,		SQL_C_CHAR},
			{SQL_INTEGER,		SQL_C_LONG},
			{SQL_SMALLINT,		SQL_C_SHORT},
			{SQL_FLOAT,			SQL_C_DOUBLE},
			{SQL_REAL,			SQL_C_FLOAT},
			{SQL_DOUBLE,		SQL_C_DOUBLE},
			{SQL_DATE,			SQL_C_DATE},
			{SQL_TIME,			SQL_C_TIME},
			{SQL_TIMESTAMP,		SQL_C_TIMESTAMP},
			{SQL_VARCHAR,		SQL_C_CHAR},
			{SQL_LONGVARCHAR,	SQL_C_CHAR},
			{SQL_BINARY,		SQL_C_BINARY},
			{SQL_VARBINARY,		SQL_C_BINARY},
			{SQL_LONGVARBINARY,	SQL_C_BINARY},
			{SQL_BIGINT,		SQL_C_CHAR},
			{SQL_TINYINT,		SQL_C_TINYINT},
			{SQL_BIT,			SQL_C_BIT},
	};
	TYPTBL CSCONST * ptyptbl;

	if( fCType != SQL_C_DEFAULT )
		return fCType;

	for( ptyptbl = &rgtyptbl[0]; ptyptbl < PmaxFromRg( rgtyptbl ); ptyptbl++ )
		if( ptyptbl->fSqlType == fSqlType )
			return ptyptbl->fCType;

	return SQL_C_BINARY;
}


pascal UWORD CbFromFCType( SWORD fCType )
{
	typedef struct
	{
		SWORD fCType;
		UWORD cb;
	} CTINFO;

	static CTINFO CSCONST rgctinfo[] =
	{
			{SQL_C_CHAR,      0},	// Variable length
			{SQL_C_LONG,      sizeof( SDWORD)},
			{SQL_C_SHORT,     sizeof( SWORD)},
			{SQL_C_FLOAT,     sizeof( SFLOAT)},
			{SQL_C_DOUBLE,    sizeof( SDOUBLE)},
			{SQL_C_DATE,      sizeof( DATE_STRUCT)},
			{SQL_C_TIME,      sizeof( TIME_STRUCT)},
			{SQL_C_TIMESTAMP, sizeof( TIMESTAMP_STRUCT)},
			{SQL_C_BINARY,    0},	// Variable length
			{SQL_C_TINYINT,   sizeof( SCHAR)},
			{SQL_C_BIT,       sizeof( UCHAR)}
	};
	CTINFO CSCONST * pctinfo;

	for( pctinfo = &rgctinfo[0]; pctinfo < PmaxFromRg( rgctinfo ); pctinfo++ )
		if( fCType == pctinfo->fCType )
			return pctinfo->cb;

	return 0;
}
