/* Cursors.h */

extern RgnHandle		cursorRgn;
extern CursHandle		watch;

/*----------*/
void LoadCursors		(void);
void ShapeCursor		(void);
/* The following routines implement a simple spinning cursor mechanism.					*/
/* First, set up your application's resource file with the appropriate resources.		*/
/* Your code should then call this unit as follows:										*/
/*		StartBusyCursor (aCurID);														*/
/*		...time-intensive code...	<= contains frequent calls to SpinCursor			*/
/*										and/or SpinBackwards							*/
/*		StopBusyCursor ();																*/
/*																						*/
/* Note: StartBusyCursor/StopBusyCursor are not currently designed to be nestable,		*/
/* that is, "time-intensive code" above should not contain any calls to StartBusyCursor	*/
/* or StopBusyCursor.																	*/
void StartBusyCursor	(short		aCurID);
void SpinCursor			(void);
void SpinBackwards		(void);
void StopBusyCursor		(void);

