

	/* Created 3/12/93 5:01 PM by AppMaker */

#include <Types.h>
#include <Quickdraw.h>
#include <Controls.h>
#include <Dialogs.h>
#include <Events.h>
#include <Lists.h>
#include <Menus.h>
#include <TextEdit.h>
#include <Desk.h>
#include <Packages.h>
#include <ToolUtils.h>
#include <Strings.h>

#include "ResourceDefs.h"
#include "DoScrap.h"
#include "Globals.h"
#include "getSQLdialogs.h"
#include "doMenuItems.h"

#include "Dispatcher.h"
#include "ODBCappData.h"
#include "Miscellany.h"
#include "DialogAids.h"
#include "Windowing.h"

#include "GATOR.H"
#include "ADHOC.H"

#define MIN_CBMAX	sizeof( TIMESTAMP_STRUCT )	// copied from receive.c
#define MIN(x,y)	( (x) <= (y) ? (x) : (y) )
#define MAX(x,y)	( (x) >= (y) ? (x) : (y) )

#pragma segment doMenuItems

		/* GLOBALS:	*/
typedef struct
{
	SQLAllocEnvRec			SQLAllocEnvInfo;
	SQLAllocConnectRec		SQLAllocConnectInfo;
	SQLColumnsRec			SQLColumnsInfo;
	SQLConnectRec			SQLConnectInfo;
	SQLBrowseConnectRec		SQLBrowseConnectInfo;
	SQLRowCountRec			SQLRowCountInfo;
	SQLDescribeColRec		SQLDescribeColInfo;
	SQLColAttributesRec		SQLColAttributesInfo;
	SQLDriverConnectRec		SQLDriverConnectInfo;
	SQLDataSourcesRec		SQLDataSourcesInfo;
	SQLTransactRec			SQLTransactInfo;
	SQLErrorRec				SQLErrorInfo;
	SQLSetConnectOptionRec	SQLSetConnectOptionInfo;
	SQLGetConnectOptionRec	SQLGetConnectOptionInfo;
	SQLNumResultColsRec		SQLNumResultColsInfo;
	SQLBindColRec			SQLBindColRecInfo;
	SQLAllocStmtRec			SQLAllocStmtInfo;
	SQLPrepareRec			SQLPrepareInfo;
	SQLSetParamRec			SQLSetParamInfo;
	SQLExecDirectRec		SQLExecDirectInfo;
	SQLSetCursorNameRec		SQLSetCursorNameInfo;
	SQLGetCursorNameRec		SQLGetCursorNameInfo;
	SQLFreeStmtRec			SQLFreeStmtInfo;
	FillParamRec			FillParamInfo;
	SQLGetStmtOptionRec		SQLGetStmtOptionInfo;
	SQLSetStmtOptionRec		SQLSetStmtOptionInfo;
	SQLParamOptionsRec		SQLParamOptionsInfo;
	SQLSetScrollOptionsRec	SQLSetScrollOptionsInfo;
	SQLGetDataRec			SQLGetDataInfo;
	SQLExtendedFetchRec		SQLExtendedFetchInfo;
	SQLTablesRec			SQLTablesInfo;
	SQLGetFunctionsRec		SQLGetFunctionsInfo;
	SQLGetInfoRec			SQLGetInfoInfo;
	SQLGetTypeInfoRec		SQLGetTypeInfoInfo;
	SQLParamDataRec			SQLParamDataInfo;
	SQLPutDataRec			SQLPutDataInfo;
	SQLSpecialColumnsRec	SQLSpecialColumnsInfo;
	SQLProceduresRec		SQLProceduresInfo;
	SQLProcedureColumnsRec	SQLProcedureColumnsInfo;
	SQLStatisticsRec		SQLStatisticsInfo;
	SQLSetPosRec			SQLSetPosInfo;
	SQLNativeSQLRec			SQLNativeSQLInfo;
	SQLPrimaryKeysRec		SQLPrimaryKeysInfo;
	SQLForeignKeysRec		SQLForeignKeysInfo;
	SQLTablePrivilegesRec	SQLTablePrivilegesInfo;
	SQLColumnPrivilegesRec	SQLColumnPrivilegesInfo;
	SQLNumParamsRec			SQLNumParamsInfo;
	SQLDescribeParamRec		SQLDescribeParamInfo;
}  GLOBALstructs;

	GLOBALstructs	**hglobs;
	UWORD			idbcMax = 0;

	long			gNum;

		/* externals:	*/

	extern windowPop	DBCpop;
	extern Str255		hdbcText;
	extern VOID			UpdateCurrentHdbc();

	extern windowPop	STMTpop;
	extern Str255		hstmtText;

	extern HENV		henv;		// handle of current environment
	extern HDBC		hdbc;		// handle of current connection
	extern UWORD	idbc;		// index  of current connection
	extern HSTMT	hstmt;		// handle of current statement
	extern UWORD	istmt;		// index  of current statement

	extern UWORD  		fOption;
	extern BOOL			fDriverMenus;
	extern SERVERINFO	*lrgserverinfo;
	extern SERVERINFO	*lpserverinfoMax;
	extern CONNINFO		*lpconninfo;		// Connection information

	extern STMTINFO		*lrgstmtinfo;
	extern STMTINFO		*lpstmtinfoMax;
	extern UWORD		istmtMax = 0;

	extern int		ifn;					// from dda.c

	extern UWORD	icol;					// from receive.c:
	extern SWORD	fCType;
	extern SDWORD	cbValueMax;
	extern UWORD	fFetchType;
//	extern SDWORD	irow;
//	UWORD	icol				= 1;
//	SWORD	fCType				= SQL_C_CHAR;
	SWORD	cbColNameMax		= MAX_CBCOLNAME;
//	SDWORD	cbValueMax			= 300;
//	UWORD	fFetchType			= SQL_FETCH_NEXT;
//	SDWORD	irow				= 1;
	BOOL	fNull_szColName		= FALSE;
	BOOL	fNull_pcbColName	= FALSE;
	BOOL	fNull_pfSqlType		= FALSE;
	BOOL	fNull_pcbColDef		= FALSE;
	BOOL	fNull_pibScale		= FALSE;
	BOOL	fNull_pfNullable	= FALSE;
	BOOL	fNull_rgbValue		= FALSE;
	BOOL	fNull_pcbValue		= FALSE;
	BOOL	fNull_pcrow			= FALSE;
	BOOL	fNull_rgfRowStatus	= FALSE;
	BOOL	fNull_pccol			= FALSE;
	UWORD	fFunction			= SQL_API_SQLALLOCCONNECT;
	BOOL	fNull_pfExists		= FALSE;

//	extern BOOL		fNull_szColName;
//	extern BOOL		fNull_pcbColName;
//	extern BOOL		fNull_pfSqlType;
//	extern BOOL		fNull_pcbColDef;
//	extern BOOL		fNull_pibScale;
//	extern BOOL		fNull_pfNullable;
	extern BOOL		fNull_rgbValue;
	extern BOOL		fNull_pcbValue;
//	extern BOOL		fNull_pcrow;
//	extern BOOL		fNull_rgfRowStatus;
//	extern BOOL		fNull_pccol;

		// These values are needed only between <func> and <func>Dlg:
	static BOOL		fNew_lpccol;
	static BOOL		fNew_lszColName;
	static BOOL		fNew_lpcbColName;
	static BOOL		fNew_lpfSqlType;
	static BOOL		fNew_lpcbColDef;
	static BOOL		fNew_lpibScale;
	static BOOL		fNew_lpfNullable;
	static BOOL		fNew_lpcrow;
	static BOOL		fNew_lrgfRowStatus;
	static BOOL		fNew_hrgbValue;
	static BOOL		fNew_lpcbValue;

//	extern BYTE CSCONST sz_untouched[]    = "untouched";

	extern BYTE CSCONST sz_fFetchType[];
//	extern BYTE CSCONST sz_irow[];
	extern BYTE CSCONST sz_apcrow[];
//	extern BYTE CSCONST sz_icol[];
//	extern BYTE CSCONST sz_ipar[];
//	extern BYTE CSCONST sz_fCType[];
//	extern BYTE CSCONST sz_cbColNameMax[];
//	extern BYTE CSCONST sz_cbValueMax[];
	extern BYTE CSCONST sz_apcbValue[];
	extern BYTE CSCONST sz_rgbValue[];
//	extern BYTE CSCONST sz_null_pointer[];

//	extern BYTE CSCONST szMismatchFormat[];


		/* from connect.c:	*/

typedef struct tagMENUTABLE
{
	UWORD fMenuItem;
	UWORD fODBCFunction;
} MENUTABLE;

	extern HWND hwndHdbcList;


	static UWORD fInfoType            = SQL_INFO_FIRST;
	static SWORD cbInfoValueMax       = MAX_INFO_STRING;
	static UWORD fDirection           = SQL_FETCH_FIRST;
	static SWORD cbDSNMax             = MAX_INFO_STRING;
	static SWORD cbDescriptionMax     = MAX_INFO_STRING;
	static BOOL  fNull_henv           = FALSE;
	static BOOL  fNull_phenv          = FALSE;
	static BOOL  fNull_phdbc          = FALSE;
	static BOOL  fNull_hwnd           = FALSE;
	static BOOL  fNull_szConnStrOut   = FALSE;
	static BOOL  fNull_pcbConnStrOut  = FALSE;
	static BOOL  fNull_rgbInfoValue   = FALSE;
	static BOOL  fNull_pcbInfoValue   = FALSE;
	static BOOL  fNull_szDSN          = FALSE;
	static BOOL  fNull_pcbDSN         = FALSE;
	static BOOL  fNull_szDescription  = FALSE;
	static BOOL  fNull_pcbDescription = FALSE;

	static BYTE CSCONST sz_UNKNOWN_SERVER[]     = UNKNOWN_SERVER;

		// These values are needed only between <func> and <func>Dlg:
	static BOOL fDriverConnect;

		/* from dda.c													*/
		/*These values are needed only between <func> and <func>Dlg:	*/

//	static UWORD	icol			= 1;
	static UWORD	fDescType		= SQL_COLUMN_COUNT;
	static SWORD	cbDescMax		= MAX_INFO_STRING;
	static BOOL		fNull_pfDesc	= FALSE;
	static BOOL		fNull_rgbDesc	= FALSE;
	static BOOL		fNull_pcbDesc	= FALSE;

	static BOOL		fNew_lrgbDesc;
	static BOOL		fNew_lpcbDesc;
	static BOOL		fNew_lpfDesc;

		/* from Send.c:	*/
	extern DDAINFO	*lpddainfo;

//		   UWORD  fOption          = SQL_CLOSE;
	static SWORD  ibScale          = 0;
	extern UWORD  ipar;
	static UDWORD udwValue         = 0;
//	static SWORD  cbColNameMax     = MAX_CBCOLNAME;
	static UDWORD cbColDef         = 0;
	static SWORD  cbCursorMax      = 300;
	static SDWORD cbSqlStrIn       = 0;
	extern SDWORD cbSqlStr;
	static SDWORD cbSqlStrMax      = MAX_CBSQLSTR;
//	static SDWORD cbValue_Param    = 0;
	static SDWORD cbValue_PutData  = 0;
	static SDWORD cbValueMax_Param = DEFAULT_BUFFER_LEN;
	extern SWORD  fSqlType;
	static	SWORD  fCType_Param     = SQL_C_CHAR;
			SWORD  fCType_PutData   = SQL_C_CHAR;
	static UDWORD crow             = 1;
	static BOOL   fNum_rgbValue    = FALSE;
//	static BOOL   fNull_hstmt      = FALSE;
	extern BOOL   fNull_szSqlStrIn;
	extern BOOL   fNull_szSqlStr;
	static BOOL   fNull_pcbSqlStr  = FALSE;
//	static BOOL   fNull_rgbValue   = FALSE;
	static BOOL   fNull_prgbValue  = FALSE;
//	static BOOL   fNull_pcbValue   = FALSE;
	static BOOL   fNull_szCursor   = FALSE;
	static BOOL   fNull_pcbCursor  = FALSE;
	static BOOL   fNull_pcpar      = FALSE;
//	static BOOL   fNull_szColName  = FALSE;
//	static BOOL   fNull_pcbColName = FALSE;
//	static BOOL   fNull_pfSqlType  = FALSE;
//	static BOOL   fNull_pcbColDef  = FALSE;
//	static BOOL   fNull_pibScale   = FALSE;
//	static BOOL   fNull_pfNullable = FALSE;
	static BOOL   fNull_pirow      = FALSE;

		// These values are needed only between <func> and <func>Dlg:
	extern BOOL fNew_lszFromInput;
	static BOOL fNew_lplrgbValue;
//	static BOOL fNew_lpfSqlType;
//	static BOOL fNew_lpcbColDef;
//	static BOOL fNew_lpibScale;
//	static BOOL fNew_lpfNullable;

	extern SDWORD cbDefault;
	static SDWORD cbValueMax_PutData;
	extern LPBYTE lszFromInput;
	static HPVOID hrgbValue;

		// These short term variables are shared between modules:
//	BOOL fChangedByApp = FALSE;


	extern        void	messageBox( char *msg, char *title, int type );
	extern pascal void	szWrite( char *lsz, BOOL fEOL );
	extern pascal void	DisplayUntouchedError( BYTE *lszVarName, BOOL fUntouched,
												BOOL fExpectUntouched );
	extern pascal void EchoRetcode( LPBYTE lszFunction, RETCODE retcode );
	extern pascal void ReleaseMemory( HPVOID hpb );
	extern pascal VOID DisplayValidHandles( BOOL fNull_henv, BOOL fNull_hdbc,
											BOOL fNull_hstmt );
	extern pascal BYTE *SzConstDisplay( LPBYTE lszName, SDWORD sdwValue );


	BYTE	sz_UNCONNECTED_SERVER[] = UNCONNECTED_SERVER;
	BYTE	szNullString[]		= "";
	BYTE	szSpace[]			= " ";
	BYTE	szEqual[]			= " = ";
	BYTE	szColon[]			= ": ";
	BYTE	szComma[]			= ", ";
	BYTE	szPeriod[]			= ".";
	BYTE	szExclam[]   		= "!";
	BYTE	sz_NULL[]			= "NULL";
	BYTE	sz_VALID[]			= "VALID";
	BYTE	sz_DSNequal[]		= "DSN=";
	BYTE	sz_Error[]			= "***Error*** ";
	BYTE	szNotEqual[]		= " != ";
	BYTE	szFormatSSError[]	= "%s%s!";
	BYTE	szFormatHex[]		= "0x%08lX";

	static BYTE CSCONST sz_null_pointer[]		= "null pointer";
	static BYTE CSCONST szFormatCastNumber[]	= "(PTR)%luL";
	static BYTE CSCONST sz_untouched[]			= "untouched";


	static FNAM CSCONST rgfnam_fSqlType[] =
	{
			// Extension SQL datatypes:
		{ SQL_ALL_TYPES,		sz_SQL_ALL_TYPES		},

			// Core SQL datatypes:
		{ SQL_CHAR,				sz_SQL_CHAR				},
		{ SQL_NUMERIC,			sz_SQL_NUMERIC			},
		{ SQL_DECIMAL,			sz_SQL_DECIMAL			},
		{ SQL_INTEGER,			sz_SQL_INTEGER			},
		{ SQL_SMALLINT,			sz_SQL_SMALLINT			},
		{ SQL_FLOAT,			sz_SQL_FLOAT			},
		{ SQL_REAL,				sz_SQL_REAL				},
		{ SQL_DOUBLE,			sz_SQL_DOUBLE			},

			// Extension SQL datatypes:
		{ SQL_DATE,				sz_SQL_DATE				},
		{ SQL_TIME,				sz_SQL_TIME				},
		{ SQL_TIMESTAMP,		sz_SQL_TIMESTAMP		},

			// Core SQL datatypes:
		{ SQL_VARCHAR,			sz_SQL_VARCHAR			},

			// Extension SQL datatypes:
		{ SQL_LONGVARCHAR,		sz_SQL_LONGVARCHAR		},
		{ SQL_BINARY,			sz_SQL_BINARY			},
		{ SQL_VARBINARY,		sz_SQL_VARBINARY		},
		{ SQL_LONGVARBINARY,	sz_SQL_LONGVARBINARY	},
		{ SQL_BIGINT,			sz_SQL_BIGINT			},
		{ SQL_TINYINT,			sz_SQL_TINYINT			},
		{ SQL_BIT,				sz_SQL_BIT				}
	};

#define ifnamMax_fSqlType \
					(sizeof( rgfnam_fSqlType ) / sizeof( rgfnam_fSqlType[0] ) )

		// Include SQL_ALL_TYPES:
	DeclareFinfoSubset( fSqlType, All, "SQL_", FINFO_SWORD, GLOBAL,
							0, ifnamMax_fSqlType );

		// Exclude SQL_ALL_TYPES:
	DeclareFinfoSubset(	fSqlType, NoAll, "SQL_", FINFO_SWORD, GLOBAL,
							1, ifnamMax_fSqlType );

		// cb values (works, since these values fit into an SWORD):

	static FNAM CSCONST rgfnam_cb[] =
	{
		{ SQL_NTS,			sz_SQL_NTS			},
		{ SQL_DATA_AT_EXEC,	sz_SQL_DATA_AT_EXEC	},
		{ SQL_NULL_DATA,	sz_SQL_NULL_DATA	}
	};
	DeclareFinfo(cb, "SQL_", FINFO_SDWORD, static );

	static FNAM CSCONST rgfnam_fCType[] =
	{
			// Core C datatypes:
		{ SQL_C_CHAR,		sz_SQL_C_CHAR		},
		{ SQL_C_LONG,		sz_SQL_C_LONG		},
		{ SQL_C_SHORT,		sz_SQL_C_SHORT		},
		{ SQL_C_FLOAT,		sz_SQL_C_FLOAT		},
		{ SQL_C_DOUBLE,		sz_SQL_C_DOUBLE		},

			// Extension C datatypes:
		{ SQL_C_DATE,		sz_SQL_C_DATE		},
		{ SQL_C_TIME,		sz_SQL_C_TIME		},
		{ SQL_C_TIMESTAMP,	sz_SQL_C_TIMESTAMP	},
		{ SQL_C_BINARY,		sz_SQL_C_BINARY		},
		{ SQL_C_TINYINT,	sz_SQL_C_TINYINT	},
		{ SQL_C_BIT,		sz_SQL_C_BIT		},

			// Core C datatypes:
		{ SQL_C_DEFAULT,	sz_SQL_C_DEFAULT	}
	};

	DeclareFinfo( fCType, "SQL_", FINFO_SWORD, GLOBAL );

	BYTE	sz_DSN[] 			= "DSN";
	BYTE	sz_UID[] 			= "UID";
	BYTE	sz_AuthStr[]		= "AuthStr";
	BYTE	sz_fInfoType[]		= "fInfoType";
	BYTE	sz_fDirection[]		= "fDirection";
	BYTE	sz_rgbInfoValue[]	= "rgbInfoValue";
	BYTE	sz_SQL_NULL_HENV[]	= "SQL_NULL_HENV";
	BYTE	sz_SQL_NULL_HDBC[]	= "SQL_NULL_HDBC";
	BYTE	sz_SQL_NULL_HSTMT[]	= "SQL_NULL_HSTMT";


	BYTE	sz_fOption[]		= "fOption";
	BYTE	sz_vParam[]			= "vParam";
	BYTE	sz_fConcurrency[]	= "fConcurrency";
	BYTE	sz_crowKeyset[]		= "crowKeyset";
	BYTE	sz_crowRowset[]		= "crowRowset";
	BYTE	sz_irow[]			= "irow";
	BYTE	sz_fRefresh[]		= "fRefresh";
	BYTE	sz_fLock[]			= "fLock";


	extern char	OutStr[ 255 ];	// One global OutStr!	was OutStr[ OUTSTRLEN ]


		// These values are init at launch, then remembered between <func> calls:

	UWORD  irow                = 0;
	SWORD  cbErrorMsgMax       = SQL_MAX_MESSAGE_LENGTH;
	SDWORD crowKeyset          = SQL_SCROLL_FORWARD_ONLY;
	UWORD  crowRowset          = 1;
	UWORD  fType               = SQL_COMMIT;
	UWORD  fConcurrency        = SQL_CONCUR_READ_ONLY;
	BOOL   fRefresh            = FALSE;
	BOOL   fLock               = FALSE;
	BOOL   fNull_henv          = FALSE;
	BOOL   fNull_hdbc          = FALSE;
	BOOL   fNull_hstmt         = FALSE;
	BOOL   fNull_szSqlState    = FALSE;
	BOOL   fNull_pfNativeError = FALSE;
	BOOL   fNull_szErrorMsg    = FALSE;
	BOOL   fNull_vParam        = FALSE;
	BOOL   fNull_pvParam       = FALSE;
	BOOL   fNull_pcbErrorMsg   = FALSE;

#define NUM_CONN_OPTIONS (SQL_TXN_ISOLATION - SQL_ACCESS_MODE + 1)
#define MIN_STMT_OPTION  SQL_QUERY_TIMEOUT
#define MIN_CONN_OPTION  SQL_ACCESS_MODE

	typedef struct
	{
		UWORD	fOption;
		UDWORD	udwParam;
	} OPTARG;				/* option arg */

	OPTARG	optargStmt		= {MIN_STMT_OPTION, 0};	// option arg SQL{Set|Get}StmtOption
	OPTARG	optargConnect	= {MIN_CONN_OPTION, 0};	// option arg SQLGetConnectOption
	OPTARG	optargBoth		= {MIN_CONN_OPTION, 0};	// both: SQLSetConnectOption is funny


	static BYTE rgbParam[ MAX_OPTION_PARAM + 1 ];

		// These values are needed only between <func> and <func>Dlg:

	static FINFO CSCONST	*pfinfo;
	static OPTARG			*poptarg;	// pointer to generic opt arg str

		// Constants in storage:

	extern FINFO	finfo_BOOL;


	FNAM CSCONST rgfnam_fType[] =
	{
		{ SQL_COMMIT,	sz_SQL_COMMIT	},
		{ SQL_ROLLBACK,	sz_SQL_ROLLBACK	}
	};

	DeclareFinfo( fType, "SQL_", FINFO_UWORD, static );


#define FIsConnect( pfinfo )     (pfinfo != &finfo_fOption_Stmt)

static pascal BOOL FDisplayOptionParam( RETCODE retcode, UWORD fOption,
						BOOL fNull_pvParam, VOID *pvParam, SWORD cbParamMax );

static pascal UDWORD VParamFromFOptionIsel( UWORD fOption, int isel );

	// vParam dropdown selection indexes:

#define iselParamNil      CB_ERR  // No selection
#define iselParamFirst    0       // First selection
#define iselParamSecond   1       // Second selection
#define iselParamThird    2       // Third selection

#define DefinePrefixedString(prefix, name) \
	static BYTE CSCONST sz_ ## prefix ## _ ## name[] = #prefix": "#name;

		// Connect options:

	DefinePrefixedString( Conn, SQL_ACCESS_MODE			)

//??static BYTE CSCONST sz_Conn_SQL_ACCESS_MODE[] = "Conn: SQL_ACCESS_MODE";

	DefinePrefixedString( Conn, SQL_AUTOCOMMIT			)
	DefinePrefixedString( Conn, SQL_LOGIN_TIMEOUT		)
	DefinePrefixedString( Conn, SQL_OPT_TRACE			)
	DefinePrefixedString( Conn, SQL_OPT_TRACEFILE		)
	DefinePrefixedString( Conn, SQL_TRANSLATE_DLL		)
	DefinePrefixedString( Conn, SQL_TRANSLATE_OPTION	)
	DefinePrefixedString( Conn, SQL_TXN_ISOLATION		)

		// Statement options:

	DefinePrefixedString( Stmt, SQL_QUERY_TIMEOUT	)
	DefinePrefixedString( Stmt, SQL_MAX_ROWS		)
	DefinePrefixedString( Stmt, SQL_NOSCAN			)
	DefinePrefixedString( Stmt, SQL_MAX_LENGTH		)
	DefinePrefixedString( Stmt, SQL_ASYNC_ENABLE	)
	DefinePrefixedString( Stmt, SQL_BIND_TYPE		)

#define InitPrefixedFnam(prefix, name) {name, sz_ ## prefix ## _ ## name}

	static FNAM CSCONST rgfnam_fOption[] =
	{
			// Connect options:

		InitPrefixedFnam( Conn, SQL_ACCESS_MODE		),
		InitPrefixedFnam( Conn, SQL_AUTOCOMMIT		),
		InitPrefixedFnam( Conn, SQL_LOGIN_TIMEOUT	),
		InitPrefixedFnam( Conn, SQL_OPT_TRACE		),
		InitPrefixedFnam( Conn, SQL_OPT_TRACEFILE	),
		InitPrefixedFnam( Conn, SQL_TRANSLATE_DLL	),
		InitPrefixedFnam( Conn, SQL_TRANSLATE_OPTION),
		InitPrefixedFnam( Conn, SQL_TXN_ISOLATION	),

			// Statement options:

		InitPrefixedFnam( Stmt, SQL_QUERY_TIMEOUT	),
		InitPrefixedFnam( Stmt, SQL_MAX_ROWS		),
		InitPrefixedFnam( Stmt, SQL_NOSCAN			),
		InitPrefixedFnam( Stmt, SQL_MAX_LENGTH		),
		InitPrefixedFnam( Stmt, SQL_ASYNC_ENABLE	),
		InitPrefixedFnam( Stmt, SQL_BIND_TYPE		)
	};
#define ifnamMax_fOption (sizeof rgfnam_fOption / sizeof rgfnam_fOption[0])

		// Connect options only:
	DeclareFinfoSubset(	fOption, Connect, "Conn: SQL_", FINFO_UWORD, static,
						0, NUM_CONN_OPTIONS );

		// Statement options only:
	DeclareFinfoSubset( fOption, Stmt, "Stmt: SQL_", FINFO_UWORD, static,
		NUM_CONN_OPTIONS, ifnamMax_fOption );

		// Both connect and statement options: (SQLSetConnectOptions)
	DeclareFinfoSubset( fOption, Both, "Conn: SQL_", FINFO_UWORD, static,
		0, ifnamMax_fOption );



initglobs()
{
	hglobs = (GLOBALstructs**)NewHandleClear( sizeof( GLOBALstructs ) );
	HLock( (Handle)hglobs );
	return;
}/* end initglobs */


void Pas2Ccopy( Str255 src, char *dest )
{
	register char	*s, *d;
	register short	c;

	s = &src[1];	d = dest;	c = (unsigned char)src[ 0 ];
	while( c-- )
		*d++ = *s++;
	*d = 0;
	return;
}/* end Pas2Ccopy */


long getTextCount( Str255 s )
{
	char	nts[] = "\pSQL_NTS";


	if( *s == 0 )
		return 0;
	if( strncmp( s+1, nts+1, *nts ) == 0 )
		return SQL_NTS;
	StringToNum( s, &gNum );
	return gNum;
}/* end getTextCount */


void refreshDBCpop()
{
	EraseRect( &DBCpop.popRect );
	InvalRect( &DBCpop.popRect );
	return;
}/* end refreshDBCpop */


void refreshSTMTpop()
{
	EraseRect( &STMTpop.popRect );
	InvalRect( &STMTpop.popRect );
	return;
}/* end refreshSTMTpop */


pascal VOID DisplayValidHandles( BOOL fNull_henv, BOOL fNull_hdbc, BOOL fNull_hstmt )
{
	static BYTE CSCONST sz_Valid_handles[] = "Valid handles: ";
	static BYTE CSCONST sz_none[]          = "none";
	static BYTE CSCONST sz_henv[]          = "henv";
	static BYTE CSCONST sz_hdbc[]          = "hdbc";
	static BYTE CSCONST sz_hstmt[]         = "hstmt";

	BOOL fValid = FALSE;

	szWrite( sz_Valid_handles, FALSE );
	if( !fNull_henv && henv != SQL_NULL_HENV )
	{
		szWrite( sz_henv, FALSE );
		fValid = TRUE;
	}
	if( !fNull_hdbc && hdbc != SQL_NULL_HDBC )
	{
		if( fValid )
			szWrite( szComma, FALSE );
		szWrite( sz_hdbc, FALSE );
		fValid = TRUE;
	}
	if( !fNull_hstmt && hstmt != SQL_NULL_HSTMT )
	{
		if( fValid )
			szWrite( szComma, FALSE );
		szWrite( sz_hstmt, FALSE );
		fValid = TRUE;
	}
	if( !fValid )
		szWrite( sz_none, FALSE );
}/* end DisplayValidHandles */


pascal VOID AllErrors()
{
	static BYTE CSCONST rgszHandleType[][5] = {"stmt", "dbc", "env"};

	HENV	henvCall;
	HDBC	hdbcCall;
	HSTMT	hstmtCall;
	RETCODE	retcode;
	UCHAR	szSqlState[ SQL_SQLSTATE_SIZE + 2 ];	// +2 for NULL & check byte
	SDWORD	fNativeError;
	UCHAR	szErrorMsg[ SQL_MAX_MESSAGE_LENGTH + 1 ];	// +1 for check byte
	SWORD	cbErrorMsg;
	int		ihandle;
	int		fAbort;

	for( ihandle = 0; ihandle < 3; ihandle++ )
	{
		hstmtCall = ihandle == 0 ? hstmt : SQL_NULL_HSTMT;
		hdbcCall  = ihandle == 1 ? hdbc  : SQL_NULL_HDBC;
		henvCall  = ihandle == 2 ? henv  : SQL_NULL_HENV;

		if( henvCall  == SQL_NULL_HENV
		 && hdbcCall  == SQL_NULL_HDBC
		 && hstmtCall == SQL_NULL_HSTMT )
			continue;
		do
		{	Untouch( szSqlState, sizeof szSqlState );
			fNativeError = (SDWORD)UNTOUCHED;
			Untouch( szErrorMsg, sizeof( szErrorMsg ) );
			cbErrorMsg = (SWORD)UNTOUCHED;

			retcode = SQLError(	henvCall, hdbcCall, hstmtCall,
								szSqlState, &fNativeError, szErrorMsg,
								SQL_MAX_MESSAGE_LENGTH, &cbErrorMsg );

			if( !( retcode == SQL_NO_DATA_FOUND
			 && strcmp( szSqlState, sz_00000 ) == 0		// mj: changed _fstrcmp
			 && (fNativeError == (SDWORD)UNTOUCHED || fNativeError == 0)
			 && szErrorMsg[0] == '\0'
			 && cbErrorMsg == 0) )
			{
				szWrite( rgszHandleType[ ihandle ], FALSE );
				szWrite( szColon, FALSE );
				if( retcode != SQL_SUCCESS )
					EchoRetcode( sz_SQLError, retcode );
			}
			DisplayError( retcode, szSqlState, &fNativeError,
							szErrorMsg, SQL_MAX_MESSAGE_LENGTH, &cbErrorMsg );
			fAbort = FAbortCheck();
		} while(  retcode == SQL_SUCCESS && !fAbort );

		if( fAbort )
			break;
	}/* end FOR */
	return;
}/* end AllErrors */


pascal VOID DisplayError(	RETCODE retcode,		UCHAR *lszSqlState,
							SDWORD *lpfNativeError,	UCHAR *lszErrorMsg,
							SWORD cbErrorMsgMax,	SWORD *lpcbErrorMsg	)
{
	static BYTE CSCONST sz_szSqlState[]     = "szSqlState";
	static BYTE CSCONST sz_apfNativeError[] = "*pfNativeError";
	static BYTE CSCONST sz_szErrorMsg[]     = "szErrorMsg";
	static BYTE CSCONST sz_apcbErrorMsg[]   = "*pcbErrorMsg";

	BOOL fUntouched;
	BOOL fNoDataSqlState;
	BOOL fNoData = retcode == SQL_NO_DATA_FOUND;
	BOOL fFail = !( retcode == SQL_SUCCESS ||
		           retcode == SQL_SUCCESS_WITH_INFO || fNoData );
	SWORD cbTouched;
	SWORD cbErrorMsg;

	if( lszSqlState )
	{
		cbTouched  = (SWORD)CbTouchedRgbCbMax( lszSqlState, SQL_SQLSTATE_SIZE+1 );
		fUntouched = (cbTouched == 0);
		if( !fFail )
			DisplayUntouchedError( sz_szSqlState, fUntouched, FALSE );

		if( !fUntouched )
		{
			if( !fFail )
				CheckSqlState( lszSqlState );

			fNoDataSqlState = strcmp( lszSqlState, sz_00000 ) == 0;
			if( !(fNoData && fNoDataSqlState) )
			{
				if( !fFail && fNoData != fNoDataSqlState )
					szWrite( sz_Error, FALSE );

				szWrite( sz_szSqlState,	FALSE );
				szWrite( szEqual,		FALSE );
				DisplayString(NULL, lszSqlState, cbTouched, 0 );
			}
		}
	}
	if( lpfNativeError )
	{
		fUntouched = *lpfNativeError == (SDWORD)UNTOUCHED;
		if( !(fNoData && (fUntouched || *lpfNativeError == 0))
		 && FCheckArg( sz_apfNativeError, fUntouched, fFail, TRUE ) )
		{
			ltoa( *lpfNativeError, OutStr, 10 );
			szWrite( OutStr, FALSE );
		}
	}
	if( FDisplayCbAndRgbArgs(	retcode, NO_DATA_CHECK, SQL_C_CHAR,
								sz_apcbErrorMsg, lpcbErrorMsg, cbErrorMsgMax,
								sz_szErrorMsg, lszErrorMsg )
	 && lszErrorMsg[0] == ' ' )
	{
		static BYTE CSCONST szMsg[] = "szErrorMsg[0] = ' '!";

		szWrite( sz_Error, FALSE );
		szWrite( szMsg,    TRUE  );
	}
	if( lpcbErrorMsg
	 && (cbErrorMsg = *lpcbErrorMsg ) >= SQL_MAX_MESSAGE_LENGTH )
	{
		static BYTE CSCONST szMsg[] = " >= ";

		szWrite( sz_Error, FALSE );
		szWrite( SzConstDisplay( sz_apcbErrorMsg, cbErrorMsg ), FALSE );
		szWrite( szMsg, FALSE );
		szWrite( SzConstDisplay(
					sz_SQL_MAX_MESSAGE_LENGTH, SQL_MAX_MESSAGE_LENGTH), FALSE );
		szWrite( szExclam, TRUE );
	}
}/* end DisplayError */


pascal VOID CheckSqlState( UCHAR *lszSqlState )
{
#define lpch lszSqlState

	int		cch = 0;
	UCHAR	*lpchMax = &lszSqlState[ SQL_SQLSTATE_SIZE ];
	UCHAR	ch;

	do
	{	if( (ch = *lpch) < '0' || ch > '9' && ch < 'A' || ch > 'Z')
			cch++;
	} while( ++lpch < lpchMax );

	if( *lpch != '\0' )
	{
		static BYTE CSCONST szMsg[] =
			"szSqlState[SQL_SQLSTATE_SIZE] != '\\0'!";

		szWrite( sz_Error, FALSE );
		szWrite( szMsg, TRUE );
		cch++;
	}
	if( cch > 0 )
	{
		static BYTE CSCONST szFormat[] = "szSqlState has %d bad characters!";

		szWrite( sz_Error, FALSE );
		wsprintf( OutStr, szFormat, cch );
		szWrite(  OutStr, TRUE );
	}
	return;
#undef lpch
}/* end CheckSqlState */


static pascal BOOL FDisplayOptionParam(	RETCODE retcode,
										UWORD fOption, BOOL fNull_pvParam,
										VOID *pvParam, SWORD cbParamMax )
{
	static BYTE CSCONST		sz_apvParam[] = "*pvParam";
	static BYTE CSCONST		szFormatHex[] = "0x%08lX";

	int		isel;
	SWORD	cbTouched;
	UDWORD	udw;

	szWrite( sz_fOption, FALSE );
	szWrite( szEqual, FALSE );
	szWrite( SzConstDisplay(
					LszNameFromFlagArg( &finfo_fOption_Both, fOption ), fOption ),
				FALSE );
	szWrite( ":", TRUE );
	EchoRetcode(	LszIfSz(FIsConnect( pfinfo ),
					sz_SQLGetConnectOption, sz_SQLGetStmtOption ),
					retcode );
	cbTouched = (SWORD)CbTouchedRgbCbMax( pvParam, cbParamMax );
	if( fNull_pvParam ||
		!FCheckArg( sz_apvParam, cbTouched == 0,
			retcode < SQL_SUCCESS || retcode == SQL_NO_DATA_FOUND, TRUE ) )
		return FALSE;

	if( fOption == SQL_OPT_TRACEFILE || fOption == SQL_TRANSLATE_DLL )
	{
		DisplayString( NULL, pvParam, cbTouched, 0 );
		szWrite( szPeriod, TRUE );
	}
	else
	{
		for( isel = iselParamFirst;
			 (udw = VParamFromFOptionIsel( fOption, isel ),
			  OutStr[0] != '\0' );
			 isel++)
			if( udw == *(UDWORD *)pvParam )
				goto FoundIt;

		if( fOption == SQL_TXN_ISOLATION )
			wsprintf( OutStr, szFormatHex, *(UDWORD *)pvParam );
		else
			ultoa( *(UDWORD*)pvParam, OutStr, 10 );
FoundIt:
		szWrite( OutStr,   FALSE );
		szWrite( szPeriod, TRUE  );
		DisplayBytesUntouchedError( sz_apvParam, cbTouched, sizeof( UDWORD ) );
	}
	return TRUE;
}/* end FDisplayOptionParam */


static pascal UDWORD VParamFromFOptionIsel( UWORD fOption, int isel )
{
	static BYTE CSCONST sz_All[] = "All";

	static BYTE CSCONST szSel_null_pointer[] = "<null pointer>";
	static BYTE CSCONST szSel_empty_string[] = "<empty string>";
	static BYTE CSCONST szSel_untouched[]    = "<untouched>";

	static BYTE CSCONST sz_Off[] = "Off";
	static BYTE CSCONST sz_On[]  = "On";

	LPBYTE lsz;
	UDWORD udw;

	OutStr[0] = '\0';
	switch( fOption )
	{
	case SQL_QUERY_TIMEOUT:
	case SQL_MAX_LENGTH:
	case SQL_LOGIN_TIMEOUT:
		if( lsz = sz_Off, udw = 0, isel == iselParamFirst )
			goto CatNum;

		break;

	case SQL_BIND_TYPE:
		if( lsz = sz_SQL_BIND_BY_COLUMN, udw = 0, isel == iselParamFirst )
			goto CatNum;

		break;

	case SQL_MAX_ROWS:
		if( lsz = sz_All, udw = 0, isel == iselParamFirst )
			goto CatNum;
		break;

	case SQL_AUTOCOMMIT:
	case SQL_ASYNC_ENABLE:
	case SQL_OPT_TRACE:
	case SQL_NOSCAN:
		if( (udw = FALSE, isel == iselParamFirst )
		 || (udw = TRUE,  isel == iselParamSecond) )
		{
			lsz = LszNameFromFlagArg( &finfo_BOOL, (UWORD)udw );
			goto CatNum;
		}
		break;

	case SQL_ACCESS_MODE:
		if( ( lsz = sz_SQL_MODE_READ_WRITE, udw = SQL_MODE_READ_WRITE,
			 isel == iselParamFirst ) ||
			( lsz = sz_SQL_MODE_READ_ONLY,  udw = SQL_MODE_READ_ONLY,
			 isel == iselParamSecond ) )
		{
CatNum:
			SzConstDisplay( lsz, udw );	// The output string is in OutStr
			return udw;
		}
		break;

	case SQL_TXN_ISOLATION:
		return FTXNIsoNameFromIbmnam( OutStr, (UWORD)(isel - iselParamFirst) );

	case SQL_TRANSLATE_OPTION:
		break;

	case SQL_OPT_TRACEFILE:
	case SQL_TRANSLATE_DLL:
		if( ( lsz = szSel_null_pointer, isel == iselParamFirst  )
		 || ( lsz = szSel_empty_string, isel == iselParamSecond )
		 || ( lsz = szSel_untouched,    isel == iselParamThird  ) )
			strcpy( OutStr, lsz );
		break;
	}
	return 0;
}/* end VParamFromFOptionIsel */


static FNAM CSCONST rgfnam_fConcurrency[] =
	{
		{ SQL_CONCUR_READ_ONLY,	sz_SQL_CONCUR_READ_ONLY	},
		{ SQL_CONCUR_LOCK,		sz_SQL_CONCUR_LOCK		},
		{ SQL_CONCUR_TIMESTAMP,	sz_SQL_CONCUR_TIMESTAMP	},
		{ SQL_CONCUR_VALUES,	sz_SQL_CONCUR_VALUES	}
	};
DeclareFinfo( fConcurrency, "SQL_", FINFO_UWORD, static );

static FNAM CSCONST rgfnam_crowKeyset[] =
	{
		{ SQL_SCROLL_FORWARD_ONLY,	sz_SQL_SCROLL_FORWARD_ONLY	},
		{ SQL_SCROLL_KEYSET_DRIVEN,	sz_SQL_SCROLL_KEYSET_DRIVEN	},
		{ SQL_SCROLL_DYNAMIC,		sz_SQL_SCROLL_DYNAMIC		}
	};
DeclareFinfo( crowKeyset, "SQL_SCROLL_", FINFO_SDWORD, static );


pascal BOOL FCheckArg( LPBYTE lszVarName,
						BOOL fUntouched, BOOL fExpectUntouched, BOOL fVerbose )
{
	if( !fExpectUntouched )
		DisplayUntouchedError( lszVarName, fUntouched, FALSE );

	if( !fUntouched )
	{
		if( FNeedSeparator() )
			szWrite( szComma, FALSE );

		if( fVerbose )
		{
			szWrite( lszVarName, FALSE );
			szWrite( szEqual, FALSE );
		}
	}
	return !fUntouched;
}


pascal VOID DisplayUntouchedError( LPBYTE lszVarName,
									BOOL fUntouched, BOOL fExpectUntouched )
{
	static BYTE CSCONST sz_is[]        = " is";
	static BYTE CSCONST sz_not[]       = " not";
	static BYTE CSCONST sz_untouched[] = " untouched!";

	if( !!fExpectUntouched == !!fUntouched )
		return;

	if( FNeedSeparator() )
		szWrite( szSpace, TRUE );

	szWrite( sz_Error,		FALSE );
	szWrite( lszVarName,	FALSE );
	szWrite( sz_is,			FALSE );
	if( !fUntouched )
		szWrite( sz_not, FALSE );

	szWrite( sz_untouched, TRUE );
	return;
}/* end DisplayUntouchedError */


pascal VOID DisplayBytesUntouchedError( LPBYTE lszVarName,
										SDWORD cbTouched, SDWORD cbExpect )
{
	static BYTE CSCONST sz_Byte[]      = "Byte";
	static BYTE CSCONST szFormat1[]    = " %ld of %s is";
	static BYTE CSCONST szFormat2[]    = "s %ld through %ld of %s are";
	static BYTE CSCONST sz_not[]       = " not";
	static BYTE CSCONST sz_untouched[] = " untouched!";

	SDWORD		ibMin, ibMax;


	if( cbTouched == cbExpect )
		return;

	ibMin = cbTouched;
	ibMax = cbExpect;
	if( cbTouched > cbExpect )
	{
		ibMin = cbExpect;
		ibMax = cbTouched;
	}
	if( FNeedSeparator() )
		szWrite( szSpace, TRUE );

	szWrite( sz_Error,	FALSE );
	szWrite( sz_Byte,	FALSE );
	if( ibMin == ibMax - 1)
		 wsprintf( OutStr, szFormat1, ibMin, lszVarName );
	else wsprintf( OutStr, szFormat2, ibMin, ibMax - 1, lszVarName );

	szWrite( OutStr, FALSE );
	if( cbTouched > cbExpect )
		szWrite( sz_not, FALSE );

	szWrite( sz_untouched, TRUE );
	return;
}/* end DisplayBytesUntouchedError */


#ifdef TRACEMSG

pascal VOID TraceMsg( HWND hdlg, unsigned message, WORD wParam, LONG lParam )
{
	typedef struct
	{	unsigned		message;
		BYTE CSCONST	*szMessage;
	} MSGMAP;

#define DefineString(name) static BYTE CSCONST sz_ ## name[] = #name;

	DefineString( WM_NULL)
	DefineString( WM_CREATE)
	DefineString( WM_DESTROY)
	DefineString( WM_MOVE)
	DefineString( WM_SIZE)
	DefineString( WM_ACTIVATE)
	DefineString( WM_SETFOCUS)
	DefineString( WM_KILLFOCUS)
	DefineString( WM_ENABLE)
	DefineString( WM_SETREDRAW)
	DefineString( WM_SETTEXT)
	DefineString( WM_GETTEXT)
	DefineString( WM_GETTEXTLENGTH)
	DefineString( WM_PAINT)
	DefineString( WM_CLOSE)
	DefineString( WM_QUERYENDSESSION)
	DefineString( WM_QUIT)
	DefineString( WM_QUERYOPEN)
	DefineString( WM_ERASEBKGND)
	DefineString( WM_SYSCOLORCHANGE)
	DefineString( WM_ENDSESSION)
	DefineString( WM_SHOWWINDOW)
	DefineString( WM_CTLCOLOR)
	DefineString( WM_WININICHANGE)
	DefineString( WM_DEVMODECHANGE)
	DefineString( WM_ACTIVATEAPP)
	DefineString( WM_FONTCHANGE)
	DefineString( WM_TIMECHANGE)
	DefineString( WM_CANCELMODE)
	DefineString( WM_SETCURSOR)
	DefineString( WM_MOUSEACTIVATE)
	DefineString( WM_CHILDACTIVATE)
	DefineString( WM_QUEUESYNC)
	DefineString( WM_GETMINMAXINFO)
	DefineString( WM_PAINTICON)
	DefineString( WM_ICONERASEBKGND)
	DefineString( WM_NEXTDLGCTL)
	DefineString( WM_SPOOLERSTATUS)
	DefineString( WM_DRAWITEM)
	DefineString( WM_MEASUREITEM)
	DefineString( WM_DELETEITEM)
	DefineString( WM_VKEYTOITEM)
	DefineString( WM_CHARTOITEM)
	DefineString( WM_SETFONT)
	DefineString( WM_GETFONT)
	DefineString( WM_QUERYDRAGICON)
	DefineString( WM_COMPAREITEM)
	DefineString( WM_COMPACTING)
	DefineString( WM_NCCREATE)
	DefineString( WM_NCDESTROY)
	DefineString( WM_NCCALCSIZE)
	DefineString( WM_NCHITTEST)
	DefineString( WM_NCPAINT)
	DefineString( WM_NCACTIVATE)
	DefineString( WM_GETDLGCODE)
	DefineString( WM_NCMOUSEMOVE)
	DefineString( WM_NCLBUTTONDOWN)
	DefineString( WM_NCLBUTTONUP)
	DefineString( WM_NCLBUTTONDBLCLK)
	DefineString( WM_NCRBUTTONDOWN)
	DefineString( WM_NCRBUTTONUP)
	DefineString( WM_NCRBUTTONDBLCLK)
	DefineString( WM_NCMBUTTONDOWN)
	DefineString( WM_NCMBUTTONUP)
	DefineString( WM_NCMBUTTONDBLCLK)
	DefineString( WM_KEYFIRST)
	DefineString( WM_KEYDOWN)
	DefineString( WM_KEYUP)
	DefineString( WM_CHAR)
	DefineString( WM_DEADCHAR)
	DefineString( WM_SYSKEYDOWN)
	DefineString( WM_SYSKEYUP)
	DefineString( WM_SYSCHAR)
	DefineString( WM_SYSDEADCHAR)
	DefineString( WM_KEYLAST)
	DefineString( WM_INITDIALOG)
	DefineString( WM_COMMAND)
	DefineString( WM_SYSCOMMAND)
	DefineString( WM_TIMER)
	DefineString( WM_HSCROLL)
	DefineString( WM_VSCROLL)
	DefineString( WM_INITMENU)
	DefineString( WM_INITMENUPOPUP)
	DefineString( WM_MENUSELECT)
	DefineString( WM_MENUCHAR)
	DefineString( WM_ENTERIDLE)
	DefineString( WM_MOUSEFIRST)
	DefineString( WM_MOUSEMOVE)
	DefineString( WM_LBUTTONDOWN)
	DefineString( WM_LBUTTONUP)
	DefineString( WM_LBUTTONDBLCLK)
	DefineString( WM_RBUTTONDOWN)
	DefineString( WM_RBUTTONUP)
	DefineString( WM_RBUTTONDBLCLK)
	DefineString( WM_MBUTTONDOWN)
	DefineString( WM_MBUTTONUP)
	DefineString( WM_MBUTTONDBLCLK)
	DefineString( WM_MOUSELAST)
	DefineString( WM_PARENTNOTIFY)
	DefineString( WM_MDICREATE)
	DefineString( WM_MDIDESTROY)
	DefineString( WM_MDIACTIVATE)
	DefineString( WM_MDIRESTORE)
	DefineString( WM_MDINEXT)
	DefineString( WM_MDIMAXIMIZE)
	DefineString( WM_MDITILE)
	DefineString( WM_MDICASCADE)
	DefineString( WM_MDIICONARRANGE)
	DefineString( WM_MDIGETACTIVE)
	DefineString( WM_MDISETMENU)
	DefineString( WM_CUT)
	DefineString( WM_COPY)
	DefineString( WM_PASTE)
	DefineString( WM_CLEAR)
	DefineString( WM_UNDO)
	DefineString( WM_RENDERFORMAT)
	DefineString( WM_RENDERALLFORMATS)
	DefineString( WM_DESTROYCLIPBOARD)
	DefineString( WM_DRAWCLIPBOARD)
	DefineString( WM_PAINTCLIPBOARD)
	DefineString( WM_VSCROLLCLIPBOARD)
	DefineString( WM_SIZECLIPBOARD)
	DefineString( WM_ASKCBFORMATNAME)
	DefineString( WM_CHANGECBCHAIN)
	DefineString( WM_HSCROLLCLIPBOARD)
	DefineString( WM_QUERYNEWPALETTE)
	DefineString( WM_PALETTEISCHANGING)
	DefineString( WM_PALETTECHANGED)

#define InitMsgmap(name) {name, sz_ ## name}

	static MSGMAP CSCONST rgmsgmap[] =
	{
		InitMsgmap( WM_NULL			),
		InitMsgmap( WM_CREATE	),
		InitMsgmap( WM_DESTROY	),
		InitMsgmap( WM_MOVE	),
		InitMsgmap( WM_SIZE	),
		InitMsgmap( WM_ACTIVATE	),
		InitMsgmap( WM_SETFOCUS	),
		InitMsgmap( WM_KILLFOCUS	),
		InitMsgmap( WM_ENABLE	),
		InitMsgmap( WM_SETREDRAW	),
		InitMsgmap( WM_SETTEXT	),
		InitMsgmap( WM_GETTEXT	),
		InitMsgmap( WM_GETTEXTLENGTH	),
		InitMsgmap( WM_PAINT	),
		InitMsgmap( WM_CLOSE	),
		InitMsgmap( WM_QUERYENDSESSION	),
		InitMsgmap( WM_QUIT	),
		InitMsgmap( WM_QUERYOPEN	),
		InitMsgmap( WM_ERASEBKGND	),
		InitMsgmap( WM_SYSCOLORCHANGE	),
		InitMsgmap( WM_ENDSESSION	),
		InitMsgmap( WM_SHOWWINDOW	),
		InitMsgmap( WM_CTLCOLOR	),
		InitMsgmap( WM_WININICHANGE	),
		InitMsgmap( WM_DEVMODECHANGE	),
		InitMsgmap( WM_ACTIVATEAPP	),
		InitMsgmap( WM_FONTCHANGE	),
		InitMsgmap( WM_TIMECHANGE	),
		InitMsgmap( WM_CANCELMODE	),
		InitMsgmap( WM_SETCURSOR	),
		InitMsgmap( WM_MOUSEACTIVATE	),
		InitMsgmap( WM_CHILDACTIVATE	),
		InitMsgmap( WM_QUEUESYNC	),
		InitMsgmap( WM_GETMINMAXINFO	),
		InitMsgmap( WM_PAINTICON	),
		InitMsgmap( WM_ICONERASEBKGND	),
		InitMsgmap( WM_NEXTDLGCTL	),
		InitMsgmap( WM_SPOOLERSTATUS	),
		InitMsgmap( WM_DRAWITEM	),
		InitMsgmap( WM_MEASUREITEM	),
		InitMsgmap( WM_DELETEITEM	),
		InitMsgmap( WM_VKEYTOITEM	),
		InitMsgmap( WM_CHARTOITEM	),
		InitMsgmap( WM_SETFONT	),
		InitMsgmap( WM_GETFONT	),
		InitMsgmap( WM_QUERYDRAGICON	),
		InitMsgmap( WM_COMPAREITEM	),
		InitMsgmap( WM_COMPACTING	),
		InitMsgmap( WM_NCCREATE	),
		InitMsgmap( WM_NCDESTROY	),
		InitMsgmap( WM_NCCALCSIZE	),
		InitMsgmap( WM_NCHITTEST	),
		InitMsgmap( WM_NCPAINT	),
		InitMsgmap( WM_NCACTIVATE	),
		InitMsgmap( WM_GETDLGCODE	),
		InitMsgmap( WM_NCMOUSEMOVE	),
		InitMsgmap( WM_NCLBUTTONDOWN	),
		InitMsgmap( WM_NCLBUTTONUP	),
		InitMsgmap( WM_NCLBUTTONDBLCLK	),
		InitMsgmap( WM_NCRBUTTONDOWN	),
		InitMsgmap( WM_NCRBUTTONUP	),
		InitMsgmap( WM_NCRBUTTONDBLCLK	),
		InitMsgmap( WM_NCMBUTTONDOWN	),
		InitMsgmap( WM_NCMBUTTONUP	),
		InitMsgmap( WM_NCMBUTTONDBLCLK	),
		InitMsgmap( WM_KEYFIRST	),
		InitMsgmap( WM_KEYDOWN	),
		InitMsgmap( WM_KEYUP	),
		InitMsgmap( WM_CHAR	),
		InitMsgmap( WM_DEADCHAR	),
		InitMsgmap( WM_SYSKEYDOWN	),
		InitMsgmap( WM_SYSKEYUP	),
		InitMsgmap( WM_SYSCHAR	),
		InitMsgmap( WM_SYSDEADCHAR	),
		InitMsgmap( WM_KEYLAST	),
		InitMsgmap( WM_INITDIALOG	),
		InitMsgmap( WM_COMMAND	),
		InitMsgmap( WM_SYSCOMMAND	),
		InitMsgmap( WM_TIMER	),
		InitMsgmap( WM_HSCROLL	),
		InitMsgmap( WM_VSCROLL	),
		InitMsgmap( WM_INITMENU	),
		InitMsgmap( WM_INITMENUPOPUP	),
		InitMsgmap( WM_MENUSELECT	),
		InitMsgmap( WM_MENUCHAR	),
		InitMsgmap( WM_ENTERIDLE	),
		InitMsgmap( WM_MOUSEFIRST	),
		InitMsgmap( WM_MOUSEMOVE	),
		InitMsgmap( WM_LBUTTONDOWN	),
		InitMsgmap( WM_LBUTTONUP	),
		InitMsgmap( WM_LBUTTONDBLCLK	),
		InitMsgmap( WM_RBUTTONDOWN	),
		InitMsgmap( WM_RBUTTONUP	),
		InitMsgmap( WM_RBUTTONDBLCLK	),
		InitMsgmap( WM_MBUTTONDOWN	),
		InitMsgmap( WM_MBUTTONUP	),
		InitMsgmap( WM_MBUTTONDBLCLK	),
		InitMsgmap( WM_MOUSELAST	),
		InitMsgmap( WM_PARENTNOTIFY	),
		InitMsgmap( WM_MDICREATE	),
		InitMsgmap( WM_MDIDESTROY	),
		InitMsgmap( WM_MDIACTIVATE	),
		InitMsgmap( WM_MDIRESTORE	),
		InitMsgmap( WM_MDINEXT	),
		InitMsgmap( WM_MDIMAXIMIZE	),
		InitMsgmap( WM_MDITILE	),
		InitMsgmap( WM_MDICASCADE	),
		InitMsgmap( WM_MDIICONARRANGE	),
		InitMsgmap( WM_MDIGETACTIVE	),
		InitMsgmap( WM_MDISETMENU	),
		InitMsgmap( WM_CUT	),
		InitMsgmap( WM_COPY	),
		InitMsgmap( WM_PASTE				),
		InitMsgmap( WM_CLEAR				),
		InitMsgmap( WM_UNDO					),
		InitMsgmap( WM_RENDERFORMAT			),
		InitMsgmap( WM_RENDERALLFORMATS		),
		InitMsgmap( WM_DESTROYCLIPBOARD		),
		InitMsgmap( WM_DRAWCLIPBOARD		),
		InitMsgmap( WM_PAINTCLIPBOARD		),
		InitMsgmap( WM_VSCROLLCLIPBOARD		),
		InitMsgmap( WM_SIZECLIPBOARD		),
		InitMsgmap( WM_ASKCBFORMATNAME		),
		InitMsgmap( WM_CHANGECBCHAIN		),
		InitMsgmap( WM_HSCROLLCLIPBOARD 	),
		InitMsgmap( WM_QUERYNEWPALETTE 		),
		InitMsgmap( WM_PALETTEISCHANGING	),
		InitMsgmap( WM_PALETTECHANGED		)
	};
#define pmsgmapMax PmaxFromRg( rgmsgmap )

	static BYTE CSCONST szFormat[] = "%04X %04X %04X %08lX ";
	static BYTE CSCONST szEOL[]    = "\r\n";

	MSGMAP CSCONST	*pmsgmap;

	wsprintf( OutStr, szFormat, hdlg, message, wParam, lParam );
	OutputDebugString( OutStr );
	for( pmsgmap = &rgmsgmap[0]; pmsgmap < pmsgmapMax; pmsgmap++ )
		if( message == pmsgmap->message )
		{
			OutputDebugString( pmsgmap->szMessage );
			break;
		}
	OutputDebugString( szEOL );
}/* end TraceMsg */
#endif TRACEMSG


static void DoDriverMenus()
{
	return;
}/* end DoDriverMenus */


static void DoTrace()
{
	return;
}/* end DoTrace */


static void DoTests()
{
	return;
}/* end DoTests */


static void DoAsync()
{
	return;
}/* end DoAsync */


static void DoSQLGetTypeInfo()
{
	SQLGetTypeInfoRec	*info = &(*hglobs)->SQLGetTypeInfoInfo;
	RETCODE				retcode;
	LPAF				lpaf;

	lpaf = *LplpafFromHstmt( hstmt );
	if( lpaf && lpaf->General.ifn == ifnGetTypeInfo )
		lpddainfo->fSqlType = lpaf->GetTypeInfo.fSqlType;

	if( !GetSQLGetTypeInfo( info ) )							/*** DIALOG	***/
		return;

	if( info->fSqlTypeChoice <= 13 )
		 lpddainfo->fSqlType = info->fSqlTypeChoice - 1;		// 0  thru 12
	else lpddainfo->fSqlType = -(info->fSqlTypeChoice - 13);	// -1 thru -7


/*****************************	#47 SQLGetTypeInfo	***************************/

	retcode = SQLGetTypeInfo( hstmt, lpddainfo->fSqlType );

	EchoRetcode( sz_SQLGetTypeInfo, retcode );

	lpaf = LpafAdd( TRUE, ifnGetTypeInfo, retcode );
	if( lpaf )
		lpaf->GetTypeInfo.fSqlType = lpddainfo->fSqlType;

	return;
}/* end DoSQLGetTypeinfo */


static void DoSQLTables()
{
	SQLTablesRec	*info = &(*hglobs)->SQLTablesInfo;
	RETCODE			retcode;
	LPAF			lpaf;


	ifn = ifnTables;
	lpaf = *LplpafFromHstmt( hstmt );
	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaTableQualifier,	lpaf->DDA.lpisaTableQualifier );
		ReplaceISA( &lpddainfo->lpisaTableOwner,		lpaf->DDA.lpisaTableOwner );
		ReplaceISA( &lpddainfo->lpisaTableName,			lpaf->DDA.lpisaTableName );
		ReplaceISA( &lpddainfo->lpisaTableType,			lpaf->Tables.lpisaTableType );
	}

	if( !GetSQLTables( info ) )									/*** DIALOG	***/
		return;


	Pas2Ccopy( info->QualifierText,	lpddainfo->lpisaTableQualifier->sz	);
	Pas2Ccopy( info->OwnerText,		lpddainfo->lpisaTableOwner->sz	);
	Pas2Ccopy( info->NameText,		lpddainfo->lpisaTableName->sz	);
	Pas2Ccopy( info->NameText,		lpddainfo->lpisaTableType->sz	);

	lpddainfo->lpisaTableQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaTableOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaTableName->cb		= getTextCount( info->cbNameText );
	lpddainfo->lpisaTableType->cb		= getTextCount( info->cbTypeText );


/*****************************	#54 SQLTables	*******************************/

	retcode = SQLTables(	hstmt,
							LszAndCbOfLpisa( lpddainfo->lpisaTableQualifier	),
							LszAndCbOfLpisa( lpddainfo->lpisaTableOwner		),
							LszAndCbOfLpisa( lpddainfo->lpisaTableName		),
							LszAndCbOfLpisa( lpddainfo->lpisaTableType		) );

	EchoRetcode( sz_SQLTables, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->DDA.lpisaTableQualifier,	lpddainfo->lpisaTableQualifier );
		ReplaceISA( &lpaf->DDA.lpisaTableOwner,		lpddainfo->lpisaTableOwner );
		ReplaceISA( &lpaf->DDA.lpisaTableName,		lpddainfo->lpisaTableName );
		ReplaceISA( &lpaf->Tables.lpisaTableType,	lpddainfo->lpisaTableType );
	}
	return;
}/* end DoSQLTables */


static void DoSQLColumns()
{
	SQLColumnsRec	*info = &(*hglobs)->SQLColumnsInfo;
	RETCODE			retcode;
	LPAF			lpaf;				/* Long Pointer to Async Function	*/


	ifn = ifnColumns;

	lpaf = *LplpafFromHstmt( hstmt );		// Get long pointer to Async Function
	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaTableQualifier,	lpaf->DDA.lpisaTableQualifier );
		ReplaceISA( &lpddainfo->lpisaTableOwner,		lpaf->DDA.lpisaTableOwner );
		ReplaceISA( &lpddainfo->lpisaTableName,			lpaf->DDA.lpisaTableName );
		ReplaceISA( &lpddainfo->lpisaColumnName,		lpaf->Columns.lpisaColumnName );
	}

	if( !GetSQLColumns( info ) )								/*** DIALOG	***/
		return;

	Pas2Ccopy( info->QualifierText,	lpddainfo->lpisaTableQualifier->sz	);
	Pas2Ccopy( info->OwnerText,		lpddainfo->lpisaTableOwner->sz	);
	Pas2Ccopy( info->NameText,		lpddainfo->lpisaTableName->sz	);
	Pas2Ccopy( info->ColumnText,	lpddainfo->lpisaColumnName->sz	);

	lpddainfo->lpisaTableQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaTableOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaTableName->cb		= getTextCount( info->cbNameText );
	lpddainfo->lpisaColumnName->cb		= getTextCount( info->cbColNameText );


/*****************************	#40 SQLColumns	*******************************/

	retcode = SQLColumns( hstmt,
							LszAndCbOfLpisa( lpddainfo->lpisaTableQualifier	),
							LszAndCbOfLpisa( lpddainfo->lpisaTableOwner		),
							LszAndCbOfLpisa( lpddainfo->lpisaTableName		),
							LszAndCbOfLpisa( lpddainfo->lpisaColumnName		) );

	EchoRetcode( sz_SQLColumns, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->DDA.lpisaTableQualifier,	lpddainfo->lpisaTableQualifier	);
		ReplaceISA( &lpaf->DDA.lpisaTableOwner,		lpddainfo->lpisaTableOwner		);
		ReplaceISA( &lpaf->DDA.lpisaTableName,		lpddainfo->lpisaTableName		);
		ReplaceISA( &lpaf->Columns.lpisaColumnName,	lpddainfo->lpisaColumnName		);
	}
	return;
}/* end DoSQLColumns */


static void DoSQLStatistics()
{
	SQLStatisticsRec	*info = &(*hglobs)->SQLStatisticsInfo;
	RETCODE				retcode;
	LPAF				lpaf;

	
	ifn = ifnStatistics;
	lpaf = *LplpafFromHstmt( hstmt );
	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaTableQualifier,	lpaf->DDA.lpisaTableQualifier );
		ReplaceISA( &lpddainfo->lpisaTableOwner,		lpaf->DDA.lpisaTableOwner );
		ReplaceISA( &lpddainfo->lpisaTableName,			lpaf->DDA.lpisaTableName );

		lpddainfo->fUnique		= lpaf->Statistics.fUnique;
		lpddainfo->fAccuracy	= lpaf->Statistics.fAccuracy;
	}

	if( !GetSQLStatistics( info ) )								/*** DIALOG	***/
		return;


	Pas2Ccopy( info->QualifierText,	lpddainfo->lpisaTableQualifier->sz	);
	Pas2Ccopy( info->OwnerText,		lpddainfo->lpisaTableOwner->sz	);
	Pas2Ccopy( info->NameText,		lpddainfo->lpisaTableName->sz	);

	lpddainfo->lpisaTableQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaTableOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaTableName->cb		= getTextCount( info->cbNameText );

	lpddainfo->fUnique		= info->fUniqueChoice   - 1 ;
	lpddainfo->fAccuracy	= info->fAccuracyChoice - 1;


	retcode = SQLStatistics(	hstmt,
								LszAndCbOfLpisa( lpddainfo->lpisaTableQualifier ),
								LszAndCbOfLpisa( lpddainfo->lpisaTableOwner ),
								LszAndCbOfLpisa( lpddainfo->lpisaTableName ),
								lpddainfo->fUnique,
								lpddainfo->fAccuracy );

	EchoRetcode( sz_SQLStatistics, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->DDA.lpisaTableQualifier,	lpddainfo->lpisaTableQualifier );
		ReplaceISA( &lpaf->DDA.lpisaTableOwner,		lpddainfo->lpisaTableOwner );
		ReplaceISA( &lpaf->DDA.lpisaTableName,		lpddainfo->lpisaTableName );

		lpaf->Statistics.fUnique	= lpddainfo->fUnique;
		lpaf->Statistics.fAccuracy	= lpddainfo->fAccuracy;
	}
	return;
}/* end DoSQLStatistics */


static void DoSQLPrimaryKeys()
{
	SQLPrimaryKeysRec	*info = &(*hglobs)->SQLPrimaryKeysInfo;
	RETCODE				retcode;
	LPAF				lpaf;


	ifn = ifnPrimaryKeys;
	lpaf = *LplpafFromHstmt( hstmt );

	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaTableQualifier,	lpaf->DDA.lpisaTableQualifier );
		ReplaceISA( &lpddainfo->lpisaTableOwner,		lpaf->DDA.lpisaTableOwner );
		ReplaceISA( &lpddainfo->lpisaTableName,			lpaf->DDA.lpisaTableName );
	}

	if( !GetSQLPrimaryKeys( info ) )							/*** DIALOG	***/
		return;


	Pas2Ccopy( info->QualifierText,		lpddainfo->lpisaTableQualifier->sz	);
	Pas2Ccopy( info->OwnerText,			lpddainfo->lpisaTableOwner->sz		);
	Pas2Ccopy( info->NameText,			lpddainfo->lpisaTableName->sz		);

	lpddainfo->lpisaTableQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaTableOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaTableName->cb		= getTextCount( info->cbNameText );


/*****************************	#65 SQLPrimaryKeys	***************************/

	retcode = SQLPrimaryKeys(	hstmt,
								LszAndCbOfLpisa( lpddainfo->lpisaTableQualifier ),
								LszAndCbOfLpisa( lpddainfo->lpisaTableOwner ),
								LszAndCbOfLpisa( lpddainfo->lpisaTableName ) );

	EchoRetcode( sz_SQLPrimaryKeys, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->DDA.lpisaTableQualifier,	lpddainfo->lpisaTableQualifier );
		ReplaceISA( &lpaf->DDA.lpisaTableOwner,		lpddainfo->lpisaTableOwner );
		ReplaceISA( &lpaf->DDA.lpisaTableName,		lpddainfo->lpisaTableName );
	}
	return;
}/* end DoSQLPrimaryKeys */


static void DoSQLForeignKeys()
{
	SQLForeignKeysRec	*info = &(*hglobs)->SQLForeignKeysInfo;
	RETCODE				retcode;
	LPAF				lpaf;


	ifn = ifnForeignKeys;
	lpaf = *LplpafFromHstmt( hstmt );

	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaTableQualifier,	lpaf->DDA.lpisaTableQualifier );
		ReplaceISA( &lpddainfo->lpisaTableOwner,		lpaf->DDA.lpisaTableOwner );
		ReplaceISA( &lpddainfo->lpisaTableName,			lpaf->DDA.lpisaTableName );
		ReplaceISA( &lpddainfo->lpisaFkTableQualifier,	lpaf->ForeignKeys.lpisaFkTableQualifier );
		ReplaceISA( &lpddainfo->lpisaFkTableOwner,		lpaf->ForeignKeys.lpisaFkTableOwner );
		ReplaceISA( &lpddainfo->lpisaFkTableName,		lpaf->ForeignKeys.lpisaFkTableName );
	}


	if( !GetSQLForeignKeys( info ) )							/*** DIALOG	***/
		return;


	Pas2Ccopy( info->QualifierText,		lpddainfo->lpisaTableQualifier->sz	);
	Pas2Ccopy( info->OwnerText,			lpddainfo->lpisaTableOwner->sz		);
	Pas2Ccopy( info->NameText,			lpddainfo->lpisaTableName->sz		);
	Pas2Ccopy( info->FKqualifierText,	lpddainfo->lpisaFkTableQualifier->sz	);
	Pas2Ccopy( info->FKownerText,		lpddainfo->lpisaFkTableOwner->sz		);
	Pas2Ccopy( info->FKnameText,		lpddainfo->lpisaFkTableName->sz		);

	lpddainfo->lpisaTableQualifier->cb		= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaTableOwner->cb			= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaTableName->cb			= getTextCount( info->cbNameText );

	lpddainfo->lpisaFkTableQualifier->cb	= getTextCount( info->cbFKqualifierText );
	lpddainfo->lpisaFkTableOwner->cb		= getTextCount( info->cbFKownerText );
	lpddainfo->lpisaFkTableName->cb			= getTextCount( info->cbFKnameText );


/*****************************	#60 SQLForeignKeys	***************************/

	retcode = SQLForeignKeys(	hstmt,
								LszAndCbOfLpisa( lpddainfo->lpisaTableQualifier ),
								LszAndCbOfLpisa( lpddainfo->lpisaTableOwner ),
								LszAndCbOfLpisa( lpddainfo->lpisaTableName ),
								LszAndCbOfLpisa( lpddainfo->lpisaFkTableQualifier ),
								LszAndCbOfLpisa( lpddainfo->lpisaFkTableOwner ),
								LszAndCbOfLpisa( lpddainfo->lpisaFkTableName ) );

	EchoRetcode( sz_SQLForeignKeys, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->DDA.lpisaTableQualifier,				lpddainfo->lpisaTableQualifier );
		ReplaceISA( &lpaf->DDA.lpisaTableOwner,					lpddainfo->lpisaTableOwner );
		ReplaceISA( &lpaf->DDA.lpisaTableName,					lpddainfo->lpisaTableName );
		ReplaceISA( &lpaf->ForeignKeys.lpisaFkTableQualifier,	lpddainfo->lpisaFkTableQualifier );
		ReplaceISA( &lpaf->ForeignKeys.lpisaFkTableOwner,		lpddainfo->lpisaFkTableOwner );
		ReplaceISA( &lpaf->ForeignKeys.lpisaFkTableName,		lpddainfo->lpisaFkTableName );
	}
	return;
}/* end DoSQLForeignKeys */


static void DoSQLTablePrivileges()
{
	SQLTablePrivilegesRec	*info = &(*hglobs)->SQLTablePrivilegesInfo;
	RETCODE					retcode;
	LPAF					lpaf;

	ifn		= ifnTablePrivileges;
	lpaf	= *LplpafFromHstmt( hstmt );

	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaTableQualifier,	lpaf->DDA.lpisaTableQualifier );
		ReplaceISA( &lpddainfo->lpisaTableOwner,		lpaf->DDA.lpisaTableOwner );
		ReplaceISA( &lpddainfo->lpisaTableName,			lpaf->DDA.lpisaTableName );
	}


	if( !GetSQLTablePrivileges( info ) )						/*** DIALOG	***/
		return;


	Pas2Ccopy( info->QualifierText,		lpddainfo->lpisaTableQualifier->sz	);
	Pas2Ccopy( info->OwnerText,			lpddainfo->lpisaTableOwner->sz		);
	Pas2Ccopy( info->NameText,			lpddainfo->lpisaTableName->sz		);

	lpddainfo->lpisaTableQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaTableOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaTableName->cb		= getTextCount( info->cbNameText );


/*****************************	#70 SQLTablePrivileges	***********************/

	retcode = SQLTablePrivileges( hstmt,
								LszAndCbOfLpisa( lpddainfo->lpisaTableQualifier ),
								LszAndCbOfLpisa( lpddainfo->lpisaTableOwner ),
								LszAndCbOfLpisa( lpddainfo->lpisaTableName ) );

	EchoRetcode( sz_SQLTablePrivileges, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->DDA.lpisaTableQualifier,	lpddainfo->lpisaTableQualifier );
		ReplaceISA( &lpaf->DDA.lpisaTableOwner,		lpddainfo->lpisaTableOwner );
		ReplaceISA( &lpaf->DDA.lpisaTableName,		lpddainfo->lpisaTableName );
	}
	return;
}/* end DoSQLTablePrivileges */


static void DoSQLColumnPrivileges()
{
	SQLColumnPrivilegesRec	*info = &(*hglobs)->SQLColumnPrivilegesInfo;
	RETCODE					retcode;
	LPAF					lpaf;


	ifn = ifnColumnPrivileges;
	lpaf = *LplpafFromHstmt( hstmt );


	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaTableQualifier,	lpaf->DDA.lpisaTableQualifier );
		ReplaceISA( &lpddainfo->lpisaTableOwner,		lpaf->DDA.lpisaTableOwner );
		ReplaceISA( &lpddainfo->lpisaTableName,			lpaf->DDA.lpisaTableName );
		ReplaceISA( &lpddainfo->lpisaColumnName,		lpaf->Columns.lpisaColumnName );
	}

	if( !GetSQLColumnPrivileges( info ) )						/*** DIALOG	***/
		return;


	Pas2Ccopy( info->QualifierText,	lpddainfo->lpisaTableQualifier->sz	);
	Pas2Ccopy( info->OwnerText,		lpddainfo->lpisaTableOwner->sz		);
	Pas2Ccopy( info->NameText,		lpddainfo->lpisaTableName->sz		);
	Pas2Ccopy( info->ColumnText,	lpddainfo->lpisaColumnName->sz		);

	lpddainfo->lpisaTableQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaTableOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaTableName->cb		= getTextCount( info->cbNameText );
	lpddainfo->lpisaColumnName->cb		= getTextCount( info->cbColumnText );


/*****************************	#56 SQLColumnPrivileges	***********************/

	retcode = SQLColumnPrivileges( hstmt,
							LszAndCbOfLpisa( lpddainfo->lpisaTableQualifier ),
							LszAndCbOfLpisa( lpddainfo->lpisaTableOwner ),
							LszAndCbOfLpisa( lpddainfo->lpisaTableName ),
							LszAndCbOfLpisa( lpddainfo->lpisaColumnName ) );

	EchoRetcode( sz_SQLColumnPrivileges, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->DDA.lpisaTableQualifier,	lpddainfo->lpisaTableQualifier );
		ReplaceISA( &lpaf->DDA.lpisaTableOwner,		lpddainfo->lpisaTableOwner );
		ReplaceISA( &lpaf->DDA.lpisaTableName,		lpddainfo->lpisaTableName );
		ReplaceISA( &lpaf->Columns.lpisaColumnName,	lpddainfo->lpisaColumnName );
	}
	return;
}/* end DoSQLColumnPrivileges */


static void DoSQLSpecialColumns()
{
	SQLSpecialColumnsRec	*info = &(*hglobs)->SQLSpecialColumnsInfo;
	RETCODE					retcode;
	LPAF					lpaf;


	ifn = ifnSpecialColumns;

	lpaf = *LplpafFromHstmt( hstmt );
	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaTableQualifier,	lpaf->DDA.lpisaTableQualifier );
		ReplaceISA( &lpddainfo->lpisaTableOwner,		lpaf->DDA.lpisaTableOwner );
		ReplaceISA( &lpddainfo->lpisaTableName,			lpaf->DDA.lpisaTableName );

		lpddainfo->fColType  = lpaf->SpecialColumns.fColType;
		lpddainfo->fScope    = lpaf->SpecialColumns.fScope;
		lpddainfo->fNullable = lpaf->SpecialColumns.fNullable;
	}


	if( !GetSQLSpecialColumns( info ) )							/*** DIALOG	***/
		return;


	Pas2Ccopy( info->QualifierText,	lpddainfo->lpisaTableQualifier->sz	);
	Pas2Ccopy( info->OwnerText,		lpddainfo->lpisaTableOwner->sz	);
	Pas2Ccopy( info->NameText,		lpddainfo->lpisaTableName->sz	);

	lpddainfo->lpisaTableQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaTableOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaTableName->cb		= getTextCount( info->cbNameText );

	lpddainfo->fColType		= info->fColTypeChoice;
	lpddainfo->fScope		= info->fScopeChoice - 1;
	lpddainfo->fNullable	= info->fNullableChoice - 1;


/*****************************	#52 SQLSpecialColumns	***********************/

	retcode = SQLSpecialColumns( hstmt,			lpddainfo->fColType,
							LszAndCbOfLpisa(	lpddainfo->lpisaTableQualifier ),
							LszAndCbOfLpisa(	lpddainfo->lpisaTableOwner ),
							LszAndCbOfLpisa(	lpddainfo->lpisaTableName ),
												lpddainfo->fScope,
												lpddainfo->fNullable );

	EchoRetcode( sz_SQLSpecialColumns, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->DDA.lpisaTableQualifier,	lpddainfo->lpisaTableQualifier );
		ReplaceISA( &lpaf->DDA.lpisaTableOwner,		lpddainfo->lpisaTableOwner );
		ReplaceISA( &lpaf->DDA.lpisaTableName,		lpddainfo->lpisaTableName );

		lpaf->SpecialColumns.fColType  = lpddainfo->fColType;
		lpaf->SpecialColumns.fScope    = lpddainfo->fScope;
		lpaf->SpecialColumns.fNullable = lpddainfo->fNullable;
	}
	return;
}/* end DoSQLSpecialColumns */


static void DoSQLProcedures()
{
	SQLProceduresRec	*info = &(*hglobs)->SQLProceduresInfo;
	RETCODE				retcode;
	LPAF				lpaf;

	ifn = ifnProcedures;

	lpaf = *LplpafFromHstmt( hstmt );
	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaProcQualifier,	lpaf->Procedures.lpisaProcQualifier );
		ReplaceISA( &lpddainfo->lpisaProcOwner,		lpaf->Procedures.lpisaProcOwner );
		ReplaceISA( &lpddainfo->lpisaProcName,		lpaf->Procedures.lpisaProcName );
	}


	if( !GetSQLProcedures( info ) )								/*** DIALOG	***/
		return;

	Pas2Ccopy( info->QualifierText,		lpddainfo->lpisaProcQualifier->sz	);
	Pas2Ccopy( info->OwnerText,			lpddainfo->lpisaProcOwner->sz		);
	Pas2Ccopy( info->NameText,			lpddainfo->lpisaProcName->sz		);

	lpddainfo->lpisaProcQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaProcOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaProcName->cb		= getTextCount( info->cbNameText );


/*****************************	#67 SQLProcedures	***************************/

	retcode = SQLProcedures(	hstmt,
								LszAndCbOfLpisa( lpddainfo->lpisaProcQualifier	),
								LszAndCbOfLpisa( lpddainfo->lpisaProcOwner		),
								LszAndCbOfLpisa( lpddainfo->lpisaProcName		) );

	EchoRetcode( sz_SQLProcedures, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->Procedures.lpisaProcQualifier,	lpddainfo->lpisaProcQualifier );
		ReplaceISA( &lpaf->Procedures.lpisaProcOwner,		lpddainfo->lpisaProcOwner );
		ReplaceISA( &lpaf->Procedures.lpisaProcName,		lpddainfo->lpisaProcName );
	}
	return;
}/* end DoSQLProcedures */


static void DoSQLProcedureColumns()
{
	SQLProcedureColumnsRec	*info = &(*hglobs)->SQLProcedureColumnsInfo;
	RETCODE					retcode;
	LPAF					lpaf;

	ifn		= ifnProcedureColumns;
	lpaf	= *LplpafFromHstmt( hstmt );

	if( lpaf && ifn == lpaf->General.ifn )	// General is really generic struct
	{
		ReplaceISA( &lpddainfo->lpisaProcQualifier,	lpaf->Procedures.lpisaProcQualifier );
		ReplaceISA( &lpddainfo->lpisaProcOwner,		lpaf->Procedures.lpisaProcOwner );
		ReplaceISA( &lpddainfo->lpisaProcName,		lpaf->Procedures.lpisaProcName );
		ReplaceISA( &lpddainfo->lpisaColumnName,	lpaf->Columns.lpisaColumnName );
	}

	if( !GetSQLProcedureColumns( info ) )						/*** DIALOG	***/
		return;


	Pas2Ccopy( info->QualifierText,		lpddainfo->lpisaProcQualifier->sz	);
	Pas2Ccopy( info->OwnerText,			lpddainfo->lpisaProcOwner->sz		);
	Pas2Ccopy( info->NameText,			lpddainfo->lpisaProcName->sz		);
	Pas2Ccopy( info->ColNameText,		lpddainfo->lpisaColumnName->sz		);

	lpddainfo->lpisaProcQualifier->cb	= getTextCount( info->cbQualifierText );
	lpddainfo->lpisaProcOwner->cb		= getTextCount( info->cbOwnerText );
	lpddainfo->lpisaProcName->cb		= getTextCount( info->cbNameText );
	lpddainfo->lpisaColumnName->cb		= getTextCount( info->cbColNameText );


/*****************************	#66 SQLProcedureColumns	***********************/

	retcode = SQLProcedureColumns( hstmt,
								LszAndCbOfLpisa( lpddainfo->lpisaProcQualifier ),
								LszAndCbOfLpisa( lpddainfo->lpisaProcOwner ),
								LszAndCbOfLpisa( lpddainfo->lpisaProcName ),
								LszAndCbOfLpisa( lpddainfo->lpisaColumnName ));

	EchoRetcode( sz_SQLProcedureColumns, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		ReplaceISA( &lpaf->Procedures.lpisaProcQualifier,	lpddainfo->lpisaProcQualifier );
		ReplaceISA( &lpaf->Procedures.lpisaProcOwner,		lpddainfo->lpisaProcOwner );
		ReplaceISA( &lpaf->Procedures.lpisaProcName,		lpddainfo->lpisaProcName );
		ReplaceISA( &lpaf->Columns.lpisaColumnName,			lpddainfo->lpisaColumnName );
	}
	return;
}/* end DoSQLProcedureColumns */


static void DoSQLAllocEnv()
{
	SQLAllocEnvRec	*info = &(*hglobs)->SQLAllocEnvInfo;
	BOOL			fUntouched;
	RETCODE			retcode;
	HENV			henvT;
	static char		sz_aphenv[] = "*phenv";
	static char		szTitle[] = "\pStorage error";
	static char 	szMsg[] = "\pMaximum 1 environment handle per application instance.";


	if( henv )
	{
		messageBox( szMsg, szTitle, stopIcon );
		return;
	}

	if( !GetSQLAllocEnv( info ) )								/*** DIALOG	***/
		return;



	henvT = (HENV)UNTOUCHED;


/*****************************	#02 SQLAllocEnv	*******************************/

	retcode = SQLAllocEnv( info->fNull_phenv ? NULL : &henvT );

	EchoRetcode( "SQLAllocEnv", retcode );

	fUntouched = henvT == (HENV)UNTOUCHED;
	if( retcode >= SQL_ERROR && !info->fNull_phenv )
		DisplayUntouchedError( sz_aphenv, fUntouched, FALSE );

	if( fUntouched || retcode < SQL_SUCCESS )
	{
		if( !fUntouched && retcode == SQL_ERROR && henvT != SQL_NULL_HENV )
		{
			szWrite( sz_Error,  FALSE );
			szWrite( sz_aphenv, FALSE );
			wsprintf( OutStr, szFormatSSError,
							(LPSTR)szNotEqual, (LPSTR)sz_SQL_NULL_HENV );
			szWrite( OutStr, TRUE );
		}
	}
	else
	{
		static BYTE szFormat[] = "henv = %s.";

		if( henvT == SQL_NULL_HENV )
		{
			szWrite( sz_Error,  FALSE );
			szWrite( sz_aphenv, FALSE );
			wsprintf( OutStr, szFormatSSError,
				(LPSTR)szEqual, (LPSTR)sz_SQL_NULL_HENV );
			szWrite( OutStr, TRUE );
		}
		henv = henvT;
		wsprintf( OutStr, szFormat,
		//	LszIfSz( henv == SQL_NULL_HENV ? sz_SQL_NULL_HENV : sz_VALID ));
				henv == SQL_NULL_HENV ? sz_SQL_NULL_HENV : sz_VALID );
		szWrite( OutStr, TRUE );
	}
	return;
}/* end DoSQLAllocEnv */


static void DoSQLAllocConnect()
{
	SQLAllocConnectRec	*info = &(*hglobs)->SQLAllocConnectInfo;
	static BYTE CSCONST sz_aphdbc[] = "*phdbc";
	static BYTE CSCONST szTitle[]	= "\pMaximum Connections Allocated";
	static BYTE CSCONST szMsg[]		= "Maximum %d connection handles supported.";

	BOOL				fUntouched;
	RETCODE				retcode;
	HDBC				hdbcT = (HDBC)UNTOUCHED;
	SERVERINFO 			*lpserverinfo;

#ifdef CRAP
		//look for free slot
	for( lpserverinfo = &lrgserverinfo[0];
		 lpserverinfo < lpserverinfoMax; lpserverinfo++ )
	{
		if( lpserverinfo->hdbc    == NULL
		 && lpserverinfo->fStatus == Unused )
			break;
	}
#else
	lpserverinfo = &lrgserverinfo[ idbcMax ];
#endif CRAP

	if( lpserverinfo == lpserverinfoMax )
	{
		wsprintf( OutStr, szMsg, MAX_CONNECTIONS );
		c2pstr( OutStr );
		messageBox( OutStr, szTitle, stopIcon );
		return;
	}

	if( !GetSQLAllocConnect( info ) )							/*** DIALOG	***/
		return;


/*****************************	#01 SQLAllocConnect	***************************/

	retcode = SQLAllocConnect(	info->NullHenvChecked     ? NULL : henv,
								info->NullPhdbcOutChecked ? NULL : &hdbcT );

	EchoRetcode( sz_SQLAllocConnect, retcode );

	fUntouched = hdbcT == (HDBC)UNTOUCHED;
	if( retcode >= SQL_ERROR && !info->NullPhdbcOutChecked )
		DisplayUntouchedError( sz_aphdbc, fUntouched, FALSE );

	if( !fUntouched && retcode == SQL_ERROR && hdbcT != SQL_NULL_HDBC )
	{
		szWrite( sz_Error, FALSE );
		szWrite( sz_aphdbc, FALSE );
		wsprintf( OutStr, szFormatSSError,
									(LPSTR)szNotEqual, (LPSTR)sz_SQL_NULL_HDBC );
		szWrite( OutStr, TRUE );
	}
	if( retcode < SQL_SUCCESS || fUntouched )
		return;

	lpserverinfo->idbc		= idbc = ++idbcMax;
	lpserverinfo->hdbc		= hdbc = hdbcT;
	lpserverinfo->fStatus	= Allocated;

	AppendMenu( DBCpop.hMenu, "\p333" );
	sprintf( OutStr, "%-d: %s", idbc, sz_UNCONNECTED_SERVER );
	strcpy( lpserverinfo->szName, OutStr );
	c2pstr( OutStr );
	DBCpop.choice = idbc+1;
	SetItem( DBCpop.hMenu, DBCpop.choice, OutStr );
	CalcMenuSize( DBCpop.hMenu );
	refreshDBCpop();

	sprintf( hdbcText, "#%-d", idbc );
	c2pstr( hdbcText );

	return;
}/* end DoSQLAllocConnect */


void initPopWithDSNs( MenuHandle menu )		/* called from GetSQLConnect	*/
{
	char	szdsn[ SQL_MAX_DSN_LENGTH + 1 ], szdescription[ 4 ];
	SWORD	cbdsn, cbdescription;
	RETCODE	retcode;

	for(;;)
	{
		retcode = SQLDataSources( henv, SQL_FETCH_NEXT,
					szdsn,			SQL_MAX_DSN_LENGTH,			&cbdsn,
					szdescription,	sizeof( szdescription ),	&cbdescription );
		if( retcode == SQL_SUCCESS
		 || (retcode == SQL_SUCCESS_WITH_INFO && cbdsn <= SQL_MAX_DSN_LENGTH) )
		{
			c2pstr( szdsn );
			AppendMenu( menu, szdsn );
		}

		if( retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO )
			break;
	}
	return;
}/* end initPopWithDSNs */


static void DoSQLConnect()
{
	SQLConnectRec	*info = &(*hglobs)->SQLConnectInfo;
	SERVERINFO		*lpserverinfo;
	RETCODE			retcode;

	if( !GetSQLConnect( info ) )								/*** DIALOG	***/
		return;

	Pas2Ccopy( info->szDSNText,		lpconninfo->lpisaDSN->sz		);
	Pas2Ccopy( info->szUIDText,		lpconninfo->lpisaUID->sz		);
	Pas2Ccopy( info->szAuthStrText,	lpconninfo->lpisaAuthStr->sz	);

	lpconninfo->lpisaDSN->cb		= getTextCount( info->cbDSNText );
	lpconninfo->lpisaUID->cb		= getTextCount( info->cbUIDText );
	lpconninfo->lpisaAuthStr->cb	= getTextCount( info->cbAuthStrText );

	DisplayISAs( sz_DSN,     lpconninfo->lpisaDSN );	szWrite( szComma, FALSE );
	DisplayISAs( sz_UID,     lpconninfo->lpisaUID );	szWrite( szComma, FALSE );
	DisplayISAs( sz_AuthStr, lpconninfo->lpisaAuthStr );szWrite( szColon, TRUE );


/*****************************	#07 SQLConnect	*******************************/

	retcode = SQLConnect( hdbc,	LszAndCbOfLpisa( lpconninfo->lpisaDSN ),
								LszAndCbOfLpisa( lpconninfo->lpisaUID ),
								LszAndCbOfLpisa( lpconninfo->lpisaAuthStr ) );

	EchoRetcode( sz_SQLConnect, retcode );

	if( retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO )
		return;

	if( fDriverMenus )
	{
		AllErrors();
	//	InitializeMenuTable();
	}

	lpserverinfo = LpserverinfoFromHdbc( hdbc );
	if( lpserverinfo )
	{
		lpserverinfo->hdbc		= hdbc;
		lpserverinfo->fStatus	= Connected;
		sprintf( lpserverinfo->szName, "%-d: %s", idbc, lpconninfo->lpisaDSN->sz );
		strcpy( OutStr, lpserverinfo->szName );
		DBCpop.choice = lpserverinfo->idbc + 1;
		c2pstr( OutStr );
		SetItem( DBCpop.hMenu, DBCpop.choice, OutStr );
		refreshDBCpop();
	}
	return;
}/* end DoSQLConnect */


void EitherConnect( BOOL fDriver )	/** SQLBrowseConnect & SQLDriverConnect	**/
{
	static BYTE CSCONST sz_apcbConnStrOut[] = "*pcbConnStrOut";
	static BYTE CSCONST sz_szConnStrOut[]   = "szConnStrOut";
	static BYTE CSCONST sz_DEFAULT[]        = "Default";

	RETCODE		retcode;
	SERVERINFO	*lpserverinfo;
	LPSTR		lszConnStrOut;
	LPSTR		lszFuncName;
	SWORD		*lpcbConnStrOut;

	LPISA		lpisa;
	SWORD		ich;
	SWORD		cbTouched;

	if( fDriver )
		 lszFuncName = sz_SQLDriverConnect;
	else lszFuncName = sz_SQLBrowseConnect;

	lszConnStrOut  = AllocateBuffer( fNull_szConnStrOut,  lpconninfo->cbConnStrOutMax );
	lpcbConnStrOut = AllocateBuffer( fNull_pcbConnStrOut, sizeof( UWORD ) );

	if( fDriver )
	{	retcode = SQLDriverConnect( hdbc,
									fNull_hwnd ? NULL : lpconninfo->hwnd,
									LszAndCbOfLpisa( lpconninfo->lpisaConnStrIn ),
									lszConnStrOut,
									lpconninfo->cbConnStrOutMax,
									lpcbConnStrOut,
									lpconninfo->fDriverCompletion );
	}
	else
	{	retcode = SQLBrowseConnect( hdbc,
									LszAndCbOfLpisa( lpconninfo->lpisaConnStrIn ),
									lszConnStrOut,
									lpconninfo->cbConnStrOutMax,
									lpcbConnStrOut );
	}

	EchoRetcode( lszFuncName, retcode );

	FDisplayCbAndRgbArgs(	retcode, NEED_DATA_OK, SQL_C_CHAR,
							sz_apcbConnStrOut,			lpcbConnStrOut,
							lpconninfo->cbConnStrOutMax,
							sz_szConnStrOut,			lszConnStrOut );

	if( retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO
	 && (fDriver || retcode != SQL_NEED_DATA ) )
	{
		lpserverinfo = LpserverinfoFromHdbc( hdbc );
		if( lpserverinfo )
			lpserverinfo->fStatus = Allocated;
		goto Done;
	}

	sprintf( OutStr, "%-d:", idbc );

	lpisa = lpconninfo->lpisaConnStrIn;
	ich = strlen( OutStr );
	cbTouched =
			 (SWORD)CbTouchedRgbCbMax( lszConnStrOut, lpconninfo->cbConnStrOutMax );

	if( !lpisa->fNull && cbTouched > 0 )
	{
			// Copy szConnStrOut to szConnStrIn:

		SWORD	cbDefault = cbTouched - (lszConnStrOut[ cbTouched-1 ] == '\0' );
		SWORD	cb = lpisa->cb == SQL_NTS ? SQL_NTS : cbDefault;

		ReleaseISA( lpisa );
		lpconninfo->lpisaConnStrIn = lpisa =
							LpisaCreateISA( FALSE, cbTouched, cbDefault, cb );
		memcpy( lpisa->sz, lszConnStrOut, cbTouched );
	}

	lpserverinfo = LpserverinfoFromHdbc( hdbc );
	if( lpserverinfo )
	{
		lpserverinfo->fStatus = Connected;

		if( retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO )
			goto Done;

		OutStr[ MAX_SERVERNAME - 1 ] = 0;
		strcpy( lpserverinfo->szName, OutStr );
	}

	if( !lpisa->fNull )
	{	LPSTR		lpchMic = strstr( lpisa->sz, sz_DSNequal );

		if( lpchMic )
		{	LPSTR	lpchMax;

			lpchMax = &lpisa->sz[ lpisa->cb == SQL_NTS ? lpisa->cbDefault : lpisa->cb ];

			lpchMic +=  sizeof sz_DSNequal - 1;
			if( lpchMic <= lpchMax )
			{
				LPSTR lpchMac = strchr( lpchMic, ';' );
				char buf[ sizeof sz_DEFAULT ];
				
				if( lpchMac == NULL || lpchMac > lpchMax )
						lpchMac = lpchMax;

				if( !fDriver && strchr( lpchMic, ';' ) == lpchMic )
				{
					strcpy( buf, sz_DEFAULT );
					lpchMic = buf;
					lpchMac = lpchMic + sizeof sz_DEFAULT - 1;
				}

				CchGetStringDisplay( &OutStr[ ich ], OUTSTRLEN - ich,
							lpchMic, (SWORD)(lpchMac - lpchMic), LENGTH_TERM );
			}
		}
			
	}
	if( OutStr[ ich ] == '\0' )
	{
		if(  lszConnStrOut
		 && lpconninfo->cbConnStrOutMax > sizeof sz_DSNequal - 1 )
		{
			static BYTE CSCONST szMsg[] = "No 'DSN=' in szConnStrOut.";

			szWrite( sz_Error,	FALSE );
			szWrite( szMsg,		TRUE  );
		}
		strcpy( &OutStr[ ich ], sz_UNKNOWN_SERVER );
	}

//	ChangeSelectedComboBoxEntry( hwndHdbcList, OutStr );
	DBCpop.choice = idbc + 1;
	c2pstr( OutStr );
	SetItem( DBCpop.hMenu, DBCpop.choice, OutStr );
	refreshDBCpop();

	if( fDriverMenus )
	{
		AllErrors();
	//	InitializeMenuTable();
	}
Done:
	ReleaseMemory( lszConnStrOut  );
	ReleaseMemory( lpcbConnStrOut );
	return;
}/* end EitherConnect */


static void DoSQLBrowseConnect()
{
	SQLBrowseConnectRec	*info = &(*hglobs)->SQLBrowseConnectInfo;


	fDriverConnect		= FALSE;
	GetPort( (GrafPtr*)lpconninfo->hwnd );

	strcpy( info->szConnStrInText, ";DSN=DSNsample;" );
	c2pstr( info->szConnStrInText );

	if( !GetSQLBrowseConnect( info ) )							/*** DIALOG	***/
		return;

	Pas2Ccopy( info->szConnStrInText, lpconninfo->lpisaConnStrIn->sz );
	lpconninfo->lpisaConnStrIn->cb	= getTextCount( info->cbConnStrInText );
	StringToNum( info->MaxText, &gNum );
	lpconninfo->cbConnStrOutMax = gNum;

	
/*****************************	#55 SQLBrowseConnect	***********************/

	EitherConnect( FALSE );
	UpdateStatementList();
	return;
}/* end DoSQLBrowseConnect */


static void DoSQLDriverConnect()
{
	SQLDriverConnectRec		*info = &(*hglobs)->SQLDriverConnectInfo;

	fDriverConnect = TRUE;
	GetPort( (GrafPtr*)lpconninfo->hwnd );

	if( !GetSQLDriverConnect( info ) )
		return;

	Pas2Ccopy( info->szConnStrInText, lpconninfo->lpisaConnStrIn->sz );
	lpconninfo->lpisaConnStrIn->cb	= getTextCount( info->cbConnStrInText );
	lpconninfo->fDriverCompletion	= info->fDriverCompletionChoice - 1;

/*****************************	#41 SQLDriverConnect	***********************/

	EitherConnect( TRUE );
	UpdateStatementList();
	return;
}/* end DoSQLDriverConnect */


static void DoSQLDisconnect()
{
	SERVERINFO	*lpserverinfo;
	STMTINFO 	*lpstmtinfo;
	RETCODE		retcode;


	retcode = SQLDisconnect( hdbc );			/***	#09 SQLDisconnect	***/

	EchoRetcode( sz_SQLDisconnect, retcode );

	if( retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO
	 || (lpserverinfo = LpserverinfoFromHdbc( hdbc )) == NULL )
		return;

	ReleaseMemory( lpserverinfo->rgbMenuStatus );
	lpserverinfo->rgbMenuStatus = NULL;

	for( lpstmtinfo = &lrgstmtinfo[0]; lpstmtinfo <  lpstmtinfoMax; lpstmtinfo++ )
	{
		if( lpstmtinfo->hdbc == hdbc )
		{
			lpstmtinfo->hdbc	= NULL;
			lpstmtinfo->hstmt	= NULL;
		}
	}

	sprintf( OutStr, "%-d: %s", idbc, sz_UNCONNECTED_SERVER );
	c2pstr( OutStr );
	SetItem( DBCpop.hMenu, idbc+1, OutStr );

	lpserverinfo->fStatus = Allocated;
	strcpy( lpserverinfo->szName, OutStr );

		/* free all associated STMTs:	*/

	for( lpstmtinfo = &lrgstmtinfo[0]; lpstmtinfo <  lpstmtinfoMax; lpstmtinfo++ )
	{	if( lpstmtinfo->hdbc == hdbc )
		{
			FreeParamsAndCols( FREE_BOTH, lpstmtinfo->hstmt );
			lpstmtinfo->hstmt	= NULL;
			lpstmtinfo->hdbc	= NULL;
		}
	}
	refreshDBCpop();
	return;
}/* end DoSQLDisconnect */


static void DoSQLFreeConnect()
{
	RETCODE		retcode;
	SERVERINFO	*lpserverinfo;

	retcode = SQLFreeConnect( hdbc );

	EchoRetcode( sz_SQLFreeConnect, retcode );

	if( retcode == SQL_SUCCESS )
	{	lpserverinfo = LpserverinfoFromHdbc( hdbc );
		if( lpserverinfo )
		{
			lpserverinfo->hdbc		= NULL;
			lpserverinfo->fStatus	= Unused;
			DBCpop.choice = 1;
			UpdateCurrentHdbc();
			DisableItem( DBCpop.hMenu, lpserverinfo->idbc+1 );
			refreshDBCpop();
		}
	}
	hdbc = SQL_NULL_HDBC;
	return;
}/* end DoSQLFreeConnect */


static void DoSQLFreeEnv()
{
	RETCODE retcode;


	retcode = SQLFreeEnv( henv );
	if( retcode == SQL_SUCCESS )
		henv = SQL_NULL_HENV;

	EchoRetcode( "SQLFreeEnv", retcode );
	return;
}/* end DoSQLFreeEnv */


	static FNAM CSCONST rgfnam_fDirection[] =
		{
			{ SQL_FETCH_NEXT,	sz_SQL_FETCH_NEXT	},
			{ SQL_FETCH_FIRST,	sz_SQL_FETCH_FIRST	}
		};
	DeclareFinfo( fDirection, "SQL_FETCH_", FINFO_UWORD, static );


static void DoSQLDataSources()
{
	SQLDataSourcesRec		*info = &(*hglobs)->SQLDataSourcesInfo;
	static BYTE CSCONST		sz_szDSN[]           = "szDSN";
	static BYTE CSCONST		sz_apcbDSN[]         = "*pcbDSN";
	static BYTE CSCONST		sz_szDescription[]   = "szDescription";
	static BYTE CSCONST		sz_apcbDescription[] = "*pcbDescription";
	static BYTE CSCONST		szFormatCbMaxs[]     =
										", cbDSNMax = %d, cbDescriptionMax = %d:";
	RETCODE		retcode;
	UCHAR		*lszDSN,	*lszDescription;
	SWORD		*lpcbDSN,	*lpcbDescription;


	if( !GetSQLDataSources( info ) )							/*** DIALOG	***/
		return;

	if( info->fDirectionChoice != 1 )
		fDirection = SQL_FETCH_FIRST;
		fDirection = SQL_FETCH_NEXT;

	StringToNum( info->cbDSNMaxText,  &gNum );		cbDSNMax			= gNum;
	StringToNum( info->cbDescMaxText, &gNum );		cbDescriptionMax	= gNum;

	fNull_henv				= info->NullHenvChecked;
	fNull_szDSN				= info->NullSzDSNOutChecked;
	fNull_pcbDSN			= info->NullPcbDSNOutChecked;
	fNull_szDescription		= info->NullSzDescriptionOutChecked;
	fNull_pcbDescription	= info->NullPcbDescriptionOutChecked;

	lszDSN			= AllocateBuffer( fNull_szDSN, cbDSNMax );
	lpcbDSN			= AllocateBuffer( fNull_pcbDSN, sizeof( SWORD ) );
	lszDescription	= AllocateBuffer( fNull_szDescription, cbDescriptionMax );
	lpcbDescription	= AllocateBuffer( fNull_pcbDescription, sizeof( SWORD ) );


/*****************************	#57 SQLDataSources	***************************/

	retcode = SQLDataSources( fNull_henv ? SQL_NULL_HENV : henv,	fDirection,
						lszDSN,			cbDSNMax,			lpcbDSN,
						lszDescription,	cbDescriptionMax,	lpcbDescription );

	szWrite( sz_fDirection,	FALSE );
	szWrite( szEqual,		FALSE );
	szWrite( SzConstDisplay(	LszNameFromFlagArg( &finfo_fDirection, fDirection ),
								fDirection ),
			FALSE );
	wsprintf( OutStr, szFormatCbMaxs, cbDSNMax, cbDescriptionMax );
	szWrite( OutStr, TRUE );
	EchoRetcode( sz_SQLDataSources, retcode );

	FDisplayCbAndRgbArgs( retcode, MID_LINE, SQL_C_CHAR,
		sz_apcbDSN, lpcbDSN, cbDSNMax,
		sz_szDSN, lszDSN);

	if( FNeedSeparator() )
		szWrite( szComma, TRUE );

	FDisplayCbAndRgbArgs(	retcode, 0, SQL_C_CHAR,
							sz_apcbDescription, lpcbDescription, cbDescriptionMax,
							sz_szDescription, lszDescription );

	ReleaseMemory( lpcbDSN );
	ReleaseMemory( lszDSN );
	ReleaseMemory( lpcbDescription );
	ReleaseMemory( lszDescription );

	return;
}/* end DoSQLDataSources */


static void DoSQLGetInfo()
{
	SQLGetInfoRec	*info = &(*hglobs)->SQLGetInfoInfo;
	RETCODE			retcode;
	LPBYTE			lrgbInfoValue;
	SWORD			*lpcbInfoValue;


	if( !GetSQLGetInfo( info ) )								/*** DIALOG	***/
		return;

	fInfoType = info->fInfoTypeChoice - 1;

	StringToNum( info->cbMaxText, &gNum );
	cbInfoValueMax = gNum;

	fNull_rgbInfoValue = info->NullRgbInfoValueOutChecked;
	fNull_pcbInfoValue = info->NullPcbInfoValueOutChecked;

	lrgbInfoValue = AllocateBuffer( fNull_rgbInfoValue, cbInfoValueMax );
	lpcbInfoValue = AllocateBuffer( fNull_pcbInfoValue, sizeof( SWORD ) );

	if( fInfoType == SQL_DRIVER_HSTMT && lrgbInfoValue )
		memcpy(	lrgbInfoValue, (BYTE*)&hstmt,
				MIN( sizeof( HSTMT ), cbInfoValueMax ) );


/*****************************	#45 SQLGetInfo	*******************************/

	retcode = SQLGetInfo(	hdbc, fInfoType,
							lrgbInfoValue, cbInfoValueMax, lpcbInfoValue );

	DisplayGetInfo( retcode, fInfoType, TRUE,
					lrgbInfoValue, cbInfoValueMax, lpcbInfoValue );

	ReleaseMemory( lrgbInfoValue );
	ReleaseMemory( lpcbInfoValue );
	return;
}/* end DoSQLGetInfo */


static void DoFullConnect()
{
	FullConnectRec		FullConnectInfo;
	FullConnectRecPtr	info;

	info = &FullConnectInfo;
		/* initialize FullConnect info	*/
	info->UserIDText [0]		= 0;
	info->PasswordText [0]	= 0;
	info->DataSourceChoice		= 1;
	info->DataSourceText [0]	= 0;
	
	if( GetFullConnect( &FullConnectInfo ) )
	{
		/* use FullConnect info	*/
	}
	return;
}/* end DoFullConnect */


static void DoFullDisconnect()
{
	return;
}/* end DoFullDisconnect */


static void DoDataSourcesAll()
{
	static char CSCONST		sz_name[] = "name:";
	static char CSCONST		sz_description[] = "description:";
	RETCODE					returncode = SQL_SUCCESS;
#define NAMESIZE 40
	char  					sz[ NAMESIZE ];


	szWrite( sz_name, FALSE );
	WriteTab( 3, lstrlen( sz_name ) );
	szWrite( sz_description, TRUE );

	for( returncode = SQLDataSources( henv, SQL_FETCH_FIRST, sz, NAMESIZE, NULL,
										OutStr, OUTSTRLEN, NULL)
		;returncode == SQL_SUCCESS
		;returncode = SQLDataSources( henv, SQL_FETCH_NEXT, sz, NAMESIZE, NULL,
										OutStr, OUTSTRLEN, NULL ) )
	{
			/* force null termination on the buffers.  Since this is a
				tool, not a test, don't need to verify any correctness
				of results, just print what is returned */
		sz[ NAMESIZE - 1 ] = 0;
		OutStr[ OUTSTRLEN - 1 ] = 0;
		szWrite( sz, FALSE );
		WriteTab( 3, strlen( sz ) );
		szWrite( OutStr, TRUE );
	}/* end FOR */

	if( returncode != SQL_NO_DATA_FOUND )
		EchoRetcode( sz_SQLDataSources, returncode );
	return;
}/* end DoDataSourcesAll */


static void DoGetInfoAll()
{
	return;
}/* end DoGetInfoAll */


void DoConnect( short itemNr )
{
	switch( itemNr )
	{
	case ConnectSQLAllocEnv:		DoSQLAllocEnv();		break;
	case ConnectSQLAllocConnect:	DoSQLAllocConnect();	break;
	case ConnectSQLConnect:			DoSQLConnect();			break;
	case ConnectSQLBrowseConnect:	DoSQLBrowseConnect();	break;
	case ConnectSQLDriverConnect:	DoSQLDriverConnect();	break;
	case ConnectSQLDisconnect:		DoSQLDisconnect();		break;
	case ConnectSQLFreeConnect:		DoSQLFreeConnect();		break;
	case ConnectSQLFreeEnv:			DoSQLFreeEnv();			break;
	case ConnectSQLDataSources:		DoSQLDataSources();		break;
	case ConnectSQLGetInfo:			DoSQLGetInfo();			break;
	case ConnectFullConnect:		DoFullConnect();		break;
	case ConnectFullDisconnect:		DoFullDisconnect();		break;
	case ConnectDataSourcesAll:		DoDataSourcesAll();		break;
	case ConnectGetInfoAll:			DoGetInfoAll();			break;
	}/* end SWITCH */
	return;
}/* end DoConnect */


static void DoCut()
{
	if( cur->text )
	{
		TECut( cur->text );
		cur->dirty = true;
		scrapDirty = true;
	}
}/* end DoCut*/


static void DoCopy()
{
	if( cur->text )
	{
		TECopy( cur->text );
		scrapDirty = true;
	}
}/* end DoCopy*/


static void DoPaste()
{
	if( cur->text )
	{
		TEPaste( cur->text );
		cur->dirty = true;
	}
	return;
}/* end DoPaste */


static void DoDelete()
{
	return;
}/* end DoDelete */


static void DoClear()
{
	if( cur->text )
	{
		TEDelete( cur->text );
		cur->dirty = true;
	}
	return;
}/* end DoClear*/


static void DoWordWrap()
{
	return;
}/* end DoWordWrap */


static void DoSelectAll()
{
	if( cur->text )
	{
		TESetSelect( 0, 32767, cur->text );
	}
	return;
}/* end DoSelectAll */


static void DoShowClipboard()
{
	return;
}/* end DoShowClipboard */


#define dialogTop		75                                   
#define dialogLeft		85


	short			numOpenTypes;
	SFTypeList		openTypeList;


void InitFileM()
{
	numOpenTypes = 1;
	openTypeList[ 0 ] = kFileType;
	return;
}/* end InitFileM */


Boolean OkToOpen( OSType fType )
{
	short			i;
	enum {searching, found, notFound}	status;

	i = 0;
	status = searching;
	while (status == searching )
	{
		if( i >= numOpenTypes )
			status = notFound;
		else
		{	if( fType == openTypeList[ i ] )
				status = found;
			else
				i++;
		}
	}
	return (status == found);
}/* end OkToOpen */


static void DoNew()
{
	OpenODBCtest( "\p", 0, 0 );
	InitAppData();
	return;
}/* end DoNew */


void OpenDoc( Str255 fileName, short vRefNum )
{
	/* This *should* be defined in an Apple interface file: */
#define StationeryFlag	0x0800

	Boolean			isStationery;
	FInfo			finderInfo;
	short			fRefNum;

	isStationery = FALSE;
	if( GetFInfo( fileName, vRefNum, &finderInfo ) == noErr )
	{
		if( finderInfo.fdFlags & StationeryFlag )
			isStationery = true;
	}
	if( OpenAppFile( vRefNum, fileName, &fRefNum ) )
	{
		if( isStationery )
		{
			OpenODBCtest( "\p", 0, 0 );
			ReadAppFile(  fRefNum );
			CloseAppFile( fRefNum );
		}
		else
		{
			OpenODBCtest( fileName, vRefNum, fRefNum );
			ReadAppFile( fRefNum );
		}
	}
	return;
}/* end OpenDoc */
 

static void DoOpen()
{
	Point			dialogOrigin;
	SFReply			sfInfo;

	SetPt( &dialogOrigin, dialogLeft, dialogTop);
	SFGetFile( dialogOrigin, "\p", nil, numOpenTypes, openTypeList, nil, &sfInfo);
	if( sfInfo.good )
	{
		OpenDoc( sfInfo.fName, sfInfo.vRefNum );
	}
	return;
}/* end DoOpen */
 

void OpenApp()
{
	DoNew();
	return;
}/* end OpenApp */
 

static void DoSaveAs()
{
	SFReply			sfInfo;
	short			fRefNum;
	StringHandle	prompt;
	Str255			suggestion;
	
	prompt = GetString( SaveAsPromptID );
	suggestion[ 0 ] = 0;

	if( CreateFile( &sfInfo, *prompt, suggestion, kSignature, kFileType ) )
	{
		CloseAppFile( cur->fileNum);
		if( OpenAppFile (sfInfo.vRefNum, sfInfo.fName, &fRefNum ) )
		{
			SetWTitle( curWindow, sfInfo.fName);
			cur->fileNum = fRefNum;
			cur->volNum = sfInfo.vRefNum;
			WriteAppFile( cur->fileNum);
			cur->dirty = FALSE;
		}
		else
		{		/*should never happen */
			SetWTitle( curWindow, "\p???" );
			cur->fileNum = 0;
			cur->volNum = 0;
		}
	}
	return;
}/* end DoSaveAs */
 

static void DoSave()
{
	if( cur->fileNum == 0 )
		DoSaveAs();
	else
	{
		WriteAppFile( cur->fileNum );
		cur->dirty = FALSE;
	}
	return;
}/* end DoSave */
 

static void CloseAppWindow()
{
	enum {saveItem = 1, cancelItem, discardItem};

	Str255			curTitle;
	short			itemNum;
	Boolean			okay;

	okay = true;
	SetInfo( FrontWindow() );
	if( cur->dirty )
	{
		GetWTitle( curWindow, curTitle );
		ParamText( curTitle, "\p", "\p", "\p" );
		InitCursor();
		itemNum = Alert( SaveID, nil );
		switch( itemNum )
		{
		case saveItem:		DoSave();			okay = !errorFlag;		break;
		case discardItem:	/* Do nothing	*/;							break;
		case cancelItem:	errorFlag = true;	okay = FALSE;			break;
		}
	}
	if( okay )
	{
		DisposeAppData();
		if( cur->windowKind == 1 )
		{		/* 1st or only window in set */
			CloseAppFile( cur->fileNum );
		}
		CloseCurWindow();
	}
	return;
}/* end CloseAppWindow */


void DoClose()
{
	WindowPeek		frontPeek;

	errorFlag = FALSE;

	frontPeek = (WindowPeek)FrontWindow();
	if( frontPeek->windowKind < 0 )
	{
		CloseDeskAcc( frontPeek->windowKind );
	}
	else if( frontPeek->windowKind == dialogKind )
	{
	}
	else
	{
		CloseAppWindow();
	}
	return;
}/* end DoClose */


void DoQuit()
{
	Boolean		quitting = TRUE;                             


	SQLFreeEnv( henv );		// unload the Driver Manager & Driver function sets

	while( quitting && FrontWindow() )
	{
		SystemTask();
		DoClose();
		if( errorFlag )
			quitting = FALSE;
	}

	if( quitting )
		quittingTime = TRUE;
	return;
}/* end DoQuit */


static void DoSQLTransact()
{
	SQLTransactRec	*info = &(*hglobs)->SQLTransactInfo;
	RETCODE			retcode;


	if( !GetSQLTransact( info ) )								/*** DIALOG	***/
		return;

	fType = info->fTypeChoice - 1;
	fNull_henv = info->NullHenvChecked;
	fNull_hdbc = info->NullHdbcChecked;

	DisplayValidHandles( fNull_henv, fNull_hdbc, TRUE );
	szWrite( szColon, TRUE );


/*****************************	#23 SQLTransact	*******************************/

	retcode = SQLTransact(	fNull_henv ? SQL_NULL_HENV : henv,
							fNull_hdbc ? SQL_NULL_HDBC : hdbc,
							fType );

	EchoRetcode( sz_SQLTransact, retcode );
	return;
}/* end DoSQLTransact */


static void DoSQLCancel()
{
	RETCODE		retcode;


	retcode = SQLCancel( hstmt );
	EchoRetcode( sz_SQLCancel, retcode );
	return;
}/* end DoSQLCancel */


static void DoSQLError()
{
	SQLErrorRec	*info = &(*hglobs)->SQLErrorInfo;
	RETCODE		retcode;
	UCHAR		szSqlState[ SQL_SQLSTATE_SIZE + 2 ];// +2 for null term & check byte
	SDWORD		fNativeError;
	SWORD		cbErrorMsg;
	UCHAR		*lszSqlState;
	UCHAR		*lszErrorMsg;
	SWORD		*lpcbErrorMsg;
	SDWORD		*lpfNativeError;
	static BYTE	szFormat[] = "; cbErrorMsgMax = %d:";


	if( GetSQLError( info ) == FALSE )							/*** DIALOG	***/
		return;


	fNull_henv			= info->NullHenvChecked;
	fNull_hdbc			= info->NullHdbcChecked;
	fNull_hstmt			= info->NullHstmtChecked;
	fNull_szSqlState	= info->NullSzSqlStateOutChecked;
	fNull_pfNativeError	= info->NullPfNativeErrorOutChecked;
	fNull_szErrorMsg	= info->NullSzErrorMsgOutChecked;
	fNull_pcbErrorMsg	= info->NullPcbErrorMsgOutChecked;
	StringToNum( info->cbErrorMsgMaxText, &gNum );
	cbErrorMsgMax = gNum;

	DisplayValidHandles( fNull_henv, fNull_hdbc, fNull_hstmt );

	wsprintf( OutStr, szFormat, cbErrorMsgMax );
	szWrite( OutStr, TRUE );

	Untouch( szSqlState, sizeof( szSqlState ) );
	fNativeError	= (SDWORD)UNTOUCHED;
	cbErrorMsg		= (SWORD)UNTOUCHED;
	lszSqlState		= fNull_szSqlState ? NULL : (UCHAR*)szSqlState;
	lszErrorMsg		= AllocateBuffer( fNull_szErrorMsg, cbErrorMsgMax );
	lpcbErrorMsg	= fNull_pcbErrorMsg   ? NULL : (SWORD*)&cbErrorMsg;
	lpfNativeError	= fNull_pfNativeError ? NULL : (SDWORD*)&fNativeError;


/*****************************	#10 SQLError	*******************************/

	retcode = SQLError(	fNull_henv  ? SQL_NULL_HENV  : henv,
						fNull_hdbc  ? SQL_NULL_HDBC  : hdbc,
						fNull_hstmt ? SQL_NULL_HSTMT : hstmt,
						lszSqlState, lpfNativeError,
						lszErrorMsg, cbErrorMsgMax, lpcbErrorMsg );

	EchoRetcode( sz_SQLError, retcode );
	DisplayError(	retcode,		lszSqlState,	lpfNativeError,
					lszErrorMsg,	cbErrorMsgMax,	lpcbErrorMsg	);

	DisposePtr( lszErrorMsg );
	return;
}/* end DoSQLError */


static void DoSQLGetFunctions()
{
	SQLGetFunctionsRec	*info = &(*hglobs)->SQLGetFunctionsInfo;
	RETCODE				retcode;
	BOOL				fExists;


	if( !GetSQLGetFunctions( info ) )							/*** DIALOG	***/
		return;

	if( info->fFunctionChoice > SQL_NUM_FUNCTIONS )
		 fFunction = info->fFunctionChoice;
	else fFunction = info->fFunctionChoice + SQL_EXT_API_START - SQL_NUM_FUNCTIONS - 1;

	fNull_pfExists = info->NullPfExistsOutChecked;

	fExists = (BOOL)UNTOUCHED;


/*****************************	#44 SQLGetFunctions	***************************/

	retcode = SQLGetFunctions( hdbc, fFunction,
								fNull_pfExists ? NULL : (BOOL*)&fExists );


	DisplayGetFunctions( retcode, fFunction, fNull_pfExists, fExists );
	return;
}/* end DoSQLGetFunctions */


static void DoAllErrors()
{
	return;
}/* end DoAllErrors */


static void DoGetFunctionsAll()
{
	return;
}/* end DoGetFunctionsAll */


static void DoSQLSetConnectOption()
{
	SQLSetConnectOptionRec	*info = &(*hglobs)->SQLSetConnectOptionInfo;
	UWORD					fOption;
	UDWORD					vParam;
	RETCODE					retcode;

	
	pfinfo	= &finfo_fOption_Both;
	poptarg	= &optargBoth;				/** use generic option	for dialog	**/

	if( !GetSQLSetConnectOption( info ) )						/*** DIALOG	***/
		return;	

	fOption	= info->fOptionChoice;
	if( fOption <= 8 )
		 fOption += 100;		/* 1 thru 8 - Conn: 101 thru 109	*/
	else fOption -= 9;			/* 9 on up  - Stmt: 0 on up			*/

	vParam	= info->vParamChoice - 1;	// for now ???

	poptarg->fOption	= fOption;
	poptarg->udwParam	= vParam;

	if( fOption < MIN_CONN_OPTION )		/** pick Stmt or Conn option		**/
		 poptarg = &optargStmt;
	else poptarg = &optargConnect;

	poptarg->fOption = fOption;
	if( fOption == SQL_OPT_TRACEFILE || fOption == SQL_TRANSLATE_DLL )
		vParam = (UDWORD)( fNull_vParam ? NULL : (PTR)rgbParam );
	else
		poptarg->udwParam = vParam;


/*****************************	#50 SQLSetConnectOption	***********************/

	retcode = SQLSetConnectOption( hdbc, fOption, vParam );

	EchoRetcode( sz_SQLSetConnectOption, retcode );
	return;
}/* end DoSQLSetConnectOption */


static void DoSQLGetConnectOption()
{
	SQLGetConnectOptionRec	*info = &(*hglobs)->SQLGetConnectOptionInfo;
	UWORD					fOption;
	RETCODE					retcode;


	pfinfo	= &finfo_fOption_Connect;

	if( !GetSQLGetConnectOption( info ) )						/*** DIALOG	***/
		return;

	fOption			= optargConnect.fOption = info->fOptionChoice + 100;
	fNull_pvParam	= info->NullPvParamOutChecked;

	Untouch( rgbParam, MAX_OPTION_PARAM + 1 );


/*****************************	#42 SQLGetConnectOption	***********************/

	retcode = SQLGetConnectOption(	hdbc,			/*** DIALOG	***/
									fOption,
									fNull_pvParam ? NULL : (PTR)rgbParam );

	if( !FDisplayOptionParam(	retcode, fOption, fNull_pvParam, rgbParam,
								MAX_OPTION_PARAM ) )
	{
		if( fOption == SQL_OPT_TRACEFILE || fOption == SQL_TRANSLATE_DLL )
		{
			Untouch( rgbParam, MAX_OPTION_PARAM + 1 );
			rgbParam[0] = 0;
		}
		else
			*(UDWORD*)rgbParam =
				VParamFromFOptionIsel( optargConnect.fOption, iselParamFirst );
	}
	optargBoth.fOption	= fOption;
	optargBoth.udwParam	= optargConnect.udwParam = *(UDWORD*)rgbParam;

	return;
}/* end DoSQLGetConnectOption */


static void DoSQLSetStmtOption()
{
	SQLSetStmtOptionRec	*info = &(*hglobs)->SQLSetStmtOptionInfo;
	UWORD				fOption;
	UDWORD				vParam;
	RETCODE				retcode;


	pfinfo	= &finfo_fOption_Stmt;

	if( !GetSQLSetStmtOption( info ) )							/*** DIALOG	***/
		return;

	fOption	= info->fOptionChoice - 1 ;
	vParam	= info->vParamChoice  - 1;

	optargBoth.fOption	= optargStmt.fOption	= fOption;
	optargBoth.udwParam	= optargStmt.udwParam	= vParam;


/*****************************	#51 SQLSetStmtOption	***********************/

	retcode = SQLSetStmtOption( hstmt, fOption, vParam );

	EchoRetcode( sz_SQLSetStmtOption, retcode );
	return;
}/* end DoSQLSetStmtOption */


static void DoSQLGetStmtOption()
{
	SQLGetStmtOptionRec	*info = &(*hglobs)->SQLGetStmtOptionInfo;
	UWORD				fOption;
	RETCODE				retcode;

	pfinfo	= &finfo_fOption_Stmt;
	poptarg = &optargStmt;

	if( !GetSQLGetStmtOption( info ) )							/*** DIALOG	***/
		return;

	fOption = optargStmt.fOption = info->fOptionChoice - 1;
	fNull_pvParam = info->NullPvParamOutChecked;

	Untouch( rgbParam, MAX_OPTION_PARAM + 1 );


/*****************************	#46 SQLGetStmtOption	***********************/

	retcode = SQLGetStmtOption( hstmt, fOption, fNull_pvParam ? NULL : (PTR)rgbParam );

	if( !FDisplayOptionParam( retcode, fOption, fNull_pvParam, rgbParam, MAX_OPTION_PARAM ) )
		*(UDWORD*)rgbParam = VParamFromFOptionIsel( optargStmt.fOption, iselParamFirst );

	optargBoth.fOption	= fOption;
	optargBoth.udwParam	= optargStmt.udwParam = *(UDWORD*)rgbParam;
	return;
}/* end DoSQLGetStmtOption */


static void DoSQLParamOptions()
{
	SQLParamOptionsRec	*info = &(*hglobs)->SQLParamOptionsInfo;
	RETCODE				retcode;
	UDWORD				irow;
	STMTINFO			*lpstmtinfo;
	UDWORD				*lpirow = &irow;

	
	if( !GetSQLParamOptions( info ) )							/*** DIALOG ***/
		return;

	StringToNum( info->crowText, &gNum );			/* dialog results	*/
	crow		= gNum;
	fNull_pirow	= info->NullPirowPointerChecked;


	lpstmtinfo = LpstmtinfoFromHstmt( hstmt );
	if( lpstmtinfo )
	{
		lpstmtinfo->crow		= crow;
		lpirow					= &lpstmtinfo->irow;
		lpstmtinfo->fNull_pirow	= fNull_pirow;
	}
	*lpirow = (UDWORD)UNTOUCHED;


/*****************************	#64 SQLParamOptions	***************************/

	retcode = SQLParamOptions( hstmt, crow, fNull_pirow ? NULL : lpirow );

	EchoRetcode( sz_SQLParamOptions, retcode );
	return;
}/* end DoSQLParamOptions */


static void DoSQLSetScrollOptions()
{
	SQLSetScrollOptionsRec	*info = &(*hglobs)->SQLSetScrollOptionsInfo;
	RETCODE					retcode;
	static BYTE CSCONST		szFormat[] = ", %s = %u:";

	
	if( !GetSQLSetScrollOptions( info ) )						/*** DIALOG	***/
		return;


	fConcurrency	= info->fConcurrencyChoice;		/* dialog results	*/
	crowKeyset		= -(info->crowKeysetChoice - 1);
	StringToNum( info->crowRowsetText, &gNum );
	crowRowset = gNum;


	szWrite( sz_fConcurrency,	FALSE );
	szWrite( szEqual,			FALSE );
	szWrite( SzConstDisplay( LszNameFromFlagArg( &finfo_fConcurrency,
													fConcurrency ),
							fConcurrency ),
			FALSE );
	szWrite( szComma,		TRUE );
	szWrite( sz_crowKeyset,	FALSE );
	szWrite( szEqual,		FALSE );
	szWrite( SzConstDisplay( LszNameFromFlagArg( &finfo_crowKeyset, crowKeyset),
							 crowKeyset ),
			FALSE );
	wsprintf( OutStr, szFormat, (LPSTR)sz_crowRowset, crowRowset );
	szWrite( OutStr, TRUE );


/*****************************	#69 SQLSetScrollOptions	***********************/

	retcode = SQLSetScrollOptions( hstmt, fConcurrency, crowKeyset, crowRowset );

	EchoRetcode( sz_SQLSetScrollOptions, retcode );
	return;
}/* end DoSQLSetScrollOptions */


static void DoSQLNumResultCols()
{
	SQLNumResultColsRec		*info = &(*hglobs)->SQLNumResultColsInfo;
	BOOL					fNull_pcref;
	RETCODE					retcode;
	SWORD					*lpcref		= NULL;
	LPAF					lpaf		= NULL;


	fNew_lpccol = (lpaf = *LplpafFromHstmt( hstmt )) == NULL
				|| lpaf->General.ifn != ifnNumResultCols;
	if( !fNew_lpccol )
	{
		lpcref = lpaf->NumResultCols.lpccol;
		fNull_pccol = lpcref == NULL;
	}

	if( !GetSQLNumResultCols( info ) )							/*** DIALOG	***/
		return;

	fNull_pccol = info->NullPccolOutChecked;	/* dialog result	*/

	fNull_pcref = fNull_pccol;

	if( fNew_lpccol )
		lpcref = AllocateBuffer( fNull_pcref, sizeof *lpcref );


/*****************************	#18 SQLNumResultCols	***********************/

	retcode = SQLNumResultCols( hstmt, lpcref );

	DisplayNumRefs( retcode, FALSE, lpcref );

	lpaf = LpafAdd( TRUE, ifnNumResultCols, retcode );
	if( lpaf )
		lpaf->NumResultCols.lpccol = lpcref;
	else if( fNew_lpccol )
		ReleaseMemory( lpcref );

	return;
}/* end DoSQLNumResultCols */


static void DoSQLDescribeCol()
{
	SQLDescribeColRec	*info = &(*hglobs)->SQLDescribeColInfo;
	RETCODE				retcode;
	UCHAR				*lszColName  = NULL;
	SWORD				*lpcbColName = NULL;
	SWORD				*lpfSqlType  = NULL;
	UDWORD				*lpcbColDef  = NULL;
	SWORD				*lpibScale   = NULL;
	SWORD				*lpfNullable = NULL;
	LPAF				lpaf;


	fNew_lszColName = fNew_lpcbColName = fNew_lpfSqlType  =
	fNew_lpcbColDef = fNew_lpibScale   = fNew_lpfNullable =
		(   lpaf = *LplpafFromHstmt( hstmt )) == NULL
		 || lpaf->General.ifn != ifnDescribeCol;
	if( !fNew_lszColName )
	{
		icol         = lpaf->DescribeCol.icol;
		lszColName   = lpaf->DescribeCol.lszColName;
		cbColNameMax = lpaf->DescribeCol.cbColNameMax;
		lpcbColName  = lpaf->DescribeCol.lpcbColName;
		lpfSqlType   = lpaf->DescribeCol.lpfSqlType;
		lpcbColDef   = lpaf->DescribeCol.lpcbColDef;
		lpibScale    = lpaf->DescribeCol.lpibScale;
		lpfNullable  = lpaf->DescribeCol.lpfNullable;

		fNull_szColName		= lszColName	== NULL;
		fNull_pcbColName	= lpcbColName	== NULL;
		fNull_pfSqlType		= lpfSqlType	== NULL;
		fNull_pcbColDef		= lpcbColDef	== NULL;
		fNull_pibScale		= lpibScale		== NULL;
		fNull_pfNullable	= lpfNullable	== NULL;
	}

	if( !GetSQLDescribeCol( info ) )							/*** DIALOG	***/
		return;

	StringToNum( info->icolText,         &gNum );		icol			= gNum;
	StringToNum( info->cbColNameMaxText, &gNum );		cbColNameMax	= gNum;
	fNull_szColName		= info->NullSzColNameOutChecked;
	fNull_pcbColName	= info->NullPcbColNameOutChecked;
	fNull_pfSqlType		= info->NullPfSqlTypeOutChecked;
	fNull_pcbColDef		= info->NullPcbColDefOutChecked;
	fNull_pibScale		= info->NullPibScaleOutChecked;
	fNull_pfNullable	= info->NullPfNullableOutChecked;

	if( fNew_lszColName )
		lszColName  = AllocateBuffer( fNull_szColName, cbColNameMax );

	if( fNew_lpcbColName )
		lpcbColName = AllocateBuffer( fNull_pcbColName, sizeof *lpcbColName );

	if( fNew_lpfSqlType )
		lpfSqlType = AllocateBuffer( fNull_pfSqlType, sizeof *lpfSqlType );

	if( fNew_lpcbColDef )
		lpcbColDef = AllocateBuffer( fNull_pcbColDef, sizeof *lpcbColDef );

	if( fNew_lpibScale )
		lpibScale = AllocateBuffer( fNull_pibScale, sizeof *lpibScale );

	if( fNew_lpfNullable )
		lpfNullable = AllocateBuffer( fNull_pfNullable, sizeof *lpfNullable );


/*****************************	#08 SQLDescribeCol	***************************/

	retcode = SQLDescribeCol(	hstmt,			icol,
								lszColName,		cbColNameMax,	lpcbColName,
								lpfSqlType,		lpcbColDef,		lpibScale,
								lpfNullable );


	DisplayDescribeRef(	FALSE, 2, retcode, icol,
						lszColName, cbColNameMax, lpcbColName, lpfSqlType,
						lpcbColDef, lpibScale, lpfNullable );

	lpaf = LpafAdd( TRUE, ifnDescribeCol, retcode );
	if( lpaf )
	{
		lpaf->DescribeCol.icol			= icol;
		lpaf->DescribeCol.lszColName	= lszColName;
		lpaf->DescribeCol.cbColNameMax	= cbColNameMax;
		lpaf->DescribeCol.lpcbColName	= lpcbColName;
		lpaf->DescribeCol.lpfSqlType	= lpfSqlType;
		lpaf->DescribeCol.lpcbColDef	= lpcbColDef;
		lpaf->DescribeCol.lpibScale		= lpibScale;
		lpaf->DescribeCol.lpfNullable	= lpfNullable;
	}
	else
	{
		if( fNew_lszColName )	ReleaseMemory( lszColName );
		if( fNew_lpcbColName)	ReleaseMemory( lpcbColName );
		if( fNew_lpfSqlType )	ReleaseMemory( lpfSqlType );
		if( fNew_lpcbColDef)	ReleaseMemory( lpcbColDef );
		if( fNew_lpibScale )	ReleaseMemory( lpibScale );
		if( fNew_lpfNullable )	ReleaseMemory( lpfNullable );
	}
	return;
}/* end DoSQLDescribeCol */


static void DoSQLColAttributes()
{
	SQLColAttributesRec	*info = &(*hglobs)->SQLColAttributesInfo;
	RETCODE				retcode;
	PTR          		lrgbDesc	= NULL;
	SWORD				*lpcbDesc	= NULL;
	SDWORD				*lpfDesc	= NULL;
	LPAF				lpaf;


	fNew_lrgbDesc = fNew_lpcbDesc = fNew_lpfDesc =
			(  lpaf = *LplpafFromHstmt( hstmt ) )	== NULL
			|| lpaf->General.ifn != ifnParamData;
	if( !fNew_lrgbDesc )
	{
		icol		= lpaf->ColAttributes.icol;
		fDescType	= lpaf->ColAttributes.fDescType;
		lrgbDesc	= lpaf->ColAttributes.lrgbDesc;
		cbDescMax	= lpaf->ColAttributes.cbDescMax;
		lpcbDesc	= lpaf->ColAttributes.lpcbDesc;
		lpfDesc		= lpaf->ColAttributes.lpfDesc;

		fNull_rgbDesc = (lrgbDesc == NULL);
		fNull_pcbDesc = (lpcbDesc == NULL);
		fNull_pfDesc  = (lpfDesc  == NULL);
	}

	if( !GetSQLColAttributes( info ) )
		return;

	StringToNum( info->icolText,      &gNum );		icol		= gNum;
	StringToNum( info->cbDescMaxText, &gNum );		cbDescMax	= gNum;
	fDescType = info->fDescTypeChoice - 1;
	fNull_rgbDesc	= info->NullRgbDescOutChecked;
	fNull_pcbDesc	= info->NullPcbDescOutChecked;
	fNull_pfDesc	= info->NullPfDescOutChecked;

	if( fNew_lrgbDesc )	lrgbDesc = AllocateBuffer( fNull_rgbDesc, cbDescMax );
	if( fNew_lpcbDesc )	lpcbDesc = AllocateBuffer( fNull_pcbDesc, sizeof *lpcbDesc );
	if( fNew_lpfDesc )	lpfDesc  = AllocateBuffer( fNull_pfDesc,  sizeof *lpfDesc );


/*****************************	#06 SQLColAttributes	***********************/

	retcode = SQLColAttributes( hstmt, icol, fDescType,
								lrgbDesc, cbDescMax, lpcbDesc, lpfDesc );


	DisplayColAttributes( retcode, icol, fDescType,
							lrgbDesc, cbDescMax, lpcbDesc, lpfDesc );

	lpaf = LpafAdd( TRUE, ifnColAttributes, retcode );
	if( lpaf )
	{
		lpaf->ColAttributes.icol      = icol;
		lpaf->ColAttributes.fDescType = fDescType;
		lpaf->ColAttributes.lrgbDesc  = lrgbDesc;
		lpaf->ColAttributes.cbDescMax = cbDescMax;
		lpaf->ColAttributes.lpcbDesc  = lpcbDesc;
		lpaf->ColAttributes.lpfDesc   = lpfDesc;
	}
	else
	{
		if( fNew_lrgbDesc )		ReleaseMemory( lpcbDesc );
		if( fNew_lpcbDesc )		ReleaseMemory( lrgbDesc );
		if( fNew_lpfDesc  )		ReleaseMemory( lpfDesc );
	}
	return;
}/* end DoSQLColAttributes */


static void DoSQLRowCount()
{
	SQLRowCountRec	*info = &(*hglobs)->SQLRowCountInfo;
	RETCODE			retcode;
	SDWORD			crow;

	
	if( !GetSQLRowCount( info ) )								/*** DIALOG	***/
		return;

	fNull_pcrow = info->NullPcrowOutChecked;

	crow = (SDWORD)UNTOUCHED;


/*****************************	#20 SQLRowCount	*******************************/

	retcode = SQLRowCount( hstmt, fNull_pcrow ? NULL : (SDWORD*)&crow );

	EchoRetcode( sz_SQLRowCount, retcode );

	if( !fNull_pcrow &&
		FCheckArg( sz_apcrow, crow == (SDWORD)UNTOUCHED,
					retcode < SQL_SUCCESS, TRUE ) )
	{
		sprintf( OutStr, "%10d.", crow );
		szWrite( OutStr, TRUE );
	}
	return;
}/* end DoSQLRowCount */


static void DoSQLBindCol()
{
	SQLBindColRec	*info = &(*hglobs)->SQLBindColRecInfo;
	RETCODE			retcode;
	HPVOID			hrgbValue;
	SDWORD			*lpcbValue;
	LPBOUND			lpbound = NULL;
	SDWORD			count;


	info->NullRgbValuePointerChecked	= fNull_rgbValue;	/* checkbox		*/
	info->NullPcbValuePointerChecked	= fNull_pcbValue;

	if( !GetSQLBindCol( info ) )								/*** DIALOG	***/
		return;

	fNull_rgbValue = info->NullRgbValuePointerChecked;
	fNull_pcbValue = info->NullPcbValuePointerChecked;

	StringToNum( info->icolText,		&gNum );		icol		= gNum;
	StringToNum( info->cbValueMaxText,	&gNum );		cbValueMax	= gNum;

	switch( info->fCTypeChoice )
	{
		case 1:		fCType = SQL_C_CHAR;		break;
		case 2:		fCType = SQL_C_LONG;		break;
		case 3:		fCType = SQL_C_FLOAT;		break;
		case 4:		fCType = SQL_C_SHORT;		break;
		case 5:		fCType = SQL_C_DOUBLE;		break;
		case 6:		fCType = SQL_C_DATE;		break;
		case 7:		fCType = SQL_C_TIME;		break;
		case 8:		fCType = SQL_C_TIMESTAMP;	break;
		case 9:		fCType = SQL_C_BINARY;		break;
		case 10:	fCType = SQL_C_TINYINT;		break;
		case 11:	fCType = SQL_C_BIT;			break;
		case 12:	fCType = SQL_C_DEFAULT;		break;
	}

	if( !fNull_rgbValue )
	{
		if( cbValueMax  >  (0x7FFFFFFF - SIZEOF_BOUND( col ) ) )
			 count = 0x7FFFFFFF;
		else count = SIZEOF_BOUND( col ) + MAX( cbValueMax, MIN_CBMAX );

		lpbound = AllocateBuffer( FALSE, count );
		if( lpbound == NULL )
			fNull_rgbValue = TRUE;
	}

	if( fNull_rgbValue )
	{
		lpbound = AllocateBuffer( FALSE, SIZEOF_BOUND( col ) );
		hrgbValue = NULL;
	}
	else
		hrgbValue = lpbound->col.rgbValue;

	lpcbValue = fNull_pcbValue ? NULL : &lpbound->col.cbValue;


	retcode = SQLBindCol( hstmt, icol, fCType, hrgbValue, cbValueMax, lpcbValue );


	EchoRetcode( sz_SQLBindCol, retcode );

	FDisplayCbAndRgbArgs( SQL_ERROR,	LPCB_SDWORD | HRGB_MIN_SIZE,	fCType,
							sz_apcbValue, lpcbValue, cbValueMax,
							sz_rgbValue,  hrgbValue );

#ifdef UNBIND_ON_BOTH_NULL
	if( retcode >= SQL_SUCCESS
	 && FInsertBound( hstmt, FALSE, icol, lpbound,
						fNull_rgbValue && fNull_pcbValue );
#else
	if( retcode >= SQL_SUCCESS &&
		FInsertBound( hstmt, FALSE, icol, lpbound, fNull_rgbValue ) )
#endif
	{
		lpbound->col.fNull_rgb  = fNull_rgbValue;
		lpbound->col.fNull_pcb  = fNull_pcbValue;
		lpbound->col.fCType     = fCType;
		lpbound->col.cbValueMax = cbValueMax;
	}
	else
		ReleaseMemory( lpbound );
	return;
}/* end DoSQLBindCol */


static void DoSQLFetch()
{
	UWORD		icolBoundMost = IcolUntouchBoundCols( hstmt );
	RETCODE		retcode;


	retcode = SQLFetch( hstmt );

	EchoRetcode( sz_SQLFetch, retcode );

	if( LpafAdd( TRUE, ifnFetch, retcode ) == NULL && icolBoundMost )
		IcolBoundColChecks( hstmt, 0, retcode );
	return;
}/* end DoSQLFetch */


static void DoSQLExtendedFetch()
{
	SQLExtendedFetchRec	*info = &(*hglobs)->SQLExtendedFetchInfo;
	RETCODE				retcode;
	UDWORD				*lpcrow        = NULL;
	UWORD				*lrgfRowStatus = NULL;
	LPAF				lpaf;

	fNew_lpcrow = fNew_lrgfRowStatus =	(lpaf = *LplpafFromHstmt( hstmt )) == NULL
										|| lpaf->General.ifn != ifnExtendedFetch;
	if( !fNew_lpcrow )
	{
		fFetchType    = lpaf->ExtendedFetch.fFetchType;
		irow          = lpaf->ExtendedFetch.irow;
		lpcrow        = lpaf->ExtendedFetch.lpcrow;
		lrgfRowStatus = lpaf->ExtendedFetch.lrgfRowStatus;

		fNull_pcrow        = (lpcrow        == NULL);
		fNull_rgfRowStatus = (lrgfRowStatus == NULL);
	}

	if( !GetSQLExtendedFetch( info ) )							/*** DIALOG	***/
		return;

	fFetchType = info->fFetchTypeChoice;
	StringToNum( info->irowText, &gNum );
	irow = gNum;
	fNull_pcrow			= info->NullPcrowOutChecked;
	fNull_rgfRowStatus	= info->NullRgfRowStatusOutChecked;


	if( fNew_lpcrow )
		lpcrow = AllocateBuffer( fNull_pcrow, sizeof *lpcrow );

	if( fNew_lrgfRowStatus )
		lrgfRowStatus = AllocateBuffer( fNull_rgfRowStatus,
												MAX_CROW * sizeof( UWORD ) + 1);


/*****************************	#59 SQLExtendedFetch	***********************/

	retcode = SQLExtendedFetch( hstmt, fFetchType, irow, lpcrow, lrgfRowStatus );

	DisplayExtendedFetch( retcode, fFetchType, irow, lpcrow, lrgfRowStatus );

	lpaf = LpafAdd( TRUE, ifnExtendedFetch, retcode );
	if( lpaf )
	{
		lpaf->ExtendedFetch.fFetchType    = fFetchType;
		lpaf->ExtendedFetch.irow          = irow;
		lpaf->ExtendedFetch.lpcrow        = lpcrow;
		lpaf->ExtendedFetch.lrgfRowStatus = lrgfRowStatus;
	}
	else
	{
		if( fNew_lpcrow )			ReleaseMemory( lpcrow );
		if( fNew_lrgfRowStatus )	ReleaseMemory( lrgfRowStatus );
	}
	return;
}/* end DoSQLExtendedFetch */


static void DoSQLCols()
{
	return;
}/* end DoSQLCols */


static void DoSQLSetPos()
{
	SQLSetPosRec	*info = &(*hglobs)->SQLSetPosInfo;
	RETCODE			retcode;
	LPAF			lpaf;


	lpaf = *LplpafFromHstmt( hstmt );
	if( lpaf && lpaf->General.ifn == ifnSetPos )
	{
		irow     = lpaf->SetPos.irow;
		fRefresh = lpaf->SetPos.fRefresh;
		fLock    = lpaf->SetPos.fLock;
	}

	
	if( !GetSQLSetPos( info ) )									/*** DIALOG	***/
		return;

	StringToNum( info->irowText, &gNum );
	irow		= gNum;
	fRefresh	= info->fRefreshChoice - 1;
	fLock		= info->fLockChoice    - 1;

	szWrite( sz_irow,		FALSE );
	szWrite( szEqual,		FALSE );
	ltoa( irow, OutStr, 10 );
	szWrite( OutStr,		FALSE );
	szWrite( szComma,		FALSE );
	szWrite( sz_fRefresh,	FALSE );
	szWrite( szEqual,		FALSE );
	szWrite( SzConstDisplay( LszNameFromFlagArg( &finfo_BOOL, fRefresh ),
							fRefresh ),
			FALSE );
	szWrite( szComma,	FALSE );
	szWrite( sz_fLock,	FALSE );
	szWrite( szEqual,	FALSE );
	szWrite(SzConstDisplay(
			LszNameFromFlagArg( &finfo_BOOL, fLock ), fLock ), FALSE );
	szWrite( szColon, TRUE );


/*****************************	#68 SQLSetPos	*******************************/

	retcode = SQLSetPos( hstmt, irow, fRefresh, fLock );

	EchoRetcode( sz_SQLSetPos, retcode );

	lpaf = LpafAdd( TRUE, ifnSetPos, retcode );
	if( lpaf )
	{
		lpaf->SetPos.irow     = irow;
		lpaf->SetPos.fRefresh = fRefresh;
		lpaf->SetPos.fLock    = fLock;
	}
	return;
}/* end DoSQLSetPos */


static void DoSQLGetData()
{
	RETCODE			retcode;
	HPVOID  		hrgbValue	= NULL;
	SDWORD			*lpcbValue	= NULL;
	LPAF			lpaf;
	SQLGetDataRec	*info = &(*hglobs)->SQLGetDataInfo;


	fNew_hrgbValue = fNew_lpcbValue = (lpaf = *LplpafFromHstmt( hstmt )) == NULL
									|| lpaf->General.ifn != ifnGetData;
	if( !fNew_hrgbValue )
	{
		icol       = lpaf->GetData.icol;
		fCType     = lpaf->GetData.fCType;
		hrgbValue  = lpaf->GetData.hrgbValue;
		cbValueMax = lpaf->GetData.cbValueMax;
		lpcbValue  = lpaf->GetData.lpcbValue;

		fNull_rgbValue = (hrgbValue  == NULL);
		fNull_pcbValue = (lpcbValue  == NULL);
	}

	if( !GetSQLGetData( info ) )								/*** DIALOG	***/
		return;

	switch( info->fCTypeChoice )						// for now ???
	{
		case 1:	fCType = 1;	break;
		case 2:	fCType = 4;	break;
		case 3:	fCType = 5;	break;
		case 4:	fCType = 7;	break;
		case 5:	fCType = 8;	break;
		case 6:	fCType = 9;	break;
	}

	StringToNum( info->icolText,		&gNum );	icol		= gNum;
	StringToNum( info->cbValueMaxText,	&gNum );	cbValueMax	= gNum;
	fNull_rgbValue = info->NullRgbValueOutChecked;
	fNull_pcbValue = info->NullPcbValueOutChecked;

	if( fNew_hrgbValue )
	{
		hrgbValue = AllocateBuffer( fNull_rgbValue, MAX( cbValueMax, MIN_CBMAX ) );
		if( hrgbValue == NULL )
			fNull_rgbValue = TRUE;
	}
	if( fNew_lpcbValue )
		lpcbValue = AllocateBuffer( fNull_pcbValue, sizeof( *lpcbValue ) );


/*****************************	#43 SQLGetData	*******************************/

	retcode = SQLGetData( hstmt, icol, fCType, hrgbValue, cbValueMax, lpcbValue );


	StringToNum( info->icolText, &gNum );
	icol = gNum;

	DisplayGetData( retcode, fCType, hrgbValue, cbValueMax, lpcbValue );

	lpaf = LpafAdd( TRUE, ifnGetData, retcode);
	if( lpaf )
	{
		lpaf->GetData.icol       = icol;
		lpaf->GetData.fCType     = fCType;
		lpaf->GetData.hrgbValue  = hrgbValue;
		lpaf->GetData.cbValueMax = cbValueMax;
		lpaf->GetData.lpcbValue  = lpcbValue;
	}
	else
	{
		if( fNew_hrgbValue )
			ReleaseMemory( hrgbValue );

		if( fNew_lpcbValue )
			ReleaseMemory( lpcbValue );
	}
	return;
}/* end DoSQLGetData */


static void DoSQLMoreResults()
{
	UWORD		icolBoundMost = IcolUntouchBoundCols( hstmt );
	RETCODE		retcode;


	retcode = SQLMoreResults( hstmt );			/***	#61 SQLMoreResults	***/

	EchoRetcode(sz_SQLMoreResults, retcode);

	if( LpafAdd( TRUE, ifnMoreResults, retcode ) == NULL && icolBoundMost )
		IcolBoundColChecks( hstmt, ALWAYS_UNTOUCHED, 0 );
	return;
}/* end DoSQLMoreResults */


static void DoDescribeColAll()
{
	return;
}/* end DoDescribeColAll */


static void DoFetchAll()
{
	return;
}/* end DoFetchAll */


static void DoShowBoundCols()
{
	return;
}/* end DoShowBoundCols */


static void DoGetDataRow()
{
	return;
}/* end DoGetDataRow */


static void DoGetDataAll()
{
	return;
}/* end DoGetDataAll */


static void DoSQLAllocStmt()
{
	SQLAllocStmtRec		*info = &(*hglobs)->SQLAllocStmtInfo;
	static BYTE CSCONST sz_aphstmt[]        = "*phstmt";
	static BYTE CSCONST szFormatNotNull[]   = " = %u != %s!";
	static BYTE CSCONST sz_NULL_STATEMENT[] = NULL_STATEMENT;
	static BYTE CSCONST szTitle[]			= "\pStorage error";
	static BYTE CSCONST szMsg[]				= "Maximum %d statement handles.";


	BOOL			fUntouched;
	HSTMT			hstmtT = (HSTMT)UNTOUCHED;
	RETCODE			retcode;
	STMTINFO		*lpstmtinfo;

	extern UWORD	istmtMax;
	extern STMTINFO	*lpstmtinfoMax;


	for( lpstmtinfo = &lrgstmtinfo[0];
		 lpstmtinfo < lpstmtinfoMax && lpstmtinfo->hstmt != NULL;
		 lpstmtinfo++ )
		;

	if( lpstmtinfo >= lpstmtinfoMax )
	{
		wsprintf( OutStr, szMsg, MAX_STATEMENTS );
		c2pstr( OutStr );
		messageBox( OutStr, szTitle, stopIcon );
		return;
	}

	if( !GetSQLAllocStmt( info ) )								/*** DIALOG	***/
		return;


/*****************************	#03 SQLAllocStmt	***************************/

	retcode = SQLAllocStmt( hdbc, info->NullPhstmtOutChecked ? NULL : &hstmtT );

	EchoRetcode( sz_SQLAllocStmt, retcode );

	fUntouched = (hstmtT == (HSTMT)UNTOUCHED);
	if( retcode >= SQL_ERROR && !fNull_hstmt )
		DisplayUntouchedError( sz_aphstmt, fUntouched, FALSE );

	if( !fUntouched && retcode == SQL_ERROR && hstmtT != SQL_NULL_HSTMT )
	{
		szWrite( sz_Error, FALSE );
		szWrite( sz_aphstmt, FALSE );
		wsprintf( OutStr, szFormatNotNull, hstmtT, (LPSTR)sz_SQL_NULL_HSTMT );
		szWrite( OutStr, TRUE );
	}
	if( retcode < SQL_SUCCESS || fUntouched )
		return;

	lpstmtinfo->istmt = istmt = ++istmtMax;
	lpstmtinfo->hstmt = hstmt = hstmtT;
	lpstmtinfo->hdbc  = hdbc;

	sprintf( OutStr, "!*%-d", istmt );
	c2pstr( OutStr );
	AppendMenu( STMTpop.hMenu, OutStr );
	STMTpop.choice = istmt+1;
	refreshSTMTpop();

	return;
}/* end DoSQLAllocStmt */


static void DoSQLPrepare()
{
	SQLPrepareRec	*info = &(*hglobs)->SQLPrepareInfo;
	RETCODE			retcode;
	HPBYTE			hszSqlStr;
	LPAF			lpaf;
	LPBYTE			lszFuncName = sz_SQLPrepare;
	int				ifn = ifnPrepare;
	TEHandle		teh;
	short			len, offset;
	Handle			textHan;


	lpaf = *LplpafFromHstmt( hstmt );
	fNew_lszFromInput = (lpaf == NULL || lpaf->General.ifn != ifn);
	if( !fNew_lszFromInput )
	{
		lszFromInput	= lpaf->Prepare.hszSqlStr;
		cbSqlStr		= lpaf->Prepare.cbSqlStr;
		cbDefault		= lpaf->Prepare.cbDefault;

		fNull_szSqlStr	= lszFromInput == NULL;
	}


	teh		= cur->inFieldHandle;
	len		= (**teh).selEnd - (**teh).selStart;
	if( len )
	{
		offset	= (**teh).selStart;
	}
	else
	{	len = (**teh).teLength;
		offset	= 0;
	}
	sprintf( info->cbSqlStrText, "%-d", len );
	c2pstr(  info->cbSqlStrText );


	if( !GetSQLPrepare( info ) )								/*** DIALOG	***/
		return;

	fNull_szSqlStr	= info->NullSzSqlStrChecked;
	if( fNull_szSqlStr )
	{
		hszSqlStr	= 0;
		cbSqlStr	= 0;
	}
	else
	{	char	*s;
		cbSqlStr = getTextCount( info->cbSqlStrText );
		textHan = NewHandleClear( len + 2 );

		//hszSqlStr	= lszFromInput;					// ??? from input window
		hszSqlStr	= *textHan;
		s = *((**teh).hText) + offset;
		memcpy( hszSqlStr, s, len );
		hszSqlStr[ len ] = 0;						// NULL terminate
	}


/*****************************	#19 SQLPrepare	*******************************/

	retcode = SQLPrepare( hstmt, hszSqlStr, cbSqlStr );


	DisposHandle( textHan );	hszSqlStr = 0;


	EchoRetcode( lszFuncName, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf != NULL )
	{
		lpaf->Prepare.hszSqlStr	= hszSqlStr;
		lpaf->Prepare.cbSqlStr	= cbSqlStr;
		lpaf->Prepare.cbDefault	= cbDefault;
	}
	else if( fNew_lszFromInput )
		ReleaseMemory( hszSqlStr );
	return;
}/* end DoSQLPrepare */


static void DoSQLSetParam()
{
	SQLSetParamRec	*info = &(*hglobs)->SQLSetParamInfo;
	RETCODE			retcode;
	HPVOID			hrgbValue;
	SDWORD			*lpcbValue;
	LPBOUND			lpbound = NULL;


	if( !GetSQLSetParam( info ) )								/*** DIALOG	***/
		return;

	StringToNum( info->iparText,		&gNum );	ipar				= gNum;
	StringToNum( info->cbColDefText,	&gNum );	cbColDef			= gNum;
	StringToNum( info->ibScaleText,		&gNum );	ibScale				= gNum;
	StringToNum( info->cbValMaxText,	&gNum );	cbValueMax_Param	= gNum;

	fNull_pcbValue = info->NullPcbValuePointerChecked;

	switch( info->fCTypeChoice )
	{
		case 1:		fCType_Param = SQL_C_CHAR;			break;
		case 2:		fCType_Param = SQL_C_LONG;			break;
		case 3:		fCType_Param = SQL_C_SHORT;			break;
		case 4:		fCType_Param = SQL_C_FLOAT;			break;
		case 5:		fCType_Param = SQL_C_DOUBLE;		break;
		case 6:		fCType_Param = SQL_C_DATE;			break;
		case 7:		fCType_Param = SQL_C_TIME;			break;
		case 8:		fCType_Param = SQL_C_TIMESTAMP;		break;
		case 9:		fCType_Param = SQL_C_BINARY;		break;
		case 10:	fCType_Param = SQL_C_TINYINT;		break;
		case 11:	fCType_Param = SQL_C_BIT;			break;
		case 12:	fCType_Param = SQL_C_DEFAULT;		break;
	}

	if( info->fSqlTypeChoice <= 12 )
		 fSqlType = info->fSqlTypeChoice;
	else fSqlType = -(info->fSqlTypeChoice - 12);

	fNum_rgbValue = (info->rgbValueChoice != 1);	// ???


	if( fNum_rgbValue == FALSE )
	{
		lpbound = AllocateBuffer( FALSE,
					(cbValueMax_Param > 0x7FFFFFFF - SIZEOF_BOUND( par ))
					? 0x7FFFFFFF
					: SIZEOF_BOUND( par ) + MAX( cbValueMax_Param, 0 ) );
		if( lpbound == NULL )
		{
			fNum_rgbValue = TRUE;
			udwValue = 0;
		}
	}

	if( fNum_rgbValue )
	{
		lpbound = AllocateBuffer( FALSE, SIZEOF_BOUND( par ) );
		hrgbValue = (PTR)udwValue;
	}
	else
		hrgbValue = lpbound->par.rgbValue;

	lpcbValue = fNull_pcbValue ? NULL : &lpbound->par.cbValue;


/*****************************	#22 SQLSetParam	*******************************/

	retcode = SQLSetParam( hstmt, ipar, fCType_Param, fSqlType,
							cbColDef, ibScale, hrgbValue, lpcbValue );


	EchoRetcode( sz_SQLSetParam, retcode );

	FDisplayCbAndRgbArgs( SQL_ERROR, LPCB_SDWORD, fCType_Param,
							sz_apcbValue, lpcbValue,
							fNum_rgbValue ? 0L : cbValueMax_Param,
							sz_rgbValue,
							fNum_rgbValue ? NULL : hrgbValue );

#ifdef UNBIND_ON_BOTH_NULL
	if( retcode >= SQL_SUCCESS
	 && FInsertBound( hstmt, TRUE, ipar, lpbound,
						fNum_rgbValue && udwValue == 0 && fNull_pcbValue ) )
#else
	if( retcode >= SQL_SUCCESS &&
		FInsertBound( hstmt, TRUE, ipar, lpbound, FALSE ) )
#endif
	{
		lpbound->par.fNum_rgb   = fNum_rgbValue;
		lpbound->par.fNull_pcb  = fNull_pcbValue;
		lpbound->par.fCType     = fCType_Param;
		lpbound->par.fSqlType   = fSqlType;
		lpbound->par.cbColDef   = cbColDef;
		lpbound->par.ibScale    = ibScale;
		lpbound->par.udwValue   = udwValue;
		lpbound->par.cbValueMax = fNum_rgbValue ? 0L : cbValueMax_Param;
		lpbound->par.cbDefault  = 0;
	}
	else
		ReleaseMemory( lpbound );
	return;
}/* end DoSQLSetParam */


static void DoSQLNumParams()
{
	SQLNumParamsRec	*info = &(*hglobs)->SQLNumParamsInfo;
	BOOL			fNull_pcref;
	RETCODE			retcode;
	SWORD			*lpcref		= NULL;
	LPAF			lpaf		= NULL;


	fNew_lpccol = TRUE;

	if( !GetSQLNumParams( info ) )								/*** DIALOG	***/
		return;

 	fNull_pcpar = info->NullPcparOutChecked;	/* dialog result	*/


	fNull_pcref = fNull_pcpar;	// Now *pfNull_pcref has been set!

	lpcref = AllocateBuffer( fNull_pcref, sizeof *lpcref );

/*****************************	#63 SQLNumParams	***************************/

	retcode = SQLNumParams( hstmt, lpcref );

	DisplayNumRefs( retcode, TRUE, lpcref );
	lpaf = LpafAdd( FALSE, ifnNotAsync, retcode );
	ReleaseMemory( lpcref );

	return;
}/* end DoSQLNumParams */


static void DoSQLDescribeParam()
{
	SQLDescribeParamRec	*info = &(*hglobs)->SQLDescribeParamInfo;
	RETCODE				retcode;
	SWORD				*lpfSqlType  = NULL;
	UDWORD				*lpcbColDef  = NULL;
	SWORD				*lpibScale   = NULL;
	SWORD				*lpfNullable = NULL;
	LPAF				lpaf;


	fNew_lpfSqlType = fNew_lpcbColDef  =
	fNew_lpibScale  = fNew_lpfNullable =
						(lpaf = *LplpafFromHstmt( hstmt )) == NULL
						 || lpaf->General.ifn != ifnDescribeParam;
	if( !fNew_lpfSqlType )
	{
		ipar        = lpaf->DescribeParam.ipar;
		lpfSqlType  = lpaf->DescribeParam.lpfSqlType;
		lpcbColDef  = lpaf->DescribeParam.lpcbColDef;
		lpibScale   = lpaf->DescribeParam.lpibScale;
		lpfNullable = lpaf->DescribeParam.lpfNullable;

		fNull_pfSqlType  = (lpfSqlType  == NULL);
		fNull_pcbColDef  = (lpcbColDef  == NULL);
		fNull_pibScale   = (lpibScale   == NULL);
		fNull_pfNullable = (lpfNullable == NULL);
	}

	if( !GetSQLDescribeParam( info ) )							/*** DIALOG	***/
		return;

	StringToNum( info->iparText, &gNum );
	ipar = gNum;

	fNull_pfSqlType  = info->NullPfSqlTypeOutChecked;
	fNull_pcbColDef  = info->NullPcbColDefOutChecked;
	fNull_pibScale   = info->NullPibScaleOutChecked;
	fNull_pfNullable = info->NullPfNullableOutChecked;


	if( fNew_lpfSqlType )
		lpfSqlType = AllocateBuffer( fNull_pfSqlType, sizeof *lpfSqlType );

	if( fNew_lpcbColDef )
		lpcbColDef = AllocateBuffer( fNull_pcbColDef, sizeof *lpcbColDef );

	if( fNew_lpibScale )
		lpibScale = AllocateBuffer( fNull_pibScale, sizeof *lpibScale );

	if( fNew_lpfNullable )
		lpfNullable = AllocateBuffer( fNull_pfNullable, sizeof *lpfNullable );


/*****************************	#58 SQLDescribeParam	***********************/

	retcode = SQLDescribeParam(	hstmt,	ipar,
								lpfSqlType,	lpcbColDef,	lpibScale,	lpfNullable );

	DisplayDescribeRef( TRUE, 2, retcode, ipar,
						NULL, 0, NULL, lpfSqlType,
						lpcbColDef, lpibScale, lpfNullable );

	lpaf = LpafAdd( TRUE, ifnDescribeParam, retcode );
	if( lpaf )
	{
		lpaf->DescribeParam.ipar        = ipar;
		lpaf->DescribeParam.lpfSqlType  = lpfSqlType;
		lpaf->DescribeParam.lpcbColDef  = lpcbColDef;
		lpaf->DescribeParam.lpibScale   = lpibScale;
		lpaf->DescribeParam.lpfNullable = lpfNullable;
	}
	else
	{
		if( fNew_lpfSqlType  )	ReleaseMemory( lpfSqlType  );
		if( fNew_lpcbColDef  )	ReleaseMemory( lpcbColDef  );
		if( fNew_lpibScale   )	ReleaseMemory( lpibScale   );
		if( fNew_lpfNullable )	ReleaseMemory( lpfNullable );
	}

	return;
}/* end DoSQLDescribeParam */


static void DoSQLExecute()
{
	RETCODE				retcode;


	retcode = SQLExecute( hstmt );

	EchoRetcode( sz_SQLExecute, retcode );
	LpafAdd( TRUE, ifnExecute, retcode );
	return;
}/* end DoSQLExecute */


static void DoSQLExecDirect()
{
	SQLExecDirectRec	*info = &(*hglobs)->SQLExecDirectInfo;
	RETCODE				retcode;
	HPBYTE				hszSqlStr;		// h for "huge"
	LPAF				lpaf;
	LPBYTE				lszFuncName = sz_SQLExecDirect;
	int					ifn         = ifnExecDirect;
	TEHandle			teh;
	short				len, offset;
	Handle				textHan;


	lpaf = *LplpafFromHstmt( hstmt );
	fNew_lszFromInput = (lpaf == NULL || lpaf->General.ifn != ifn);
	if( !fNew_lszFromInput )
	{
		lszFromInput	= lpaf->Prepare.hszSqlStr;
		cbSqlStr		= lpaf->Prepare.cbSqlStr;
		cbDefault		= lpaf->Prepare.cbDefault;

		fNull_szSqlStr	= (lszFromInput == NULL);
	}


	teh		= cur->inFieldHandle;
	len		= (**teh).selEnd - (**teh).selStart;
	if( len )
	{
		offset	= (**teh).selStart;
	}
	else
	{	len = (**teh).teLength;
		offset	= 0;
	}
	sprintf( info->cbSqlStrText, "%-d", len );
	c2pstr(  info->cbSqlStrText );

	if( !GetSQLExecDirect( info ) )								/*** DIALOG	***/
		return;

	fNull_szSqlStr	= info->NullSzSqlStrChecked;
	if( fNull_szSqlStr )
	{
		hszSqlStr	= 0;
		cbSqlStr	= 0;
	}
	else
	{	char	*s;
		cbSqlStr = getTextCount( info->cbSqlStrText );
		textHan = NewHandleClear( len + 2 );

		//hszSqlStr	= lszFromInput;					// ??? from input window
		hszSqlStr	= *textHan;
		s = *((**teh).hText) + offset;
		memcpy( hszSqlStr, s, len );
		hszSqlStr[ len ] = 0;						// NULL terminate
	}



/*****************************	#11 SQLExecDirect	***************************/

	retcode = SQLExecDirect( hstmt, hszSqlStr, cbSqlStr );


	DisposHandle( textHan );	hszSqlStr = 0;


	EchoRetcode( lszFuncName, retcode );

	lpaf = LpafAdd( TRUE, ifn, retcode );
	if( lpaf )
	{
		lpaf->Prepare.hszSqlStr	= hszSqlStr;
		lpaf->Prepare.cbSqlStr	= cbSqlStr;
		lpaf->Prepare.cbDefault	= cbDefault;
	}
	else if( fNew_lszFromInput )
		ReleaseMemory( hszSqlStr );
	return;
}/* end DoSQLExecDirect */


static void DoSQLSetCursorName()
{
	SQLSetCursorNameRec	*info = &(*hglobs)->SQLSetCursorNameInfo;
	RETCODE				retcode;


	if( !GetSQLSetCursorName( info ) )							/*** DIALOG	***/
		return;

	Pas2Ccopy( info->szCursorText, lpddainfo->lpisaCursor->sz );
	lpddainfo->lpisaCursor->cb = getTextCount( info->cbCursorText );


/*****************************	#21 SQLSetCursorName	*******************************/

	retcode = SQLSetCursorName( hstmt, LszAndCbOfLpisa( lpddainfo->lpisaCursor ) );

	EchoRetcode( sz_SQLSetCursorName, retcode );
	return;
}/* end DoSQLSetCursorName */



static void DoSQLGetCursorName()
{
	SQLGetCursorNameRec	*info = &(*hglobs)->SQLGetCursorNameInfo;
	static BYTE CSCONST szFormat[]      = "cbCursorMax = %d:";
	static BYTE CSCONST sz_apcbCursor[] = "*pcbCursor";
	static BYTE CSCONST sz_szCursor[]   = "szCursor";

	RETCODE		retcode;
	UCHAR		*lszCursor;
	SWORD		*lpcbCursor;
	LPISA		lpisa;


	if( !GetSQLGetCursorName( info ) )							/*** DIALOG	***/
		return;

	fNull_szCursor	= info->NullSzCursorOutChecked;
	fNull_pcbCursor	= info->NullPcbCursorOutChecked;
	StringToNum( info->cbCursorMaxText, &gNum );
	cbCursorMax = gNum;

	lszCursor	= AllocateBuffer( fNull_szCursor,  cbCursorMax );
	lpcbCursor	= AllocateBuffer( fNull_pcbCursor, sizeof *lpcbCursor );


/*****************************	#17 SQLGetCursorName	***********************/

	retcode = SQLGetCursorName( hstmt, lszCursor, cbCursorMax, lpcbCursor );

	wsprintf( OutStr, szFormat, cbCursorMax );
	szWrite( OutStr, TRUE );
	EchoRetcode( sz_SQLGetCursorName, retcode );
	lpisa = lpddainfo->lpisaCursor;
	if( FDisplayCbAndRgbArgs( retcode, 0, SQL_C_CHAR,
								sz_apcbCursor, lpcbCursor, cbCursorMax,
								sz_szCursor, lszCursor) && !lpisa->fNull )
	{
		SWORD cbTouched = (SWORD)CbTouchedRgbCbMax( lszCursor, cbCursorMax );
		SWORD cb = lpisa->cb == SQL_NTS || lpcbCursor == NULL ? SQL_NTS : *lpcbCursor;

		ReleaseISA( lpisa );
		lpddainfo->lpisaCursor = lpisa =
			LpisaCreateISA( FALSE, cbTouched,
							cbTouched - (lszCursor[ cbTouched - 1 ] == '\0' ), cb );
		memcpy( lpisa->sz, lszCursor, cbTouched );
	}
	ReleaseMemory( lszCursor  );
	ReleaseMemory( lpcbCursor );
	return;
}/* end DoSQLGetCursorName */


static void DoSQLParamData()
{
	SQLParamDataRec	*info = &(*hglobs)->SQLParamDataInfo;
	RETCODE			retcode;
	PTR				*lplrgbValue = NULL;
	LPAF			lpaf;


	fNew_lplrgbValue	= (lpaf = *LplpafFromHstmt( hstmt )) == NULL
						|| lpaf->General.ifn != ifnParamData;
	if( !fNew_lplrgbValue )
	{	lplrgbValue = lpaf->ParamData.lplrgbValue;
		fNull_prgbValue = (lplrgbValue == NULL);
	}


	info->NullPrgbValueOutChecked = fNew_lplrgbValue;
	if( !GetSQLParamData( info ) )								/*** DIALOG	***/
		return;
	fNull_prgbValue = info->NullPrgbValueOutChecked;

		/* check dialog result	*/

	if( fNew_lplrgbValue )
		lplrgbValue =
			(PTR*)AllocateBuffer( fNull_prgbValue, sizeof( *lplrgbValue ) );


/*****************************	#48 SQLParamData	***************************/

	retcode = SQLParamData( hstmt, lplrgbValue );

	DisplayParamData( retcode, lplrgbValue );

	lpaf = LpafAdd( TRUE, ifnParamData, retcode );
	if( lpaf )
		lpaf->ParamData.lplrgbValue = lplrgbValue;

	else if( fNew_lplrgbValue )
		ReleaseMemory( lplrgbValue );
	return;
}/* end DoSQLParamData */


static void DoSQLPutData()
{
	SQLPutDataRec	*info = &(*hglobs)->SQLPutDataInfo;
	RETCODE			retcode;
	LPAF			lpaf;
	TEHandle		teh;
	short			len, offset;
	Handle			textHan;


	lpaf = *LplpafFromHstmt( hstmt );
	fNew_lszFromInput	= (lpaf == NULL || lpaf->General.ifn != ifnPutData);
	if( !fNew_lszFromInput )
	{
		fCType_PutData		= lpaf->PutData.fCType;
		hrgbValue			= lpaf->PutData.hrgbValue;
		cbValue_PutData		= lpaf->PutData.cbValue;
		cbDefault			= lpaf->PutData.cbDefault;
		cbValueMax_PutData	= lpaf->PutData.cbValueMax;
		fNull_szSqlStr		= (lszFromInput == NULL);
	}


	teh		= cur->inFieldHandle;
	len		= (**teh).selEnd - (**teh).selStart;
	if( len )
	{
		offset	= (**teh).selStart;
	}
	else
	{	len = (**teh).teLength;
		offset	= 0;
	}
	sprintf( info->cbValueText, "%-d", len );
	c2pstr(  info->cbValueText );

	if( !GetSQLPutData( info ) )								/*** DIALOG	***/
		return;

	switch( info->cbValueChoice )
	{
		case 1:		cbValue_PutData = 0;				break;
		case 2:		cbValue_PutData = SQL_NTS;			break;
		case 3:		cbValue_PutData = SQL_NULL_DATA;	break;
	}


	fNull_szSqlStr	= info->NullRgbValueChecked;
	if( fNull_szSqlStr )
	{
		hrgbValue		= 0;
		cbValue_PutData	= 0;
	}
	else
	{	char	*s, *d;
		cbValue_PutData = getTextCount( info->cbValueText );
		textHan = NewHandleClear( len + 2 );

		//hrgbValue	= lszFromInput;					// ??? from input window
		d = hrgbValue	= *textHan;
		s = *((**teh).hText) + offset;
		memcpy( d, s, len );
		d[ len ] = 0;								// NULL terminate
	}


/*****************************	#49 SQLPutData	*******************************/

	retcode = SQLPutData( hstmt, hrgbValue, cbValue_PutData );


	DisposHandle( textHan );	hrgbValue = 0;


	EchoRetcode( sz_SQLPutData, retcode );

	lpaf = LpafAdd( TRUE, ifnPutData, retcode );
	if( lpaf )
	{
		lpaf->PutData.fCType		= fCType_PutData;
		lpaf->PutData.hrgbValue		= hrgbValue;
		lpaf->PutData.cbValue		= cbValue_PutData;
		lpaf->PutData.cbDefault		= cbDefault;
		lpaf->PutData.cbValueMax	= cbValueMax_PutData;
	}
	else if( fNew_lszFromInput )
		ReleaseMemory( hrgbValue );
	return;
}/* end DoSQLPutData */


static void DoSQLFreeStmt()
{
	SQLFreeStmtRec	*info = &(*hglobs)->SQLFreeStmtInfo;
	UWORD			icolBoundMost;
	RETCODE			retcode;
	STMTINFO		*lpstmtinfo;

	
	if( !GetSQLFreeStmt( info ) )								/*** DIALOG	***/
		return;

	icolBoundMost	= IcolUntouchBoundCols( hstmt );
	fOption			= info->fOptionChoice - 1;


/*****************************	#16 SQLFreeStmt	*******************************/

	retcode = SQLFreeStmt( hstmt, fOption );

	EchoRetcode( sz_SQLFreeStmt, retcode );

	if( icolBoundMost )
		IcolBoundColChecks( hstmt, ALWAYS_UNTOUCHED, 0 );

	if( retcode >= SQL_SUCCESS )
	{
		switch( fOption )
		{
		case SQL_UNBIND:
			FreeParamsAndCols( FREE_COLS, hstmt );
			break;

		case SQL_RESET_PARAMS:
			FreeParamsAndCols( FREE_PARAMS, hstmt );
			break;

		case SQL_DROP:
			FreeParamsAndCols( FREE_COLS | FREE_PARAMS, hstmt );
			DeleteAf( LplpafFromHstmt( hstmt ) );

			lpstmtinfo = LpstmtinfoFromHstmt( hstmt );
			if( lpstmtinfo )
			{
				lpstmtinfo->hdbc  = SQL_NULL_HDBC;
				lpstmtinfo->hstmt = SQL_NULL_HSTMT;
				DisableItem( STMTpop.hMenu, lpstmtinfo->istmt+1 );
				STMTpop.choice = 1;					/* Set to NULL choice	*/
				refreshSTMTpop();
			}
			UpdateCurrentHstmt();
			break;
		}/* end SWITCH */
	}
	return;
}/* end DoSQLFreeStmt */


static void DoSQLNativeSQL()
{
	SQLNativeSQLRec			*info = &(*hglobs)->SQLNativeSQLInfo;
	static BYTE CSCONST		szFormat[]      = "cbSqlStrMax = %ld:";
	static BYTE CSCONST		sz_szSqlStr[]   = "szSqlStr";
	static BYTE CSCONST		sz_apcbSqlStr[] = "*pcbSqlStr";

	RETCODE		retcode;
	HPBYTE		hszSqlStrIn,	hszSqlStr;
	SDWORD		cbSqlStr,		*lpcbSqlStr;
	TEHandle	teh;
	short		len, offset;
	Handle		textHan;


	teh		= cur->inFieldHandle;
	len		= (**teh).selEnd - (**teh).selStart;
	if( len )
	{
		offset	= (**teh).selStart;
	}
	else
	{	len = (**teh).teLength;
		offset	= 0;
	}
	sprintf( info->cbSqlStrInText, "%-d", len );
	c2pstr(  info->cbSqlStrInText );


	if( !GetSQLNativeSQL( info ) )								/*** DIALOG	***/
		return;

	fNull_szSqlStr	= info->NullSzSqlStrOutChecked;
	fNull_pcbSqlStr	= info->NullPcbSqlStrOutChecked;

	StringToNum( info->cbSqlStrMaxText, &gNum );
	cbSqlStrMax		= gNum;

	if( fNull_szSqlStr )
	{
		hszSqlStr	= 0;
		cbSqlStrIn	= 0;
	}
	else
	{	char	*s;
		cbSqlStrIn = getTextCount( info->cbSqlStrInText );
		textHan = NewHandleClear( len + 2 );

		hszSqlStrIn	= *textHan;
		s = *((**teh).hText) + offset;
		memcpy( hszSqlStrIn, s, len );
		hszSqlStrIn[ len ] = 0;						// NULL terminate
	}


//	hszSqlStrIn	= lszFromInput;
	hszSqlStr	= AllocateBuffer( fNull_szSqlStr, cbSqlStrMax );	// out
	cbSqlStr	= (SDWORD)UNTOUCHED;								// (out)
	lpcbSqlStr	= fNull_pcbSqlStr ? NULL : (SDWORD*)&cbSqlStr;		// out


/*****************************	#62 SQLNativeSql	***************************/

	retcode = SQLNativeSql( hdbc, hszSqlStrIn, cbSqlStrIn,
								  hszSqlStr,   cbSqlStrMax, lpcbSqlStr );


	DisposHandle( textHan );	hszSqlStrIn = 0;


	wsprintf( OutStr, szFormat, cbSqlStrMax );
	szWrite( OutStr, TRUE );
	EchoRetcode( sz_SQLNativeSql, retcode );

	FDisplayCbAndRgbArgs( retcode, LPCB_SDWORD, SQL_C_CHAR,
							sz_apcbSqlStr, lpcbSqlStr, cbSqlStrMax,
							sz_szSqlStr, hszSqlStr );

	ReleaseMemory( hszSqlStrIn );
	ReleaseMemory( hszSqlStr );

	return;
}/* end DoSQLNativeSQL */


static void DoFillParam()
{
	FillParamRec	*info = &(*hglobs)->FillParamInfo;


	if( !GetFillParam( info ) )
		return;
	return;
}/* end DoFillParam */


static void DoShowParams()
{
	static BYTE CSCONST szComma[]       = ", ";
	static BYTE CSCONST szHead[]        = "hstmt, ipar, fCType, "
				"fSqlType, cbColDef, ibScale, cbValueMax, pcbValue, rgbValue:";
	static BYTE CSCONST szFormat[]      = ", %lu, %d, %ld, ";

	SWORD	fCType;
	SWORD	fSqlType;
	SDWORD	cbValueMax;
	SDWORD	cbValue;
	UDWORD	udwValue;

	LPBOUND		*lplpbound, lpbound;

	lplpbound = LplpboundFirstFromHstmt( hstmt );
	if( lplpbound == NULL )
		return;

	szWrite( szHead, TRUE );

	for( lpbound = *lplpbound; lpbound; lpbound = lpbound->par.lpboundNext )
	{
		if( lpbound->par.fParam == FALSE )  // not a param
			continue;

		fCType		= lpbound->par.fCType;
		fSqlType	= lpbound->par.fSqlType;
		cbValueMax	= lpbound->par.cbValueMax;
		cbValue		= lpbound->par.cbValue;
		udwValue	= lpbound->par.udwValue;

		sprintf( OutStr, "#%10d: %10d,", istmt, lpbound->par.ipar );
		szWrite( OutStr, FALSE );

		szWrite( (LPBYTE)SzConstDisplay(
									LszNameFromFlagArg( &finfo_fCType, fCType ),
									fCType ),
					FALSE );
		szWrite( szComma, FALSE );

		szWrite( (LPBYTE)SzConstDisplay(
							LszNameFromFlagArg( &finfo_fSqlType_NoAll, fSqlType ),
							fSqlType ),
				FALSE );

		wsprintf( OutStr, szFormat,
			lpbound->par.cbColDef, lpbound->par.ibScale, cbValueMax );
		szWrite( OutStr, FALSE );

		szWrite(
			LszIfSz( lpbound->par.fNull_pcb, sz_null_pointer,
				LszIfSz( cbValue == UNTOUCHED, sz_untouched,
					SzConstDisplay( LszNameFromFlagArg( &finfo_cb, cbValue ),
									cbValue ) ) ),
			FALSE );
		szWrite( szComma, FALSE );

		if( !lpbound->par.fNum_rgb )
			DisplayValue( NULL,
				cbValue == SQL_DATA_AT_EXEC ? SQL_C_CHAR :
					FCTypeFromFCTypeFSqlType( fCType, fSqlType ),
				lpbound->par.rgbValue, cbValueMax );

		else if( udwValue == 0 )
			szWrite( sz_null_pointer, FALSE );
		else
		{
			wsprintf( OutStr, szFormatCastNumber, udwValue );
			szWrite( OutStr, FALSE );
		}

		szWrite( ".", TRUE );
	}
	return;
}/* end DoShowParams */


void DoCatalog( short itemNr )
{
	switch( itemNr )
	{
	case CatalogSQLGetTypeInfo:			DoSQLGetTypeInfo();			break;
	case CatalogSQLTables:				DoSQLTables();				break;
	case CatalogSQLColumns:				DoSQLColumns();				break;
	case CatalogSQLStatistics:			DoSQLStatistics();			break;
	case CatalogSQLPrimaryKeys:			DoSQLPrimaryKeys();			break;
	case CatalogSQLForeignKeys:			DoSQLForeignKeys();			break;
	case CatalogSQLTablePrivileges:		DoSQLTablePrivileges();		break;
	case CatalogSQLColumnPrivileges:	DoSQLColumnPrivileges();	break;
	case CatalogSQLSpecialColumns:		DoSQLSpecialColumns();		break;
	case CatalogSQLProcedures:			DoSQLProcedures();			break;
	case CatalogSQLProcedureColumns:	DoSQLProcedureColumns();	break;
	}/* end SWITCH */
	return;
}/* end DoCatalog */


void DoEdit( short itemNr )
{
	switch( itemNr )
	{
	case EditCut:			DoCut();			break;
	case EditCopy:			DoCopy();			break;
	case EditPaste:			DoPaste();			break;
	case EditDelete:		DoDelete();			break;
	case EditClear:			DoClear();			break;
	case EditWordWrap:		DoWordWrap();		break;
	case EditSelectAll:		DoSelectAll();		break;
	case EditShowClipboard:	DoShowClipboard();	break;
	}
	return;
}/* end DoEdit */


void DoFile( short itemNr )
{
	errorFlag = FALSE;
	
	switch( itemNr )
	{
	case FileOpen:		DoOpen();		break;
	case FileSaveAs:	DoSaveAs();		break;
	case FileQuit:		DoQuit();		break;
	}
	return;
}/* end DoFile */


void DoHelp( short itemNr )
{
	switch( itemNr )
	{
	case HelpSQLAllocEnv:	DoSQLAllocEnv();	break;
	case HelpGetInfoAll:	DoGetInfoAll();		break;
	}
	return;
}/* end DoHelp */


void DoMisc( short itemNr )
{
	switch( itemNr )
	{
	case MiscSQLTransact:		DoSQLTransact();		break;
	case MiscSQLCancel:			DoSQLCancel();			break;
	case MiscSQLError:			DoSQLError();			break;
	case MiscSQLGetFunctions:	DoSQLGetFunctions();	break;
	case MiscAllErrors:			DoAllErrors();			break;
	case MiscGetFunctionsAll:	DoGetFunctionsAll();	break;
	}/* end SWITCH */
	return;
}/* end DoMisc */


void DoOptions( short itemNr )
{
	switch( itemNr )
	{
	case OptionsSQLSetConnectOption:	DoSQLSetConnectOption();	break;
	case OptionsSQLGetConnectOption:	DoSQLGetConnectOption();	break;
	case OptionsSQLSetStmtOption:		DoSQLSetStmtOption();		break;
	case OptionsSQLGetStmtOption:		DoSQLGetStmtOption();		break;
	case OptionsSQLParamOptions:		DoSQLParamOptions();		break;
	case OptionsSQLSetScrollOptions:	DoSQLSetScrollOptions();	break;
	}/* end SWITCH */
	return;
}/* end DoOptions */


void DoResults( short itemNr )
{
	switch( itemNr )
	{
	case ResultsSQLNumResultCols:	DoSQLNumResultCols();	break;
	case ResultsSQLDescribeCol:		DoSQLDescribeCol();		break;
	case ResultsSQLColAttributes:	DoSQLColAttributes();	break;
	case ResultsSQLRowCount:		DoSQLRowCount();		break;
	case ResultsSQLBindCols:		DoSQLBindCol();			break;
	case ResultsSQLFetch:			DoSQLFetch();			break;
	case ResultsSQLExtendedFetch:	DoSQLExtendedFetch();	break;
	case ResultsSQLCols:			DoSQLCols();			break;
	case ResultsSQLSetPos:			DoSQLSetPos();			break;
	case ResultsSQLGetData:			DoSQLGetData();			break;
	case ResultsSQLMoreResults:		DoSQLMoreResults();		break;
	case ResultsDescribeColAll:		DoDescribeColAll();		break;
	case ResultsFetchAll:			DoFetchAll();			break;
	case ResultsShowBoundCols:		DoShowBoundCols();		break;
	case ResultsGetDataRow:			DoGetDataRow();			break;
	case ResultsGetDataAll:			DoGetDataAll();			break;
	}/* end SWITCH */
	return;
}/* end DoResults */


void DoStatement( short itemNr )
{
	switch( itemNr )
	{
	case StatementSQLAllocStmt:		DoSQLAllocStmt();		break;
	case StatementSQLPrepare:		DoSQLPrepare();			break;
	case StatementSQLSetParam:		DoSQLSetParam();		break;
	case StatementSQLNumParams:		DoSQLNumParams();		break;
	case StatementSQLDescribeParam:	DoSQLDescribeParam();	break;
	case StatementSQLExecute:		DoSQLExecute();			break;
	case StatementSQLExecDirect:	DoSQLExecDirect();		break;
	case StatementSQLSetCursorName:	DoSQLSetCursorName();	break;
	case StatementSQLGetCursorName:	DoSQLGetCursorName();	break;
	case StatementSQLParamData:		DoSQLParamData();		break;
	case StatementSQLPutData:		DoSQLPutData();			break;
	case StatementSQLFreeStmt:		DoSQLFreeStmt();		break;
	case StatementSQLNativeSQL:		DoSQLNativeSQL();		break;
	case StatementFillParam:		DoFillParam();			break;
	case StatementShowParams:		DoShowParams();			break;
	}/* end SWITCH */
	return;
}/* end DoStatement */


void DoAuto( short itemNr )
{
	switch( itemNr )
	{
	case AutoDriverMenus:	DoDriverMenus();	break;
	case AutoTrace:			DoTrace();			break;
	case AutoTests:			DoTests();			break;
	case AutoAsync:			DoAsync();			break;
//	case AutoStackChecking:	DoStackChecking();	break;
	}/* end SWITCH */
	return;
}/* end DoAuto */
