
	/*
	** RESULTS.C - This is the module containing the code for ODBC for
	** returning results and information about results.
	**
	** (C) Copyright 1991, 1992 By Microsoft Corp.
	*/


#include "sample.h"


	//	This returns the number of columns associated with the database
	//	attached to "lpstmt".

SQL_API RETCODE SQLNumResultCols( HSTMT, SWORD* )
{
	return SQL_SUCCESS;
}


	//	Return information about the database column the user wants
	//	information about.

SQL_API RETCODE SQLDescribeCol( HSTMT, UWORD, UCHAR*, SWORD, SWORD*, SWORD*, UDWORD*, SWORD*, SWORD* )
{
	return SQL_SUCCESS;
}


	//	Returns result column descriptor information for a result set.

SQL_API RETCODE SQLColAttributes( HSTMT, UWORD, UWORD, UCHAR*, SWORD, SWORD*, SDWORD* )
{
	return SQL_SUCCESS;
}


	//	Associate a user-supplied buffer with a database column.

SQL_API RETCODE SQLBindCol( HSTMT, UWORD, SWORD, PTR, SDWORD, SDWORD* )
{
	return SQL_SUCCESS;
}


	//	Returns data for bound columns in the current row ("lpstmt->iCursor"),
	//	advances the cursor.

SQL_API RETCODE SQLFetch( HSTMT )
{
	return SQL_SUCCESS;
}

	//  Returns result data for a single column in the current row.

SQL_API RETCODE SQLGetData( HSTMT, UWORD, SWORD, PTR, SDWORD, SDWORD* )
{
	return SQL_SUCCESS;
}


	//	This determines whether there are more results sets available for
	//  the "lpstmt".

SQL_API RETCODE SQLMoreResults( HSTMT )
{
	return SQL_SUCCESS;
}


	//	This returns the number of rows associated with the database
	//	attached to "lpstmt".

SQL_API RETCODE SQLRowCount( HSTMT, SDWORD* )
{
	return SQL_SUCCESS;
}


	//	This positions the cursor within a block of data.

SQL_API RETCODE SQLSetPos( HSTMT, UWORD, BOOL, BOOL )
{
	return SQL_SUCCESS;
}


	//	This fetchs a block of data (rowset).

SQL_API RETCODE SQLExtendedFetch( HSTMT, UWORD, SDWORD, UDWORD*, UWORD* )
{
	return SQL_SUCCESS;
}


	//  Returns the next SQL error information.

SQL_API RETCODE SQLError( HENV, HDBC, HSTMT, UCHAR*, SDWORD*, UCHAR*, SWORD, SWORD* )
{
	return SQL_NO_DATA_FOUND;
}
