/*
 *	ODBCdbmsSetup.r
 *
 *	Resource descriptions for the setup dialog.
 *
 *	 1993 by Apple Computer, Inc., all rights reserved.
 */

#include "Types.r"
#include "ODBCtypes.r"

/*
 *	include the library's 'libr', 'libi', and 'code' resources
 */

INCLUDE "ODBCdbmsSetup.RSRC";

/*
 *	the vendor descriptor, which is used to identify this setup shared library
 *	from other setup shared libraries
 */

resource 'odds' (0) { "Sample" };

/*
 *	the setup dialog and its resources
 */

resource 'DLOG' (134, "DBMSsetup") {
	{81, 62, 285, 486},
	movableDBoxProc,
	visible,
	goAway,
	0x0,
	134,
	"DBMS Setup Example"
};

resource 'DITL' (134, "DBMSsetup") {
	{	/* array DITLarray: 13 elements */
		/* [1] */
		{168, 320, 188, 400},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{168, 216, 188, 296},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{16, 12, 32, 142},
		StaticText {
			disabled,
			"Data Source Name:"
		},
		/* [4] */
		{44, 56, 60, 141},
		StaticText {
			disabled,
			"Description:"
		},
		/* [5] */
		{72, 92, 88, 139},
		StaticText {
			disabled,
			"Other:"
		},
		/* [6] */
		{16, 144, 32, 406},
		EditText {
			enabled,
			""
		},
		/* [7] */
		{44, 144, 60, 406},
		EditText {
			enabled,
			""
		},
		/* [8] */
		{72, 144, 88, 406},
		EditText {
			enabled,
			""
		},
		/* [9] */
		{120, 12, 136, 96},
		StaticText {
			disabled,
			"Translation:"
		},
		/* [10] */
		{120, 96, 136, 312},
		StaticText {
			disabled,
			"No Translator                           "
			"     "
		},
		/* [11] */
		{118, 320, 138, 400},
		Button {
			enabled,
			"Select"
		},
		/* [12] */
		{104, 12, 106, 409},
		UserItem {
			disabled
		},
		/* [13] */
		{148, 12, 150, 409},
		UserItem {
			disabled
		}
	}
};

resource 'dctb' (134, "DBMSsetup")
{
	{	/* array ColorSpec: 0 elements */
	}
};
