/*
 *	ODBCdataTranslate.r
 *
 *	Resource descriptions for the data translate dialog.
 *
 *	 1993 by Apple Computer, Inc., all rights reserved.
 */

#include "Types.r"
#include "ODBCtypes.r"

/*
 *	include the library's 'libr', 'libi', and 'code' resources
 */

INCLUDE "ODBCdataTranslate.RSRC";

/*
 *	the vendor descriptor, which is used to identify this translate shared library
 *	from other setup shared libraries
 */

resource 'oddt' (0) { "Sample" };

/*
 *	the translate dialog and its resources
 */

resource 'DLOG' (132, "ConfigTranslator") {
	{58, 51, 198, 336},
	movableDBoxProc,
	visible,
	goAway,
	0x0,
	132,
	"Sample Translator"
};

data 'DITL' (132, "ConfigTranslator") {
	$"0007 0000 0000 0068 00B8 007C 0108 0402"            /* .......h..|.... */
	$"4F4B 0000 0000 0068 0050 007C 00A0 0406"            /* OK.....h.P.|... */
	$"4361 6E63 656C 0000 0000 0028 0014 0038"            /* Cancel.....(...8 */
	$"0082 060D 5472 616E 736C 6174 696F 6E20"            /* ..Translation  */
	$"3100 0000 0000 003C 0014 004C 0082 060D"            /* 1......<...L.. */
	$"5472 616E 736C 6174 696F 6E20 3200 0000"            /* Translation 2... */
	$"0000 0028 0094 0038 0102 060D 5472 616E"            /* ...(..8...Tran */
	$"736C 6174 696F 6E20 3300 0000 0000 003C"            /* slation 3......< */
	$"0094 004C 0102 060D 5472 616E 736C 6174"            /* ..L...Translat */
	$"696F 6E20 3400 0000 0000 001C 000C 0057"            /* ion 4..........W */
	$"0110 8002 0002 0000 0000 000C 000C 001C"            /* ............... */
	$"0110 8813 5472 616E 736C 6174 696F 6E20"            /* ...Translation  */
	$"4F70 7469 6F6E 7300"                                /* Options. */
};

resource 'dctb' (132) {
	{	/* array ColorSpec: 0 elements */
	}
};

