// File: HelloPartDef.h
//
// Common constants used by our code & Rez file
//
// We Can't just integrate these into HelloPart.h, since that file
// includes some XMP headers, which makes it unsuitable for use with
// Rez.

#ifndef __HELLOPARTDEF__
#define __HELLOPARTDEF__

// Kind
#define kHelloPartKind "Apple:Kind:HelloPart"

// Kind
#define kHelloPartCategory "Apple:Category:HelloPart"

// Class ID
#define kHelloPartID "appl:sample:HelloPart$class"

// Editor User String
#define kHelloPartEditorUserString "HelloPart 1.0"

// Kind User String
#define kHelloPartKindUserString "HelloPart Kind"

// Category User String
#define kHelloPartCategoryUserString "HelloPart Category"

// HelloPart OSType
#define kHelloPartOSType 'GEEK'

#define kKindCategoryMapId			kNMAPid+1
#define kEditorKindMapId			kNMAPid+2
#define kEditorUserStringMapId		kNMAPid+3
#define kKindUserStringMapId		kNMAPid+4
#define kCategoryUserStringMapId	kNMAPid+5
#define kOldMacOSTypeMapId			kNMAPid+6

#endif
