/*
	File:		StorgDef.h

	Contains:	defines for storage code and resources

	Written by:	Caia Grisar

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 1/21/94	CG		Renamed kXMPMemoryContainer and
									kXMPFileContainer to
									kXMPDefaultMemoryContainer and
									kXMPDefaultFileContainer.
		 <1>	 1/18/94	CG		first checked in

	To Do:
*/

#ifndef _STORGDEF_
#define _STORGDEF_

#define kXMPDefaultFileContainer	"Apple:ContainerType:File"
#define kXMPDefaultMemoryContainer 	"Apple:ContainerType:Memory"

#endif //_STORGDEF_
