#
#	File:		OperNew.mak
#
#	Contains:	Makefile for OpenDoc new operators
#
#	Written by:	Nick Pilch
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		 <4>	 3/23/94	NP		Rebuilt dependencies.
#		 <3>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
#									#1150864.
#		 <2>	 2/10/94	T		.cp -> .cpp
#		 <2>	 12/3/93	T		Rename XMPError.h to ErrorDef.h
#		 <1>	11/29/93	NP		first checked in
#
#	To Do:
#

# DIRECTORY DEPENDENCIES

"{JediObjects}" 	"{JediUtilitiesDir}"
				
#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

OperatorNewOBJECTS = 
			"{JediObjects}XMPNew.cpp.o"					

OperatorNewSOURCEFILES = 
			"{JediUtilitiesDir}"XMPNew.cpp					

###########################################################################
# ROOT TARGETS
###########################################################################

# BUILD LIBRARIES

BuildCF  "{JediObjects}"OperatorNewLib.o
	Echo -n "" > "{MPW}"JediAppName

BuildSC  "{JediObjects}"OperatorNewLib.o
	Echo -n "" > "{MPW}"JediAppName

BuildCFASLM  "{JediObjects}OperatorNewLib.o"
	Echo -n "" > "{MPW}"JediAppName

BuildSCASLM  "{JediObjects}OperatorNewLib.o"
	Echo -n "" > "{MPW}"JediAppName


"{JediObjects}"OperatorNewLib.o  {OperatorNewOBJECTS}
	Echo Libing: {Targ}
	Lib {LibOptions} {Deps} -o {Targ}


# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-ignore "{CIncludes}"								
		-append "{MAKEFILE}"								
		-objdir "{JediObjects}"								
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{JediBinaryDir}"DummyTarget					
		{OperatorNewSOURCEFILES}

#*** Dependencies: Cut here ***
# This makefile was produced at 1:34:51 PM on Wed, Mar 23, 1994 by
# MakeDepend

"{JediObjects}"XMPNew.cpp.o	  
	"{JediUtilitiesDir}"XMPNew.cpp 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediUtilitiesDir}"XMPMem.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"ErrorDef.h

