//	File:		MovieDef.h
//
//	Contains:	Common definitions for CMoviePart
//
//	Written by:	Lonnie Millett
//
//	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.


#ifndef __MOVIEDEF__
#define __MOVIEDEF__

// Kind
#define kSampleMovieKind "Apple:OSType:Scrap:moov"

// Class ID
#define kCMoviePartID "appl:framework:sample:moviepart$class,1.0.0"

// Editor User String
#define kSampleMovieEditorUserString "Sample Movie 1.0"

// Kind User String
#define kSampleMovieKindUserString "Sample Movie"

// Category User String
#define kSampleMovieCategoryUserString "Video"

// Movie OSType
#define kSampleMovieOSType 'moov'

#ifdef ASLMBUILD
#define FW_kKindCategoryMapId		kNMAPid+1
#define FW_kEditorKindMapId			kNMAPid+2
#define FW_kEditorUserStringMapId	kNMAPid+3
#define FW_kKindUserStringMapId		kNMAPid+4
#define FW_kCategoryUserStringMapId	kNMAPid+5
#define FW_kOldMacOSTypeMapId		kNMAPid+6
#else
// For the static build, the value of FW_kKindCategoryMap must pick up where the last part
// left off. kNMAPid+43 is the last value used by the QDrawPart.
#define FW_kKindCategoryMapId		kNMAPid+44
#define FW_kEditorKindMapId			kNMAPid+45
#define FW_kEditorUserStringMapId	kNMAPid+46
#define FW_kKindUserStringMapId		kNMAPid+47
#define FW_kCategoryUserStringMapId	kNMAPid+48
#define FW_kOldMacOSTypeMapId			kNMAPid+49
// Our text part picks up with kNMAPid+50, see TextDef.h
#endif

// Menus
#define kMovieMenu 7

#endif

