/*
	File:		MovieSel.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 3/21/94	DS		Add constant to this file that was removed
									from OpenDoc. This Sucks.

	To Do:
*/

//	File:		MovieSel.h
//
//	Contains:	Definition for class CMovieSelection
//
//	Written by:	Lonnie Millett
//
//	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.

#ifndef _MOVIESEL_
#define _MOVIESEL_

// ----- FrameWork Includes -----

#ifndef _FWSELECT_
#include <FWSelect.h>
#endif

//==============================================================================
//	 Forward Declarations
//==============================================================================

class CMoviePart;
class CDrawFrame;
class CFacet;
class CSelectionIterator;

//==============================================================================
//	 Forward Declarations
//==============================================================================
const	XMPValueType	kXMPApplePICT	= "Apple:OSType:Scrap:PICT";
const	XMPValueType	kXMPAppleTEXT	= "Apple:OSType:Scrap:TEXT";
const	XMPValueType	kXMPApplesnd	= "Apple:OSType:Scrap:snd ";

//==============================================================================
//	 class CMovieSelection
//==============================================================================

class CMovieSelection : public FW_CSelection
{
	
//------------------------------------------------------------------------------
//	 Initialization/Destruction
//------------------------------------------------------------------------------
public:
	CMovieSelection();
	void			InitMovieSelection(CMoviePart* moviePart);
	virtual 		~CMovieSelection();
	
//------------------------------------------------------------------------------
//	 Inherited API
//------------------------------------------------------------------------------
public:
	virtual void		CloseSelection();
	virtual void		SelectAll();
	virtual XMPBoolean	IsEmpty() const;

	// ----- Cut/Copy/Paste/Clear -----
	virtual XMPBoolean	DoClear();
	
	virtual void		ExternalizeSelection(XMPStorageUnit* storageUnit, CFrame* commandFrame, XMPCloneKind cloneKind);
	virtual XMPBoolean	InternalizeSelection(XMPStorageUnit* storageUnit, XMPCloneKind cloneKind);
	void PasteOSTypeToMovies(Handle newHandle, OSType handleType);

//------------------------------------------------------------------------------
//	 Data Members
//------------------------------------------------------------------------------
private:
	CMoviePart*			fMoviePart;
};

#endif