/*
	File:		ClockDef.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <8>	 3/28/94	CG		1150376: No longer support ASLM versioning.
		 <7>	  2/8/94	JA		Moved 'kNMAPIDxx' consts to Clock.r
		 <6>	 1/18/94	CG		Added define for file type.
		 <5>	 1/14/94	CG		Added defines for user strings.
		 <4>	 1/12/94	CG		Added kNMAPid1 and 2.
		 <3>	12/16/93	RR		Changed dialog ids to avoid overlap
		 <2>	12/16/93	RR		Added ids for alerts, dialogs and menus
		 <1>	11/22/93	T		first checked in

	To Do:
		Put strings in STR resources.
*/

#ifndef _CLOCKDEF_
#define _CLOCKDEF_

#ifndef _STDDEFS_
	#include "StdDefs.h"
#endif _STDDEFS_

// Kind
#define kXMPKindTestClock "Apple:Kind:TestClock"

// Class ID
#define kClockPartID "appl:clockpart$class"

// Editor User String
#define kClockEditorUserString "Test Clock 1.0"

// Kind User String
#define kClockKindUserString "Test Clock"

// Category User String
#define kClockCategoryUserString "Time"

// Clock OSType
#define kClockOSType 'CLCK'

#define kXMPClockPart_FontMenuID		100
#define kXMPClockPart_SizeMenuID		101
#define kXMPClockPart_StyleMenuID		102 
#define kXMPClockPart_SettingsMenuID	103

#define kXMPClockPart_Size_9Pt			1
#define kXMPClockPart_Size_10Pt			2
#define kXMPClockPart_Size_11Pt			3
#define kXMPClockPart_Size_12Pt			4
#define kXMPClockPart_Size_14Pt			5
#define kXMPClockPart_Size_18Pt			6
#define kXMPClockPart_Size_24Pt			7
#define kXMPClockPart_Size_36Pt			8

#define kXMPClockPart_Style_Plain		1
#define kXMPClockPart_Style_Bold		2
#define kXMPClockPart_Style_Italic		3
#define kXMPClockPart_Style_Underline	4
#define kXMPClockPart_Style_Outline		5
#define kXMPClockPart_Style_Shadow		6
#define kXMPClockPart_Style_Condense	7
#define kXMPClockPart_Style_Extend		8

#define kXMPClockPart_AboutBoxID			4128
#define kXMPClockPart_SynchronizeDialogID	4129
#define kXMPClockPart_SettingsDialogID		4130
#define kXMPClockPart_SettingsCheckBoxID	1

#endif //_CLOCKDEF_

