/*
	File:		DragDef.h

	Contains:	defines for DragPart code and resources

	Written by:	Tantek elik

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <6>	 3/28/94	CG		1150376: No longer support ASLM versioning.
		 <5>	  2/8/94	JA		Moved 'kNMAPIDxx' consts to DragPart.r
		 <4>	 1/18/94	CG		Added define for file type.
		 <3>	 1/14/94	CG		Added defines for user strings.
		 <2>	 1/12/94	CG		Added kNMAPid1 and 2.
		 <1>	11/24/93	T		first checked in

	To Do:
*/

#ifndef _DRAGDEF_
#define _DRAGDEF_

// Kind
#define kXMPKindTestDrag "Apple:Kind:TestDrag"

// Class ID
#define kDragPartID "appl:dragpart$class"

// Editor User String
#define kDragEditorUserString "Test Text 1.0"

// Kind User String
#define kDragKindUserString "Test Drag"

// Category User String
#define kDragCategoryUserString "Text"

// Drag OSType
#define kDragOSType 'DRAG'

#endif //_DRAGDEF_

