/*
	File:		CmdDefs.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <6>	 1/14/94	eeh		added kXMPCommandOpenDocument
		 <5>	 1/11/94	eeh		added kXMPCommandAddDeleteAOCEMailer in
									keeping place of separate Add and Delete
		 <4>	12/13/93	RR		Added kXMPCommandAbout
		 <3>	11/15/93	eeh		added kXMPCommandForwardMail,
									kXMPCommandReplyToMail, and
									kXMPCommandReplyToAllMail
		 <2>	 11/9/93	SS		Fixed type-o (kXMPCommandClear)
		 <1>	10/14/93	RR		first checked in

	To Do:
*/

#ifndef _CMDDEFS_
#define _CMDDEFS_

// This file can be compiled by C/C++ and Rez.
// It contains #defines for the command numbers of the standard menu items
// of the document shell

//!!! We should reserve a range

#define	kXMPCommandAbout				999

#define	kXMPCommandNew					1000
#define	kXMPCommandOpen					1001
#define	kXMPCommandOpenDocument			1002
#define	kXMPCommandInsert				1003
#define	kXMPCommandClose				1004
#define	kXMPCommandSave					1005
#define	kXMPCommandSaveACopy			1006
#define	kXMPCommandRevert				1007
#define	kXMPCommandDraft				1008
#define	kXMPCommandPageSetup			1009
#define	kXMPCommandPrint				1010
#define	kXMPCommandShowPartsBin			1011

#define	kXMPCommandAddDeleteAOCEMailer	1030
#define	kXMPCommandExpandAOCEMailer		1031
#define	kXMPCommandContractAOCEMailer	1032
#define	kXMPCommandSendMail				1033
#define	kXMPCommandForwardMail			1034
#define	kXMPCommandReplyToMail			1035
#define	kXMPCommandReplyToAllMail		1036

#define	kXMPCommandUndo					1016
#define	kXMPCommandRedo					1017
#define	kXMPCommandCut					1018
#define	kXMPCommandCopy					1019
#define	kXMPCommandPaste				1020
#define	kXMPCommandPasteAs				1021
#define	kXMPCommandClear				1022
#define	kXMPCommandSelectAll			1023
#define	kXMPCommandGetPartInfo			1024
#define	kXMPCommandPreferences			1025
#define	kXMPCommandViewAsWin			1026

#endif	// _CMDDEFS_