
#define Hello_Class_Source
#include <hello.ih>


#include <Types.h>
#include <Files.h>


#include <stdio.h>
#include <string.h>
static void sendmessage ( char *message );


SOM_Scope void  SOMLINK sayHello (Hello *somSelf, Environment *ev)
{
    /* HelloData *somThis = HelloGetData(somSelf); */
    /* HelloMethodDebug( "Hello","sayHello" ); */
    sendmessage ( " <from C method: Quack!... > " );
    sendmessage ( _get_msg ( somSelf, ev ) );
	sendmessage ( "-------" );
} /* sayHello () */

SOM_Scope void  SOMLINK somInit (Hello *somSelf)
{
    /* HelloData *somThis = HelloGetData(somSelf); */
    /* HelloMethodDebug("Hello","somInit"); */

    Hello_parent_SOMObject_somInit(somSelf);
	
    __set_msg ( somSelf, somGetGlobalEnvironment (), " <from C override: Like a duck!> " );
} /* somInit () */


SOM_Scope Hello*  SOMLINK HelloCreate (M_Hello *somSelf, Environment *ev,
		string message)
{
    Hello *obj = _somNew ( somSelf );
	static char temp [256];

    /* M_HelloData *somThis = M_HelloGetData(somSelf); */
    /* M_HelloMethodDebug("M_Hello","HelloCreateClass"); */

	strcpy ( temp, " [from C MetaClassInit:" );
    strcat ( temp, message );
	strcat ( temp, " ] " );
	
    __set_msg ( obj, ev, temp );
    
    /* Return statement to be customized: */
    return obj;
} /* HelloCreate () */



#define USEFOPEN 1

static void sendmessage ( char *message )
{
#if USEDEBUGSTR
	Str255 pStr;
	unsigned char *to, *from;
	to = pStr+1;
	from = (unsigned char *) message;
	while ( *to++ = *from++ ) { }
	pStr [0] = to - pStr - 2;
	DebugStr ( pStr );
#elif USEFOPEN
	OSErr err;
	FILE *fp;
	err = HCreate ( 0, 0, (StringPtr) "\pOutput", 'MPS ', 'TEXT' );
	fp = fopen ( "Output", "a" );
	fprintf ( fp, "%s\n", message );
	fclose ( fp );
#elif USESTDOUT
    printf ( "%s\n", message );
#elif USEHFS
	OSErr err;
	long count = 0;
	short refNum = 0;
	err = HCreate ( 0, 0, (StringPtr) "\pOutput", 'MPS ', 'TEXT' );
	err = HOpenDF ( 0, 0, (StringPtr) "\pOutput", fsRdWrPerm, & refNum );	
	err = SetFPos ( refNum, fsFromLEOF, 0 );
	count = strlen ( message );
	err = FSWrite ( refNum, & count, message );
	count = 1;
	err = FSWrite ( refNum, & count, "\n" );
	err = FSClose ( refNum );
#else
#error undefined output
#endif
} /* sendmessage () */


