{
 graphics:
  gxFont types
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.

}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT FontTypes;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingFontTypes}
{$SETC UsingFontTypes := 1}


{$I+}
{$SETC FontTypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$SETC UsingIncludes := FontTypesIncludes}

TYPE

{$IFC UNDEFINED VoidDefined}
{$SETC VoidDefined := 1}
VOID = RECORD END;
{$ENDC}

	GxFont = ^Void;
	GxFontPointer = ^GxFont;
	GxFontArray = ARRAY [0..0] OF GxFont;


{ Platform constants and types }
CONST
	gxGlyphPlatform		= -1;
	gxNoPlatform 		= 0;
	gxUnicodePlatform	= 1;
	gxMacintoshPlatform = 2;
	gxISOPlatform		= 3;
	gxMicrosoftPlatform	= 4;
	gxCustomPlatform	= 5;

TYPE
	GxFontPlatform = LongInt;
	GxFontPlatformPointer = ^GxFontPlatform;
	GxFontPlatformArray = ARRAY [0..0] OF GxFontPlatform;


{ Script constants and types }
CONST
	{ Macintosh Scripts }
	gxNoScript			= 1;
	gxRomanScript		= 2;
	gxJapaneseScript	= 3;
	gxTraditionalChineseScript	= 4;
	gxChineseScript		= 4;
	gxKoreanScript		= 5;
	gxArabicScript		= 6;
	gxHebrewScript		= 7;
	gxGreekScript		= 8;
	gxCyrillicScript	= 9;
	gxRussian			= 9;
	gxRSymbolScript		= 10;
	gxDevanagariScript	= 11;
	gxGurmukhiScript	= 12;
	gxGujaratiScript	= 13;
	gxOriyaScript		= 14;
	gxBengaliScript		= 15;
	gxTamilScript		= 16;
	gxTeluguScript		= 17;
	gxKannadaScript		= 18;
	gxMalayalamScript	= 19;
	gxSinhaleseScript	= 20;
	gxBurmeseScript		= 21;
	gxKhmerScript		= 22;
	gxThaiScript		= 23;
	gxLaotianScript		= 24;
	gxGeorgianScript	= 25;
	gxArmenianScript	= 26;
	gxSimpleChineseScript = 27;
	gxTibetanScript		= 28;
	gxMongolianScript	= 29;
	gxGeezScript		= 30;
	gxEthiopicScript	= 30;
	gxAmharicScript		= 30;
	gxSlavicScript		= 31;
	gxEastEuropeanRomanScript = 31;
	gxVietnameseScript	= 32;
	gxExtendedArabicScript = 33;
	gxSindhiScript		= 33;
	gxUninterpretedScript=34;

	{ ISO Scripts }
	gxISOASCIIScript	= 1;
	gxISO8859_1Script	= 2;
	gxISO10646BaseScript= 3;

	{ Custom Scripts }
	gxCustom8BitScript	= 1;
	gxCustom816BitScript= 2;
	gxCustom16BitScript	= 3;

TYPE
	GxFontScript = LongInt;
	GxFontScriptPointer = ^GxFontScript;
	GxFontScriptArray = ARRAY [0..0] OF GxFontScript;


{ Font Language constants and types }
CONST
	gxNoLanguage			= 1;
	gxEnglishLanguage		= 2;
	gxFrenchLanguage		= 3;
	gxGermanLanguage		= 4;
	gxItalianLanguage		= 5;
	gxDutchLanguage			= 6;
	gxSwedishLanguage		= 7;
	gxSpanishLanguage		= 8;
	gxDanishLanguage		= 9;
	gxPortugueseLanguage	= 10;
	gxNorwegianLanguage		= 11;
	gxHebrewLanguage		= 12;
	gxJapaneseLanguage		= 13;
	gxArabicLanguage		= 14;
	gxFinnishLanguage		= 15;
	gxGreekLanguage			= 16;
	gxIcelandicLanguage		= 17;
	gxMalteseLanguage		= 18;
	gxTurkishLanguage		= 19;
	gxCroatianLanguage		= 20;
	gxTradChineseLanguage	= 21;
	gxUrduLanguage			= 22;
	gxHindiLanguage			= 23;
	gxThaiLanguage			= 24;
	gxKoreanLanguage		= 25;
	gxLithuanianLanguage	= 26;
	gxPolishLanguage		= 27;
	gxHungarianLanguage		= 28;
	gxEstonianLanguage		= 29;
	gxLettishLanguage		= 30;
	gxLatvianLanguage		= 30;
	gxSaamiskLanguage		= 31;
	gxLappishLanguage		= 31;
	gxFaeroeseLanguage		= 32;
	gxFarsiLanguage			= 33;
	gxPersianLanguage		= 33;
	gxRussianLanguage		= 34;
	gxSimpChineseLanguage	= 35;
	gxFlemishLanguage		= 36;
	gxIrishLanguage			= 37;
	gxAlbanianLanguage		= 38;
	gxRomanianLanguage		= 39;
	gxCzechLanguage			= 40;
	gxSlovakLanguage		= 41;
	gxSlovenianLanguage		= 42;
	gxYiddishLanguage		= 43;
	gxSerbianLanguage		= 44;
	gxMacedonianLanguage	= 45;
	gxBulgarianLanguage		= 46;
	gxUkrainianLanguage		= 47;
	gxByelorussianLanguage	= 48;
	gxUzbekLanguage			= 49;
	gxKazakhLanguage		= 50;
	gxAzerbaijaniLanguage	= 51;
	gxAzerbaijanArLanguage	= 52;
	gxArmenianLanguage		= 53;
	gxGeorgianLanguage		= 54;
	gxMoldavianLanguage		= 55;
	gxKirghizLanguage		= 56;
	gxTajikiLanguage		= 57;
	gxTurkmenLanguage		= 58;
	gxMongolianLanguage		= 59;
	gxMongolianCyrLanguage	= 60;
	gxPashtoLanguage		= 61;
	gxKurdishLanguage		= 62;
	gxKashmiriLanguage		= 63;
	gxSindhiLanguage		= 64;
	gxTibetanLanguage		= 65;
	gxNepaliLanguage		= 66;
	gxSanskritLanguage		= 67;
	gxMarathiLanguage		= 68;
	gxBengaliLanguage		= 69;
	gxAssameseLanguage		= 70;
	gxGujaratiLanguage		= 71;
	gxPunjabiLanguage		= 72;
	gxOriyaLanguage			= 73;
	gxMalayalamLanguage		= 74;
	gxKannadaLanguage		= 75;
	gxTamilLanguage			= 76;
	gxTeluguLanguage		= 77;
	gxSinhaleseLanguage		= 78;
	gxBurmeseLanguage		= 79;
	gxKhmerLanguage			= 80;
	gxLaoLanguage			= 81;
	gxVietnameseLanguage	= 82;
	gxIndonesianLanguage	= 83;
	gxTagalogLanguage		= 84;
	gxMalayRomanLanguage	= 85;
	gxMalayArabicLanguage	= 86;
	gxAmharicLanguage		= 87;
	gxTigrinyaLanguage		= 88;
	gxGallaLanguage			= 89;
	gxOromoLanguage			= 89;
	gxSomaliLanguage		= 90;
	gxSwahiliLanguage		= 91;
	gxRuandaLanguage		= 92;
	gxRundiLanguage			= 93;
	gxChewaLanguage			= 94;
	gxMalagasyLanguage		= 95;
	gxEsperantoLanguage		= 96;
	gxWelshLanguage			= 129;
	gxBasqueLanguage		= 130;
	gxCatalanLanguage		= 131;
	gxLatinLanguage			= 132;
	gxQuechuaLanguage		= 133;
	gxGuaraniLanguage		= 134;
	gxAymaraLanguage		= 135;
	gxTatarLanguage			= 136;
	gxUighurLanguage		= 137;
	gxDzongkhaLanguage		= 138;
	gxJavaneseRomLanguage	= 139;
	gxSundaneseRomLanguage	= 140;

TYPE
	GxFontLanguage = LongInt;
	GxFontLanguagePointer = ^GxFontLanguage;
	GxFontLanguageArray = ARRAY [0..0] OF GxFontLanguage;

{ Font name constants and types }
CONST
	gxNoFontName			= 1;
	gxCopyrightFontName		= 2;
	gxFamilyFontName		= 3;
	gxStyleFontName			= 4;
	gxUniqueFontName		= 5;
	gxFullFontName			= 6;
	gxVersionFontName		= 7;
	gxPostscriptFontName	= 8;
	gxTrademarkFontName		= 9;
	gxManufacturerFontName	= 10;


TYPE
	GxFontName = LongInt;
	GxFontNamePointer = ^GxFontName;
	GxFontNameArray = ARRAY [0..0] OF GxFontName;

	GxFontTableTag = LongInt;
	GxFontTableTagPointer = ^GxFontTableTag;
	GxFontTableTagArray = ARRAY [0..0] OF GxFontTableTag;
	
	GxFontVariationTag = LongInt;
	GxFontVariationTagPointer = ^GxFontVariationTag;
	GxFontVariationTagArray = ARRAY [0..0] OF GxFontVariationTag;
	
	GxFontFormatTag = LongInt;
	GxFontFormatTagPointer = ^GxFontFormatTag;
	GxFontFormatTagArray = ARRAY [0..0] OF GxFontFormatTag;
	
	GxFontStorageTag = LongInt;
	GxFontStorageTagPointer = ^GxFontStorageTag;
	GxFontStorageTagArray = ARRAY [0..0] OF GxFontStorageTag;

	GxFontDescriptorTag = GxFontVariationTag;

	GxFontVariation = RECORD
		name: GxFontVariationTag;
		value: Fixed;
		END;
	GxFontVariationPointer = ^GxFontVariation;
	GxFontVariationArray = ARRAY [0..0] OF GxFontVariation;

	GxFontDescriptor = GxFontVariation;
	GxFontDescriptorPointer = ^GxFontDescriptor;
	GxFontDescriptorArray = ARRAY [0..0] OF GxFontDescriptor;


	GxFontRunFeature = RECORD
		featureType: UnsignedInteger;
		setting: UnsignedInteger;
		END;
	GxFontRunFeaturePointer = ^GxFontRunFeature;
	GxFontRunFeatureArray = ARRAY [0..0] OF GxFontRunFeature;
	
	
	GxFontFeatureSetting = RECORD
		setting: UnsignedInteger;
		nameID: UnsignedInteger;
		END;
	GxFontFeatureSettingPointer = ^GxFontFeatureSetting;
	GxFontFeatureSettingArray = ARRAY [0..0] OF GxFontFeatureSetting;


{ Font Attribute constants and types }
CONST
	gxSystemFontAttribute = 1;
	gxReadOnlyFontAttribute = 2;

TYPE
	GxFontAttribute = LongInt;
	GxFontAttributePointer = ^GxFontAttribute;
	GxFontAttributeArray = ARRAY [0..0] OF GxFontAttribute;


{ Font Feature constants and types }
CONST
	gxMutuallyExclusiveFeature = 32768;

TYPE
	GxFontFeatureFlag = LongInt;
	GxFontFeatureFlagPointer = ^GxFontFeatureFlag;
	GxFontFeatureFlagArray = ARRAY [0..0] OF GxFontFeatureFlag;
	
	GxFontFeature = LongInt;
	GxFontFeaturePointer = ^GxFontFeature;
	GxFontFeatureArray = ARRAY [0..0] OF GxFontFeature;


{ Font Storage constants and types }
CONST
	gxResourceFontStorage	= 'rsrc';
	gxHandleFontStorage		= 'hndl';
	gxFileFontStorage		= 'bass';
	gxNfntFontStorage		= 'nfnt';
	
TYPE
	GxFontStorageReference = ^VOID;
	GxFontStorageReferencePointer = ^GxFontStorageReference;
	GxFontStorageReferenceArray = ARRAY [0..0] OF GxFontStorageReference;



{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
