{
 graphics:
    public error equates
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.    
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT GraphicsErrors;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingGraphicsErrors}
{$SETC UsingGraphicsErrors := 1}


CONST

	{ Error Constants }
	out_of_memory = -27999;
	internal_fatal_error = -27998;
	no_outline_font_found = -27997;
	not_enough_memory_for_graphics_client_heap = -27996;
	could_not_create_backing_store = -27995;
	internal_error = -27800;
	internal_font_error = -27799;
	internal_layout_error = -27798;
	functionality_unimplemented = -27797;
	clip_to_frame_shape_unimplemented = -27796;
	gxFirstFontScalerError = -27795;
	null_font_scaler_context = -27795;
	null_font_scaler_input = -27794;
	invalid_font_scaler_context = -27793;
	invalid_font_scaler_input = -27792;
	invalid_font_scaler_font_data = -27791;
	font_scaler_newblock_failed = -27790;
	font_scaler_bitmap_allocation_failed = -27789;
	font_scaler_outline_allocation_failed = -27788;
	required_font_scaler_table_missing = -27787;
	unsupported_font_scaler_outline_format = -27786;
	unsupported_font_scaler_stream_format = -27785;
	unsupported_font_scaler_font_format = -27784;
	font_scaler_hinting_error = -27783;
	font_scaler_rasterizer_error = -27782;
	font_scaler_internal_error = -27781;
	font_scaler_invalid_matrix = -27780;
	font_scaler_fixed_overflow = -27779;
	font_scaler_api_version_mismatch = -27778;
	gxLastFontScalerError = -27778;
	unknown_font_scaler_error = -27777;
	illegal_font_storage_type = -27776;
	illegal_font_storage_reference = -27775;
	illegal_font_attributes = -27774;
	illegal_font_parameter = -27773;
	font_cannot_be_changed = -27772;
	fragmented_memory = -27771;
	could_not_dispose_backing_store = -27770;
	unflattening_interrupted_by_client = -27769;
	parameter_is_nil = -27700;
	shape_is_nil = -27699;
	style_is_nil = -27698;
	transform_is_nil = -27697;
	ink_is_nil = -27696;
	transferMode_is_nil = -27695;
	color_is_nil = -27694;
	colorProfile_is_nil = -27693;
	colorSet_is_nil = -27692;
	spoolProcedure_is_nil = -27691;
	tag_is_nil = -27690;
	type_is_nil = -27689;
	mapping_is_nil = -27688;
	parameter_out_of_range = -27687;
	inconsistent_parameters = -27686;
	index_is_less_than_zero = -27685;
	index_is_less_than_one = -27684;
	count_is_less_than_zero = -27683;
	count_is_less_than_one = -27682;
	contour_is_less_than_zero = -27681;
	length_is_less_than_zero = -27680;
	invalid_client_reference = -27679;
	invalid_graphics_heap_start_pointer = -27678;
	invalid_nongraphic_globals_pointer = -27677;
	colorSpace_out_of_range = -27676;
	pattern_lattice_out_of_range = -27675;
	frequency_parameter_out_of_range = -27674;
	tinting_parameter_out_of_range = -27673;
	method_parameter_out_of_range = -27672;
	space_may_not_be_indexed = -27671;
	glyph_index_too_small = -27670;
	no_glyphs_added_to_font = -27669;
	glyph_not_added_to_font = -27668;
	point_does_not_intersect_bitmap = -27667;
	required_font_table_not_present = -27666;
	unknown_font_table_format = -27665;
	shapeFill_not_allowed = -27664;
	inverseFill_face_must_set_clipLayer_flag = -27663;
	invalid_transferMode_colorSpace = -27662;
	colorProfile_must_be_nil = -27661;
	bitmap_pixel_size_must_be_1 = -27660;
	empty_shape_not_allowed = -27659;
	ignorePlatformShape_not_allowed = -27658;
	nil_style_in_glyph_not_allowed = -27657;
	complex_glyph_style_not_allowed = -27656;
	cannot_set_item_shapes_to_nil = -27655;
	cannot_use_original_item_shapes_when_growing_picture = -27654;
	cannot_add_unspecified_new_glyphs = -27653;
	cannot_dispose_locked_tag = -27652;
	cannot_dispose_locked_shape = -27651;
	graphic_type_does_not_have_a_structure = -27650;
	style_run_array_does_not_match_number_of_characters = -27649;
	rectangles_cannot_be_inserted_into = -27648;
	unknown_graphics_heap = -27647;
	graphics_routine_selector_is_obsolete = -27646;
	cannot_set_graphics_client_memory_without_setting_size = -27645;
	graphics_client_memory_too_small = -27644;
	graphics_client_memory_is_already_allocated = -27643;
	viewPort_is_a_window = -27642;
	illegal_type_for_shape = -27641;
	invalid_viewDevice_reference = -27640;
	invalid_viewGroup_reference = -27639;
	invalid_viewPort_reference = -27638;
	no_owners = -27637;
	bad_address = -27636;
	object_wrong_type = -27635;
	shape_wrong_type = -27634;
	style_wrong_type = -27633;
	ink_wrong_type = -27632;
	transform_wrong_type = -27631;
	device_wrong_type = -27630;
	port_wrong_type = -27629;
	shape_cache_wrong_type = -27628;
	style_cache_wrong_type = -27627;
	ink_cache_wrong_type = -27626;
	transform_cache_wrong_type = -27625;
	port_cache_wrong_type = -27624;
	shape_cache_parent_mismatch = -27623;
	style_cache_parent_mismatch = -27622;
	ink_cache_parent_mismatch = -27621;
	transform_cache_parent_mismatch = -27620;
	port_cache_parent_mismatch = -27619;
	invalid_shape_cache_port = -27618;
	invalid_shape_cache_device = -27617;
	invalid_ink_cache_port = -27616;
	invalid_ink_cache_device = -27615;
	invalid_style_cache_port = -27614;
	invalid_style_cache_device = -27613;
	invalid_transform_cache_port = -27612;
	invalid_transform_cache_device = -27611;
	indirect_memory_block_too_small = -27610;
	indirect_memory_block_too_large = -27609;
	unexpected_nil_pointer = -27608;
	invalid_pointer = -27607;
	invalid_seed = -27606;
	invalid_frame_seed = -27605;
	invalid_text_seed = -27604;
	invalid_draw_seed = -27603;
	bad_private_flags = -27602;
	text_bounds_cache_wrong_size = -27601;
	text_metrics_cache_wrong_size = -27600;
	text_index_cache_wrong_size = -27599;
	bitmap_ptr_too_small = -27598;
	bitmap_ptr_not_aligned = -27597;
	bitmap_rowBytes_negative = -27596;
	bitmap_width_negative = -27595;
	bitmap_height_negative = -27594;
	invalid_pixelSize = -27593;
	bitmap_rowBytes_too_small = -27592;
	bitmap_rowBytes_not_aligned = -27591;
	bitmap_rowBytes_must_be_specified_for_user_image_buffer = -27590;
	invalid_matrix_flag = -27589;
	invalid_vector_count = -27588;
	invalid_contour_count = -27587;
	recursive_caches = -27586;
	glyph_run_count_negative = -27585;
	glyph_run_count_zero = -27584;
	glyph_run_counts_do_not_sum_to_character_count = -27583;
	glyph_first_advance_bit_set_not_allowed = -27582;
	glyph_tangent_vectors_both_zero = -27581;
	layout_run_length_negative = -27580;
	layout_run_length_zero = -27579;
	layout_run_level_negative = -27578;
	layout_run_lengths_do_not_sum_to_text_length = -27577;
	invalid_fillShape_ownerCount = -27576;
	recursive_fillShapes = -27575;
	bad_shape_in_picture = -27574;
	bad_style_in_picture = -27573;
	bad_ink_in_picture = -27572;
	bad_transform_in_picture = -27571;
	bad_shape_cache_in_picture = -27570;
	bad_seed_in_picture = -27569;
	invalid_picture_count = -27568;
	bad_textLayer_count = -27567;
	bad_fillType_in_textFace = -27566;
	bad_style_in_textFace = -27565;
	bad_transform_in_textFace = -27564;
	transform_clip_missing = -27563;
	metrics_wrong_type = -27562;
	metrics_point_size_probably_bad = -27561;
	scalar_block_wrong_type = -27560;
	scalar_block_parent_mismatch = -27559;
	scalar_block_too_small = -27558;
	scalar_block_too_large = -27557;
	invalid_metrics_range = -27556;
	invalid_metrics_flags = -27555;
	metrics_maxWidth_probably_bad = -27554;
	font_wrong_type = -27553;
	font_wrong_size = -27552;
	invalid_font_platform = -27551;
	invalid_lookup_range = -27550;
	invalid_lookup_platform = -27549;
	font_not_in_font_list = -27548;
	metrics_not_in_metrics_list = -27547;
	bad_device_private_flags = -27546;
	bad_device_attributes = -27545;
	invalid_device_number = -27544;
	invalid_device_viewGroup = -27543;
	invalid_device_bounds = -27542;
	invalid_bitmap_in_device = -27541;
	colorSet_wrong_type = -27540;
	invalid_colorSet_viewDevice_owners = -27539;
	invalid_colorSet_colorSpace = -27538;
	invalid_colorSet_count = -27537;
	colorProfile_wrong_type = -27536;
	invalid_colorProfile_flags = -27535;
	invalid_colorProfile_response_count = -27534;
	backing_free_parent_mismatch = -27533;
	backing_store_parent_mismatch = -27532;
	number_of_contours_exceeds_implementation_limit = -27400;
	number_of_points_exceeds_implementation_limit = -27399;
	size_of_polygon_exceeds_implementation_limit = -27398;
	size_of_path_exceeds_implementation_limit = -27397;
	size_of_text_exceeds_implementation_limit = -27396;
	size_of_bitmap_exceeds_implementation_limit = -27395;
	number_of_colors_exceeds_implementation_limit = -27394;
	common_colors_not_initialized = -27300;
	no_open_picture = -27299;
	picture_already_open = -27298;
	no_open_poly = -27297;
	poly_already_open = -27296;
	no_open_region = -27295;
	region_already_open = -27294;
	no_active_picture = -27293;

	{ Warning Constants }
	warning_stack_underflow = -26999;
	warning_stack_overflow = -26998;
	notice_stack_underflow = -26997;
	notice_stack_overflow = -26996;
	shape_does_not_contain_text = -26900;
	shape_does_not_contain_a_bitmap = -26899;
	picture_expected = -26898;
	bitmap_is_not_resizable = -26897;
	shape_operator_may_not_be_a_bitmap = -26896;
	shape_operator_may_not_be_a_picture = -26895;
	graphic_type_does_not_contain_points = -26894;
	graphic_type_does_not_have_multiple_contours = -26893;
	graphic_type_cannot_be_mapped = -26892;
	graphic_type_cannot_be_moved = -26891;
	graphic_type_cannot_be_scaled = -26890;
	graphic_type_cannot_be_rotated = -26889;
	graphic_type_cannot_be_skewed = -26888;
	graphic_type_cannot_be_reset = -26887;
	graphic_type_cannot_be_dashed = -26886;
	graphic_type_cannot_be_reduced = -26885;
	graphic_type_cannot_be_inset = -26884;
	shape_cannot_be_inverted = -26883;
	map_shape_out_of_range = -26800;
	move_shape_out_of_range = -26799;
	scale_shape_out_of_range = -26798;
	rotate_shape_out_of_range = -26797;
	skew_shape_out_of_range = -26796;
	map_transform_out_of_range = -26795;
	move_transform_out_of_range = -26794;
	scale_transform_out_of_range = -26793;
	rotate_transform_out_of_range = -26792;
	skew_transform_out_of_range = -26791;
	contour_out_of_range = -26700;
	index_out_of_range_in_contour = -26699;
	picture_index_out_of_range = -26698;
	color_index_requested_not_found = -26697;
	colorSet_index_out_of_range = -26696;
	index_out_of_range = -26695;
	count_out_of_range = -26694;
	length_out_of_range = -26693;
	font_table_index_out_of_range = -26692;
	font_glyph_index_out_of_range = -26691;
	font_table_not_found = -26690;
	font_name_not_found = -26689;
	shape_access_not_allowed = -26688;
	colorSet_access_restricted = -26687;
	colorProfile_access_restricted = -26686;
	tag_access_restricted = -26685;
	viewDevice_access_restricted = -26684;
	new_shape_contains_invalid_data = -26683;
	new_tag_contains_invalid_data = -26682;
	extra_data_passed_was_ignored = -26681;
	unable_to_traverse_open_contour_that_starts_or_ends_off_the_curve = -26680;
	unable_to_draw_open_contour_that_starts_or_ends_off_the_curve = -26679;
	picture_cannot_contain_itself = -26678;
	viewPort_cannot_contain_itself = -26677;
	cannot_dispose_default_shape = -26676;
	cannot_dispose_default_style = -26675;
	cannot_dispose_default_ink = -26674;
	cannot_dispose_default_transform = -26673;
	cannot_dispose_default_colorProfile = -26672;
	cannot_dispose_default_colorSet = -26671;
	cannot_set_unique_items_attribute_for_a_picture_that_already_contains_items = -26670;
	shape_not_locked = -26669;
	tag_not_locked = -26668;
	shape_direct_attribute_not_set = -26667;
	first_glyph_advance_must_be_absolute = -26666;
	shape_does_not_have_area = -26665;
	shape_does_not_have_length = -26664;
	point_does_not_intersect_port = -26663;
	cannot_dispose_non_font = -26662;
	character_substitution_took_place = -26661;
	font_substitution_took_place = -26660;
	union_of_area_and_length_returns_area_only = -26659;
	insufficient_coordinate_space_for_new_device = -26658;
	unrecognized_stream_version = -26657;
	bad_data_in_stream = -26656;
	gxFirstFontScalerWarning = -26655;
	font_scaler_no_output = -26655;
	font_scaler_fake_metrics = -26654;
	font_scaler_fake_linespacing = -26653;
	font_scaler_glyph_substitution = -26652;
	gxLastFontScalerWarning = -26652;
	shape_passed_has_no_bounds = -26651;
	layer_style_cannot_contain_a_face = -26650;
	layer_glyph_shape_cannot_contain_nil_styles = -26649;
	face_override_style_font_must_match_style = -26648;
	tags_of_type_flst_removed = -26647;
	no_picture_drawn = -26600;
	polygons_have_different_size_contours = -26599;
	graphic_type_cannot_be_specifed_by_four_values = -26598;
	graphic_type_cannot_be_specifed_by_six_values = -26597;
	point_expected = -26596;
	line_or_rectangle_expected = -26595;
	curve_expected = -26594;
	graphic_type_does_not_contain_control_bits = -26593;
	request_exceeds_available_data = -26592;
	extra_data_unread = -26591;
	no_variable_length_user_data_saved = -26590;



TYPE
	GxGraphicsError = LongInt;
	GxGraphicsErrorPointer = ^GxGraphicsError;

	GxGraphicsWarning = LongInt;
	GxGraphicsWarningPointer = ^GxGraphicsWarning;

	GxGraphicsNotice = LongInt;
	GxGraphicsNoticePointer = ^GxGraphicsNotice;


	GxUserErrorFunction = ProcPtr;
	GxUserWarningFunction = ProcPtr;
	GxUserNoticeFunction = ProcPtr;


{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
