{
 graphics:
    graphics stream types
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.

}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT GraphicsStreamTypes;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingGraphicsStreamTypes}
{$SETC UsingGraphicsStreamTypes := 1}


{$I+}
{$SETC GraphicsStreamTypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingFontTypes}
{$I $$Shell(PInterfaces)FontTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingGraphicsTypes}
{$I $$Shell(PInterfaces)GraphicsTypes.p}
{$ENDC}
{$SETC UsingIncludes := GraphicsStreamTypesIncludes}

CONST

{ GraphicsOperation opcodes }
	gxNewObjectOpcode	= 0;
	gxSetDataOpcode		= 64;
	gxSetDefaultOpcode	= 128;
	gxReservedOpcode	= 192;
	gxNextOpcode		= 255;

{ new object types (new object opcode) }
	gxHeaderTypeOpcode		= 0;
	gxStyleTypeOpcode		= 40;
	gxInkTypeOpcode			= 41;
	gxTransformTypeOpcode	= 42;
	gxColorProfileTypeOpcode= 43;
	gxColorSetTypeOpcode	= 44;
	gxTagTypeOpcode			= 45;
	gxBitImageOpcode		= 46;
	gxFontNameTypeOpcode	= 47;
	gxTrailerTypeOpcode		= 63;

{ fields of objects (set data opcodes) }
	gxShapeAttributesOpcode = 1;
	gxShapeTagOpcode		= 2;
	gxShapeFillOpcode		= 3;

	gxOmitPathPositionXMask	= 192;
	gxOmitPathPositionYMask	= 48;
	gxOmitPathDeltaXMask	= 12;
	gxOmitPathDeltaYMask	= 3;

	gxOmitPathPositionXShift= 6;
	gxOmitPathPositionYShift= 4;
	gxOmitPathDeltaXShift	= 2;
	gxOmitPathDeltaYShift	= 0;

	gxOmitBitmapImageMask	= 192;
	gxOmitBitmapWidthMask	= 48;
	gxOmitBitmapHeightMask	= 12;
	gxOmitBitmapRowBytesMask= 3;
	
	gxOmitBitmapImageShift	= 6;
	gxOmitBitmapWidthShift	= 4;
	gxOmitBitmapHeightShift	= 2;
	gxOmitBitmapRowBytesShift = 0;
	
	gxOmitBitmapPixelSizeMask= 192;
	gxOmitBitmapSpaceMask	= 48;
	gxOmitBitmapSetMask		= 12;
	gxOmitBitmapProfileMask	= 3;
	
	gxOmitBitmapPixelSizeShift	= 6;
	gxOmitBitmapSpaceShift		= 4;
	gxOmitBitmapSetShift		= 2;
	gxOmitBitmapProfileShift	= 0;
	
	gxOmitBitmapPositionXMask	= 192;
	gxOmitBitmapPositionYMask	= 48;
	
	gxOmitBitmapPositionXShift	= 6;
	gxOmitBitmapPositionYShift	= 4;
	
	gxOmitBitImageRowBytesMask	= 192;
	gxOmitBitImageHeightMask	= 48;
	gxOmitBitImageDataMask		= 8;
	
	gxOmitBitImageRowBytesShift	= 6;
	gxOmitBitImageHeightShift	= 4;
	gxOmitBitImageDataShift		= 3;
	
	gxCopyBitImageBytesOpcode	= 0;
	gxRepeatBitImageBytesOpcode	= 64;
	gxLookupBitImageBytesOpcode	= 128;
	gxRepeatBitImageScanOpcode	= 192;
	
	gxOmitTextCharactersMask	= 192;
	gxOmitTextPositionXMask		= 48;
	gxOmitTextPositionYMask		= 12;
	gxOmitTextDataMask			= 2;

	gxOmitTextCharactersShift	= 6;
	gxOmitTextPositionXShift	= 4;
	gxOmitTextPositionYShift	= 2;
	gxOmitTextDataShift			= 1;
	
	gxOmitGlyphCharactersMask	= 192;
	gxOmitGlyphLengthMask		= 48;
	gxOmitGlyphRunNumberMask	= 12;
	gxOmitGlyphOnePositionMask	= 2;
	gxOmitGlyphDataMask			= 1;
	
	gxOmitGlyphCharactersShift	= 6;
	gxOmitGlyphLengthShift		= 4;
	gxOmitGlyphRunNumberShift	= 2;
	gxOmitGlyphOnePositionShift	= 1;
	gxOmitGlyphDataShift		= 0;
	
	gxOmitGlyphPositionsMask	= 192;
	gxOmitGlyphAdvancesMask		= 32;
	gxOmitGlyphTangentsMask		= 24;
	gxOmitGlyphRunsMask			= 4;
	gxOmitGlyphStylesMask		= 3;
	
	gxOmitGlyphPositionsShift	= 6;
	gxOmitGlyphAdvancesShift	= 5;
	gxOmitGlyphTangentsShift	= 3;
	gxOmitGlyphRunsShift		= 2;
	gxOmitGlyphStylesShift		= 0;
	
	gxOmitLayoutLengthMask		= 192;
	gxOmitLayoutPositionXMask	= 48;
	gxOmitLayoutPositionYMask	= 12;
	gxOmitLayoutDataMask		= 2;
	
	gxOmitLayoutLengthShift		= 6;
	gxOmitLayoutPositionXShift	= 4;
	gxOmitLayoutPositionYShift	= 2;
	gxOmitLayoutDataShift		= 1;
	
	gxOmitLayoutWidthMask		= 192;
	gxOmitLayoutFlushMask		= 48;
	gxOmitLayoutJustMask		= 12;
	gxOmitLayoutOptionsMask		= 3;
	
	gxOmitLayoutWidthShift		= 6;
	gxOmitLayoutFlushShift		= 4;
	gxOmitLayoutJustShift		= 2;
	gxOmitLayoutOptionsShift	= 0;
	
	gxOmitLayoutStyleRunNumberMask = 192;
	gxOmitLayoutLevelRunNumberMask = 48;
	gxOmitLayoutHasBaselineMask	= 8;
	gxOmitLayoutStyleRunsMask	= 4;
	gxOmitLayoutStylesMask		= 3;
	
	gxOmitLayoutStyleRunNumberShift = 6;
	gxOmitLayoutLevelRunNumberShift = 4;
	gxOmitLayoutHasBaselineShift	= 3;
	gxOmitLayoutStyleRunsShift		= 2;
	gxOmitLayoutStylesShift			= 0;
	
	gxOmitLayoutLevelRunsMask	= 128;
	gxOmitLayoutLevelsMask		= 64;
	
	gxOmitLayoutLevelRunsShift	= 7;
	gxOmitLayoutLevelsShift		= 6;
	
	gxInkAttributesOpcode		= 1;
	gxInkTagOpcode				= 2;
	gxInkColorOpcode			= 3;
	gxInkTransferModeOpcode		= 4;
	
	gxOmitColorsSpaceMask		= 192;
	gxOmitColorsProfileMask		= 48;
	gxOmitColorsComponentsMask	= 15;
	gxOmitColorsIndexMask		= 12;
	gxOmitColorsIndexSetMask	= 3;
	
	gxOmitColorsSpaceShift		= 6;
	gxOmitColorsProfileShift	= 4;
	gxOmitColorsComponentsShift	= 0;
	gxOmitColorsIndexShift		= 2;
	gxOmitColorsIndexSetShift	= 0;
	
	gxOmitTransferSpaceMask		= 192;
	gxOmitTransferSetMask		= 48;
	gxOmitTransferProfileMask	= 12;
	
	gxOmitTransferSpaceShift	= 6;
	gxOmitTransferSetShift		= 4;
	gxOmitTransferProfileShift	= 2;
	
	gxOmitTransferSourceMatrixMask	= 192;
	gxOmitTransferDeviceMatrixMask	= 48;
	gxOmitTransferResultMatrixMask	= 12;
	gxOmitTransferFlagsMask			= 3;
	
	gxOmitTransferSourceMatrixShift = 6;
	gxOmitTransferDeviceMatrixShift = 4;
	gxOmitTransferResultMatrixShift = 2;
	gxOmitTransferFlagsShift = 0;
	
	gxOmitTransferComponentModeMask = 128;
	gxOmitTransferComponentFlagsMask = 64;
	gxOmitTransferComponentSourceMinimumMask = 48;
	gxOmitTransferComponentSourceMaximumMask = 12;
	gxOmitTransferComponentDeviceMinimumMask = 3;
	
	gxOmitTransferComponentModeShift = 7;
	gxOmitTransferComponentFlagsShift = 6;
	gxOmitTransferComponentSourceMinimumShift = 4;
	gxOmitTransferComponentSourceMaximumShift = 2;
	gxOmitTransferComponentDeviceMinimumShift = 0;
	
	gxOmitTransferComponentDeviceMaximumMask = 192;
	gxOmitTransferComponentClampMinimumMask = 48;
	gxOmitTransferComponentClampMaximumMask = 12;
	gxOmitTransferComponentOperandMask = 3;
	
	gxOmitTransferComponentDeviceMaximumShift = 6;
	gxOmitTransferComponentClampMinimumShift = 4;
	gxOmitTransferComponentClampMaximumShift = 2;
	gxOmitTransferComponentOperandShift = 0;

	gxStyleAttributesOpcode = 1;
	gxStyleTagOpcode = 2;
	gxStyleCurveErrorOpcode = 3;
	gxStylePenOpcode = 4;
	gxStyleJoinOpcode = 5;
	gxStyleDashOpcode = 6;
	gxStyleCapsOpcode = 7;
	gxStylePatternOpcode = 8;
	gxStyleTextAttributesOpcode = 9;
	gxStyleTextSizeOpcode = 10;
	gxStyleFontOpcode = 11;
	gxStyleTextFaceOpcode = 12;
	gxStylePlatformOpcode = 13;
	gxStyleFontVariationsOpcode = 14;
	gxStyleRunControlsOpcode = 15;
	gxStyleRunPriorityJustOverrideOpcode = 16;
	gxStyleRunGlyphJustOverridesOpcode = 17;
	gxStyleRunGlyphSubstitutionsOpcode = 18;
	gxStyleRunFeaturesOpcode = 19;
	gxStyleRunKerningAdjustmentsOpcode = 20;
	gxStyleJustificationOpcode = 21;
	
	gxOmitDashAttributesMask = 192;
	gxOmitDashShapeMask = 48;
	gxOmitDashAdvanceMask = 12;
	gxOmitDashPhaseMask = 3;
	
	gxOmitDashAttributesShift = 6;
	gxOmitDashShapeShift = 4;
	gxOmitDashAdvanceShift = 2;
	gxOmitDashPhaseShift = 0;
	
	gxOmitDashScaleMask = 192;
	
	gxOmitDashScaleShift = 6;
	
	gxOmitPatternAttributesMask = 192;
	gxOmitPatternShapeMask = 48;
	gxOmitPatternUXMask = 12;
	gxOmitPatternUYMask = 3;
	
	gxOmitPatternAttributesShift = 6;
	gxOmitPatternShapeShift = 4;
	gxOmitPatternUXShift = 2;
	gxOmitPatternUYShift = 0;
	
	gxOmitPatternVXMask = 192;
	gxOmitPatternVYMask = 48;
	
	gxOmitPatternVXShift = 6;
	gxOmitPatternVYShift = 4;
	
	gxOmitJoinAttributesMask = 192;
	gxOmitJoinShapeMask = 48;
	gxOmitJoinMiterMask = 12;
	
	gxOmitJoinAttributesShift = 6;
	gxOmitJoinShapeShift = 4;
	gxOmitJoinMiterShift = 2;
	
	gxOmitCapAttributesMask = 192;
	gxOmitCapStartShapeMask = 48;
	gxOmitCapEndShapeMask = 12;
	
	gxOmitCapAttributesShift = 6;
	gxOmitCapStartShapeShift = 4;
	gxOmitCapEndShapeShift = 2;
	
	gxOmitFaceLayersMask = 192;
	gxOmitFaceMappingMask = 48;
	
	gxOmitFaceLayersShift = 6;
	gxOmitFaceMappingShift = 4;
	
	gxOmitFaceLayerFillMask = 192;
	gxOmitFaceLayerFlagsMask = 48;
	gxOmitFaceLayerStyleMask = 12;
	gxOmitFaceLayerTransformMask = 3;
	
	gxOmitFaceLayerFillShift = 6;
	gxOmitFaceLayerFlagsShift = 4;
	gxOmitFaceLayerStyleShift = 2;
	gxOmitFaceLayerTransformShift = 0;
	
	gxOmitFaceLayerBoldXMask = 192;
	gxOmitFaceLayerBoldYMask = 48;
	
	gxOmitFaceLayerBoldXShift = 6;
	gxOmitFaceLayerBoldYShift = 4;
	
	gxColorSetReservedOpcode = 1;
	gxColorSetTagOpcode = 2;
	
	gxColorProfileAttributesOpcode = 1;
	gxColorProfileTagOpcode = 2;
	
	gxTransformReservedOpcode = 1;
	gxTransformTagOpcode = 2;
	gxTransformClipOpcode = 3;
	gxTransformMappingOpcode = 4;
	gxTransformPartMaskOpcode = 5;
	gxTransformToleranceOpcode = 6;
	
	{ Generic Opcodes }
	gxTypeOpcode = 1;		{ used by currentOperand when currentOperation is gxNextOpcode }
	gxSizeOpcode = 2;


{
  format of top byte:
    xx yyyyyy	xx == 0x00, 0x40, 0x80, 0xC0: defines graphics operation (see gxGraphicsOperationOpcode)
				yyyyyy == size of operation in bytes
				if (yyyyyy == 0), byte size follows. If byte following == 0, word size follows; if == 0, long follows
				word and long, if present, are specified in high-endian order (first byte is largest magnitude)
                
    format of byte following size specifiers, if any:
    xx yyyyyy	xx == 0x00, 0x40, 0x80, 0xC0: defines compression level (0 == none, 0xC0 == most)
				exact method of compression is defined by type of data
				yyyyyy == data type selector (0 to 63): see gxGraphicsNewOpcode, __DataOpcode

}

	gxOpcodeShift		= 6;
	gxObjectSizeMask	= $3F;
	gxCompressionShift	= 6;
	gxObjectTypeMask	= $3F;
	
	gxNoCompression		= 1;
	gxWordCompression	= 2;
	gxByteCompression	= 3;
	gxOmitCompression	= 4;

	gxCompressionMask	= 3;

	{	the following structures define how primitives without a public geometry
		are stored (their format mirrors that of the New call to create them)	}

	gxFlatFontListItemTag	= 'flst';
	
TYPE
	GxFlatFontName = BEGIN
		name: Byte;
		platform: Byte;
		script: Byte;
		language: Byte;
		length: Integer;
		END;

	GxFlatFontListItem = BEGIN
		fontID: GxFont;
		name: Byte;
		platform: Byte;
		script: Byte;
		language: Byte;
		length: Integer;
		glyphCount: Integer;
		END;

	GxFlatFontList = BEGIN
		count: LongInt;
		items: ARRAY [0..1] OF GxFlatFontListItem;
		END;

	GxFlattenHeader = BEGIN
		version: Fixed;
		flatFlags: Byte;
		END;

CONST
	gxOmitPictureShapeMask		= 192;
	gxOmitOverrideStyleMask		= 48;
	gxOmitOverrideInkMask		= 12;
	gxOmitOverrideTransformMask = 3;
	
	gxOmitPictureShapeShift		= 6;
	gxOmitOverrideStyleShift	= 4;
	gxOmitOverrideInkShift		= 2;
	gxOmitOverrideTransformShift= 0;
	

{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
