{
****************************************

    synonym tags:

    These are the data structures for Graphics 
    synonyms stored in tags.

    Copyright  1991, 1992 Apple Computer Inc.  All rights reserved

*****************************************
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT SynonymTags;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingSynonymTags}
{$SETC UsingSynonymTags := 1}


{$I+}
{$SETC SynonymTagsIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingGraphicsTypes}
{$I $$Shell(PInterfaces)GraphicsTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingFontTypes}
{$I $$Shell(PInterfaces)FontTypes.p}
{$ENDC}
{$SETC UsingIncludes := SynonymTagsIncludes}

CONST
gxNoSave = 1;


TYPE
GxPostControl = RECORD
	flags: LongInt;
	numFonts: LongInt;
	name: Integer;
	platform: Integer;
	script: Integer;
	language: Integer;
	fontList: ARRAY [0..1] OF SignedByte;
	END;
GxPostControlPointer = ^GxPostControl;
GxPostControlArray = ARRAY [0..0] OF GxPostControl;



GxDashSynonym = RECORD
	size: LongInt;
	dashLength: ARRAY [0..1] OF Fixed;
	END;
GxDashSynonymPointer = ^GxDashSynonym;
GxDashSynonymArray = ARRAY [0..0] OF GxDashSynonym;




CONST
gxButtCap = 1;
gxRoundCap = 2;
gxSquareCap = 3;
gxTriangleCap = 4;


TYPE
GxLineCapSynonym = LongInt;
GxLineCapSynonymPointer = ^GxLineCapSynonym;
GxLineCapSynonymArray = ARRAY [0..0] OF GxLineCapSynonym;

{ gxLine cap type }



CONST
gxIgnoreFlag = 0;
gxLineToFlag = 1;
gxCurveToFlag = 2;
gxMoveToFlag = 3;
gxClosePathFlag = 4;


TYPE
GxCubicSynonymFlags = Integer;
GxCubicSynonymFlagsPointer = ^GxCubicSynonymFlags;
GxCubicSynonymFlagsArray = ARRAY [0..0] OF GxCubicSynonymFlags;

{ Low four bits are instruction (moveto, lineto, curveto, closepath) }



CONST
gxHatch = 1;
gxCrossHatch = 2;


TYPE
GxPatternSynonym = RECORD
	patternType: LongInt;
	angle: Fixed;
	spacing: Fixed;
	thickness: Fixed;
	anchorPoint: GxPoint;
	END;
GxPatternSynonymPointer = ^GxPatternSynonym;
GxPatternSynonymArray = ARRAY [0..0] OF GxPatternSynonym;




{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
