/* graphics:
	trap binding interface
	by Cary Clark, Georgiann Delaney, Herb Derby, Michael Fairman, Pablo Fernicola, Dave Good, Josh Horwich, Barton House, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1994 Apple Computer, Inc.  All rights reserved.	*/

#ifndef graphicsLinkageIncludes
	#define graphicsLinkageIncludes

	#define	QuickDrawGXTrap		0xA832
	
	#define	gxAnyContext			0x00
	#define	gxNeedClient			0x10
	#define	gxNeedStack			0x20
	#define	gxNeedHeap			0x40
	#define	gxEnvironmentControl	0x80
	
	#define	GXParameterCount(paramEntry)	( (paramEntry) & 0x0F )

#ifndef dontUseInLines
	#define GXTrap( x, environment ) ={0x303C, x, QuickDrawGXTrap}
#else
	#define GXTrap( x, environment )
#endif

	#define GXInlineCode( x, environment ) GXTrap(x, environment)

#endif
