

	//  FILE: autotest.h
	//      Used with autotest.c

	//	     (C) 1990-1992 Microsoft Corporation.  All right reserved.


#define IDC_AUTOTEST_GROUP            111
#define IDC_AUTOTEST_SOURCE           112
#define IDC_AUTOTEST_SELECT           115
#define IDC_AUTOTEST_DESCRIPTION      113
#define IDC_AUTOTEST_LOG              114
#define IDC_AUTOTEST_SCREEN           116
#define IDC_AUTOTEST_ISOLATE          117
#define IDC_AUTOTEST_CATNAME          118

pascal void QuickTests(struct ServerStruct *pTestSource);
pascal int QuickTestsDesc(int i, char *szName, char *szDesc);
pascal void CoreQuickTest(struct ServerStruct *pTestSource);
pascal void ExtQuickTestL2(struct ServerStruct *pTestSource);
pascal void ExtQuickTestL1(struct ServerStruct *pTestSource);
pascal void Custom(struct ServerStruct *pTestSource);
pascal void SQLMFQueryEngine(struct ServerStruct *pTestSource);
pascal void BruceQueries(struct ServerStruct *pTestSource);


	// Connect Functions
	// sag
pascal void TestSQLAllocEnv(struct ServerStruct *pTestSource);
pascal int TestSQLAllocEnvDesc(int i, char *szName, char *szDesc);
pascal void TestSQLAllocConnect(struct ServerStruct *pTestSource);
pascal int TestSQLAllocConnectDesc(int i, char *szName, char *szDesc);
pascal void TestSQLConnect(struct ServerStruct *pTestSource);
pascal int TestSQLConnectDesc(int i, char *szName, char *szDesc);
pascal void TestSQLBrowseConnect(struct ServerStruct *pTestSource);
pascal int TestSQLBrowseConnectDesc(int i, char *szName, char *szDesc);
pascal void TestSQLDisconnect(struct ServerStruct *pTestSource);
pascal int TestSQLDisconnectDesc(int i, char *szName, char *szDesc);
pascal void TestSQLFreeConnect(struct ServerStruct *pTestSource);
pascal int TestSQLFreeConnectDesc(int i, char *szName, char *szDesc);
pascal void TestSQLFreeEnv(struct ServerStruct *pTestSource);
pascal int TestSQLFreeEnvDesc(int i, char *szName, char *szDesc);
	// ext
pascal void TestSQLDataSources(struct ServerStruct *pTestSource);
pascal int TestSQLDataSourcesDesc(int i, char *szName, char *szDesc);
pascal void TestSQLDriverConnect(struct ServerStruct *pTestSource);
pascal int TestSQLDriverConnectDesc(int i, char *szName, char *szDesc);
pascal void TestSQLGetInfo(struct ServerStruct *pTestSource);
pascal int TestSQLGetInfoDesc(int i, char *szName, char *szDesc);

	// Extended Data Types Functions
	// ext
pascal void TestSQLGetFunctions(struct ServerStruct *pTestSource);
pascal int TestSQLGetFunctionsDesc(int i, char *szName, char *szDesc);
pascal void TestSQLGetTypeInfo(struct ServerStruct *pTestSource);
pascal int TestSQLGetTypeInfoDesc(int i, char *szName, char *szDesc);
pascal void TestSQLSpecialColumns(struct ServerStruct *pTestSource);
pascal int TestSQLSpecialColumnsDesc(int i, char *szName, char *szDesc);
pascal void TestSQLColAttributes(struct ServerStruct *pTestSource);
pascal int TestSQLColAttributesDesc(int i, char *szName, char *szDesc);

	// Data Dictionary Functions
	// ext
pascal void TestSQLTables(struct ServerStruct *pTestSource);
pascal int TestSQLTablesDesc(int i, char *szName, char *szDesc);
pascal void TestSQLColumns(struct ServerStruct *pTestSource);
pascal int TestSQLColumnsDesc(int i, char *szName, char *szDesc);
pascal void TestSQLStatistics(struct ServerStruct *pTestSource);
pascal int TestSQLStatisticsDesc(int i, char *szName, char *szDesc);
pascal void TestSQLPrimaryKeys(struct ServerStruct *pTestSource);
pascal int TestSQLPrimaryKeysDesc(int i, char *szName, char *szDesc);
pascal void TestSQLForeignKeys(struct ServerStruct *pTestSource);
pascal int TestSQLForeignKeysDesc(int i, char *szName, char *szDesc);
pascal void TestSQLTablePrivileges(struct ServerStruct *pTestSource);
pascal int TestSQLTablePrivilegesDesc(int i, char *szName, char *szDesc);
pascal void TestSQLColumnPrivileges(struct ServerStruct *pTestSource);
pascal int TestSQLColumnPrivilegesDesc(int i, char *szName, char *szDesc);

	// Send/Execute Functions
	// sag
pascal void TestSQLAllocStmt(struct ServerStruct *);
pascal int TestSQLAllocStmtDesc(int i, char *szName, char *szDesc);
pascal void TestSQLPrepare(struct ServerStruct *pTestSource);
pascal int TestSQLPrepareDesc(int i, char *szName, char *szDesc);
pascal void TestSQLSetParam(struct ServerStruct *pTestSource);
pascal int TestSQLSetParamDesc(int i, char *szName, char *szDesc);
pascal void TestSQLSetCursorName(struct ServerStruct *pTestSource);
pascal int TestSQLSetCursorNameDesc(int i, char *szName, char *szDesc);
pascal void TestSQLGetCursorName(struct ServerStruct *pTestSource);
pascal int TestSQLGetCursorNameDesc(int i, char *szName, char *szDesc);
pascal void TestSQLExecute(struct ServerStruct *pTestSource);
pascal int TestSQLExecuteDesc(int i, char *szName, char *szDesc);
pascal void TestSQLExecDirect(struct ServerStruct *pTestSource);
pascal int TestSQLExecDirectDesc(int i, char *szName, char *szDesc);
	// ext
pascal void TestSQLNativeSql(struct ServerStruct *pTestSource);
pascal int TestSQLNativeSqlDesc(int i, char *szName, char *szDesc);
pascal void TestSQLDescribeParam(struct ServerStruct *pTestSource);
pascal int TestSQLDescribeParamDesc(int i, char *szName, char *szDesc);

	// Receive Functions
	// sag
pascal void TestSQLNumResultCols(struct ServerStruct *pTestSource);
pascal int TestSQLNumResultColsDesc(int i, char *szName, char *szDesc);
pascal void TestSQLDescribeCol(struct ServerStruct *pTestSource);
pascal int TestSQLDescribeColDesc(int i, char *szName, char *szDesc);
pascal void TestSQLBindCol(struct ServerStruct *pTestSource);
pascal int TestSQLBindColDesc(int i, char *szName, char *szDesc);
pascal void TestSQLFetch(struct ServerStruct *pTestSource);
pascal int TestSQLFetchDesc(int i, char *szName, char *szDesc);
pascal void TestSQLRowCount(struct ServerStruct *pTestSource);
pascal int TestSQLRowCountDesc(int i, char *szName, char *szDesc);
pascal void TestSQLFreeStmt(struct ServerStruct *pTestSource);
pascal int TestSQLFreeStmtDesc(int i, char *szName, char *szDesc);
	// ext
pascal void TestSQLGetData(struct ServerStruct *pTestSource);
pascal int TestSQLGetDataDesc(int i, char *szName, char *szDesc);
pascal void TestSQLMoreResults(struct ServerStruct *pTestSource);
pascal int TestSQLMoreResultsDesc(int i, char *szName, char *szDesc);

	// Arrays
	// ext
pascal void TestSQLArraySetParam(struct ServerStruct *pTestSource);
pascal int TestSQLArraySetParamDesc(int i, char *szName, char *szDesc);

	// Scrollable Cursors
	// ext
pascal void TestSQLSetScrollOptions(struct ServerStruct *pTestSource);
pascal int TestSQLSetScrollOptionsDesc(int i, char *szName, char *szDesc);
pascal void TestSQLExtendedFetch(struct ServerStruct *pTestSource);
pascal int TestSQLExtendedFetchDesc(int i, char *szName, char *szDesc);
pascal void TestSQLSetPos(struct ServerStruct *pTestSource);
pascal int TestSQLSetPosDesc(int i, char *szName, char *szDesc);

	// Misc Functions
	// sag
pascal void TestSQLTransact(struct ServerStruct *pTestSource);
pascal int TestSQLTransactDesc(int i, char *szName, char *szDesc);
pascal void TestSQLCancel(struct ServerStruct *pTestSource);
pascal int TestSQLCancelDesc(int i, char *szName, char *szDesc);
pascal void TestSQLError(struct ServerStruct *pTestSource);
pascal int TestSQLErrorDesc(int i, char *szName, char *szDesc);
	// ext
pascal void TestSQLSetConnectOption(struct ServerStruct *pTestSource);
pascal int TestSQLSetConnectOptionDesc(int i, char *szName, char *szDesc);
pascal void TestSQLGetConnectOption(struct ServerStruct *pTestSource);
pascal int TestSQLGetConnectOptionDesc(int i, char *szName, char *szDesc);
pascal void TestSQLSetStmtOption(struct ServerStruct *pTestSource);
pascal int TestSQLSetStmtOptionDesc(int i, char *szName, char *szDesc);
pascal void TestSQLNumParams(struct ServerStruct *pTestSource);
pascal int TestSQLNumParamsDesc(int i, char *szName, char *szDesc);
pascal void TestSQLParamData(struct ServerStruct *pTestSource);
pascal int TestSQLParamDataDesc(int i, char *szName, char *szDesc);
pascal void TestSQLPutData(struct ServerStruct *pTestSource);
pascal int TestSQLPutDataDesc(int i, char *szName, char *szDesc);
	/* needed for auto.c */
#define SZSIZE 100
pascal char * FGetLogFileName( HWND hdlg, char *szFileName, char *szTitle, DWORD f );
