
	/* Created 3/12/93 4:51 PM by AppMaker */

typedef struct		// #01
{
	Boolean			NullHenvChecked;
	Boolean			NullPhdbcOutChecked;
} SQLAllocConnectRec, *SQLAllocConnectRecPtr;

	Boolean GetSQLAllocConnect( SQLAllocConnectRec * );


typedef struct		// #02
{
	Boolean		fNull_phenv;
} SQLAllocEnvRec, *SQLAllocEnvRecPtr;

	Boolean GetSQLAllocEnv();


typedef struct		// #03
{
	Boolean			NullPhstmtOutChecked;
} SQLAllocStmtRec, *SQLAllocStmtRecPtr;

	Boolean GetSQLAllocStmt( SQLAllocStmtRec * );


typedef struct		// #04
{
	Boolean			NullRgbValuePointerChecked;
	Boolean			NullPcbValuePointerChecked;
	short			fCTypeChoice;
	Str255			icolText;
	Str255			fCTypeText;
	Str15			cbValueMaxText;
} SQLBindColRec, *SQLBindColRecPtr;

	Boolean GetSQLBindCol( SQLBindColRec * );


typedef struct		// #55
{
	Boolean			NullSzConnStrOutChecked;
	Boolean			NullPcbConnStrOutChecked;
	short			szConnStrIn55Choice;
	short			cbConnStrIn55Choice;
	Str255			szConnStrInText;
	Str15			cbConnStrInText;
	Str15			MaxText;
} SQLBrowseConnectRec, *SQLBrowseConnectRecPtr;

	Boolean GetSQLBrowseConnect( SQLBrowseConnectRec * );


typedef struct		// #06
{
	Boolean			NullRgbDescOutChecked;
	Boolean			NullPcbDescOutChecked;
	Boolean			NullPfDescOutChecked;
	short			fDescTypeChoice;
	Str15			icolText;
	Str255			fDescTypeText;
	Str15			cbDescMaxText;
} SQLColAttributesRec, *SQLColAttributesRecPtr;

Boolean GetSQLColAttributes( SQLColAttributesRec * );


typedef struct		// #56
{
	short			QualifierChoice;
	short			OwnerChoice;
	short			NameChoice;
	short			ColumnChoice;
	short			cbQualifierChoice;
	short			cbOwnerChoice;
	short			cbNameChoice;
	short			cbColumnChoice;

	Str255			QualifierText;
	Str255			OwnerText;
	Str255			NameText;
	Str255			ColumnText;
	Str15			cbQualifierText;
	Str15			cbOwnerText;
	Str15			cbNameText;
	Str15			cbColumnText;
} SQLColumnPrivilegesRec, *SQLColumnPrivilegesRecPtr;

	Boolean GetSQLColumnPrivileges( SQLColumnPrivilegesRec * );


typedef struct		// #40
{
	short			QualifierChoice;
	short			OwnerChoice;
	short			NameChoice;
	short			ColumnChoice;
	short			cbQualifierChoice;
	short			cbOwnerChoice;
	short			cbNameChoice;
	short			cbColNameChoice;

	Str255			QualifierText;
	Str255			OwnerText;
	Str255			NameText;
	Str255			ColumnText;
	Str15			cbQualifierText;
	Str15			cbOwnerText;
	Str15			cbNameText;
	Str15			cbColNameText;
} SQLColumnsRec, *SQLColumnsRecPtr;

	Boolean GetSQLColumns( SQLColumnsRec * );


typedef struct		// #07
{
	short			szDSNChoice,	szUIDChoice,	szAuthStrChoice;
	short			cbDSNChoice,	cbUIDChoice,	cbAuthStrChoice;

	Str255			szDSNText,		szUIDText,		szAuthStrText;
	Str15			cbDSNText,		cbUIDText,		cbAuthStrText;
} SQLConnectRec, *SQLConnectRecPtr;

	Boolean GetSQLConnect( SQLConnectRec * );


typedef struct		// #57
{
	Boolean			NullHenvChecked;
	Boolean			NullSzDSNOutChecked;
	Boolean			NullPcbDSNOutChecked;
	Boolean			NullSzDescriptionOutChecked;
	Boolean			NullPcbDescriptionOutChecked;
	short			fDirectionChoice;
	Str255			fDirectionText;
	Str15			cbDSNMaxText;
	Str15			cbDescMaxText;
} SQLDataSourcesRec, *SQLDataSourcesRecPtr;

	Boolean GetSQLDataSources( SQLDataSourcesRec * );


typedef struct		// #08
{
	Boolean			NullSzColNameOutChecked;
	Boolean			NullPcbColNameOutChecked;
	Boolean			NullPfSqlTypeOutChecked;
	Boolean			NullPcbColDefOutChecked;
	Boolean			NullPibScaleOutChecked;
	Boolean			NullPfNullableOutChecked;
	Str15			icolText;
	Str15			cbColNameMaxText;
} SQLDescribeColRec, *SQLDescribeColRecPtr;

	Boolean GetSQLDescribeCol( SQLDescribeColRec * );


typedef struct		// #58
{
	Boolean			NullPfSqlTypeOutChecked;
	Boolean			NullPcbColDefOutChecked;
	Boolean			NullPibScaleOutChecked;
	Boolean			NullPfNullableOutChecked;
	Str255			iparText;
} SQLDescribeParamRec, *SQLDescribeParamRecPtr;

	Boolean GetSQLDescribeParam( SQLDescribeParamRec * );


typedef struct		// #41
{
	Boolean			NullHwndChecked;
	Boolean			NullPcbConnStrOutChecked;
	Boolean			NullSzConnStrOutChecked;
	short			szConnStrInChoice;
	short			cbConnStrInChoice;
	short			fDriverCompletionChoice;
	Str255			szConnStrInText;
	Str15			cbConnStrInText;
	Str255			fDriverCompletionText;
	Str15			MaxText;
} SQLDriverConnectRec, *SQLDriverConnectRecPtr;

	Boolean GetSQLDriverConnect( SQLDriverConnectRec * );


typedef struct		// #10
{
	Boolean			NullHenvChecked;
	Boolean			NullHdbcChecked;
	Boolean			NullHstmtChecked;
	Boolean			NullSzSqlStateOutChecked;
	Boolean			NullPfNativeErrorOutChecked;
	Boolean			NullSzErrorMsgOutChecked;
	Boolean			NullPcbErrorMsgOutChecked;
	Str15			cbErrorMsgMaxText;
} SQLErrorRec, *SQLErrorRecPtr;

	Boolean GetSQLError( SQLErrorRec * );


typedef struct		// #11
{
	Boolean			NullSzSqlStrChecked;
	short			cbSqlStrChoice;
	Str15			cbSqlStrText;
} SQLExecDirectRec, *SQLExecDirectRecPtr;

	Boolean GetSQLExecDirect( SQLExecDirectRec * );


typedef struct		// #xx
{
	Boolean			NullPcrowOutChecked;
	Boolean			NullRgfRowStatusOutChecked;
	short			fFetchTypeChoice;
	Str31			fFetchTypeText;
	Str15			irowText;
} SQLExtendedFetchRec, *SQLExtendedFetchRecPtr;

	Boolean GetSQLExtendedFetch( SQLExtendedFetchRec * );


typedef struct		// #60
{
	short			QualifierChoice;
	short			OwnerChoice;
	short			NameChoice;
	short			Qual2Choice;
	short			Owner2Choice;
	short			Name2Choice;
	short			cbQualifierChoice;
	short			cbOwnerChoice;
	short			cbNameChoice;
	short			cbQual2Choice;
	short			cbOwner2Choice;
	short			cbName2Choice;

	Str255			QualifierText;
	Str255			OwnerText;
	Str255			NameText;
	Str255			FKqualifierText;
	Str255			FKownerText;
	Str255			FKnameText;
	Str15			cbQualifierText;
	Str15			cbOwnerText;
	Str15			cbNameText;
	Str15			cbFKqualifierText;
	Str15			cbFKownerText;
	Str15			cbFKnameText;
} SQLForeignKeysRec, *SQLForeignKeysRecPtr;

	Boolean GetSQLForeignKeys( SQLForeignKeysRec * );


typedef struct		// #16
{
	short			fOptionChoice;
	Str255			fOptionText;
} SQLFreeStmtRec, *SQLFreeStmtRecPtr;

	Boolean GetSQLFreeStmt( SQLFreeStmtRec * );


typedef struct		// #42
{
	Boolean			NullPvParamOutChecked;
	short			fOptionChoice;
	Str255			fOptionText;
} SQLGetConnectOptionRec, *SQLGetConnectOptionRecPtr;

	Boolean GetSQLGetConnectOption( SQLGetConnectOptionRec * );


typedef struct		// #17
{
	Boolean			NullSzCursorOutChecked;
	Boolean			NullPcbCursorOutChecked;
	Str15			cbCursorMaxText;
} SQLGetCursorNameRec, *SQLGetCursorNameRecPtr;

	Boolean GetSQLGetCursorName( SQLGetCursorNameRec * );


typedef struct		// #43
{
	Boolean			NullRgbValueOutChecked;
	Boolean			NullPcbValueOutChecked;
	short			fCTypeChoice;
	Str15			icolText;
	Str255			fCTypeText;
	Str15			cbValueMaxText;
} SQLGetDataRec, *SQLGetDataRecPtr;

	Boolean GetSQLGetData( SQLGetDataRec * );


typedef struct		// #44
{
	Boolean			NullPfExistsOutChecked;
	short			fFunctionChoice;
	Str255			fFunctionText;
} SQLGetFunctionsRec, *SQLGetFunctionsRecPtr;

	Boolean GetSQLGetFunctions( SQLGetFunctionsRec * );


typedef struct		// #45
{
	Boolean			NullRgbInfoValueOutChecked;
	Boolean			NullPcbInfoValueOutChecked;
	short			fInfoTypeChoice;
	Str255			fInfoTypeText;
	Str15			cbMaxText;
} SQLGetInfoRec, *SQLGetInfoRecPtr;

	Boolean GetSQLGetInfo( SQLGetInfoRec * );


typedef struct		// #46
{
	Boolean			NullPvParamOutChecked;
	short			fOptionChoice;
	Str255			fOptionText;
} SQLGetStmtOptionRec, *SQLGetStmtOptionRecPtr;

	Boolean GetSQLGetStmtOption( SQLGetStmtOptionRec * );


typedef struct		// #47
{
	short			fSqlTypeChoice;
	Str255			fSqlTypeText;
} SQLGetTypeInfoRec, *SQLGetTypeInfoRecPtr;

	Boolean GetSQLGetTypeInfo( SQLGetTypeInfoRec * );


typedef struct		// #62
{
	Boolean			NullSzSqlStrInChecked;
	Boolean			NullSzSqlStrOutChecked;
	Boolean			NullPcbSqlStrOutChecked;
	short			cbSqlStrInChoice;
	Str15			cbSqlStrInText;
	Str15			cbSqlStrMaxText;
} SQLNativeSQLRec, *SQLNativeSQLRecPtr;

	Boolean GetSQLNativeSQL( SQLNativeSQLRec * );


typedef struct
{
	Boolean			NullPcparOutChecked;
} SQLNumParamsRec, *SQLNumParamsRecPtr;

Boolean GetSQLNumParams( SQLNumParamsRec * );


typedef struct		// #18
{
	Boolean			NullPccolOutChecked;
} SQLNumResultColsRec, *SQLNumResultColsRecPtr;

	Boolean GetSQLNumResultCols( SQLNumResultColsRec * );


typedef struct		// #48
{
	Boolean			NullPrgbValueOutChecked;
} SQLParamDataRec, *SQLParamDataRecPtr;

	Boolean GetSQLParamData( SQLParamDataRec * );


typedef struct
{
	Boolean			NullPirowPointerChecked;
	Str15			crowText;
} SQLParamOptionsRec, *SQLParamOptionsRecPtr;

	Boolean GetSQLParamOptions( SQLParamOptionsRec * );


typedef struct		// #19
{
	Boolean			NullSzSqlStrChecked;
	short			cbSqlStrChoice;
	Str15			cbSqlStrText;
} SQLPrepareRec, *SQLPrepareRecPtr;

	Boolean GetSQLPrepare( SQLPrepareRec * );


typedef struct		// #65
{
	short			QualifierChoice;
	short			OwnerChoice;
	short			NameChoice;
	short			cbQualifierChoice;
	short			cbOwnerChoice;
	short			cbNameChoice;

	Str255			QualifierText;
	Str255			OwnerText;
	Str255			NameText;
	Str15			cbQualifierText;
	Str15			cbOwnerText;
	Str15			cbNameText;
} SQLPrimaryKeysRec, *SQLPrimaryKeysRecPtr;

Boolean GetSQLPrimaryKeys( SQLPrimaryKeysRec * );


typedef struct		// #66
{
	short			QualifierChoice;
	short			OwnerChoice;
	short			NameChoice;
	short			ColNameChoice;
	short			cbQualifierChoice;
	short			cbOwnerChoice;
	short			cbNameChoice;
	short			cbColNameChoice;

	Str255			QualifierText;
	Str255			OwnerText;
	Str255			NameText;
	Str255			ColNameText;
	Str15			cbQualifierText;
	Str15			cbOwnerText;
	Str15			cbNameText;
	Str15			cbColNameText;
} SQLProcedureColumnsRec, *SQLProcedureColumnsRecPtr;

	Boolean GetSQLProcedureColumns( SQLProcedureColumnsRec * );


typedef struct		// #67
{
	short			QualifierChoice;
	short			OwnerChoice;
	short			NameChoice;
	short			cbQualifierChoice;
	short			cbOwnerChoice;
	short			cbNameChoice;

	Str255			QualifierText;
	Str255			OwnerText;
	Str255			NameText;
	Str15			cbQualifierText;
	Str15			cbOwnerText;
	Str15			cbNameText;
} SQLProceduresRec, *SQLProceduresRecPtr;

	Boolean GetSQLProcedures( SQLProceduresRec * );


typedef struct		// #49
{
	Boolean			NullRgbValueChecked;
	short			cbValueChoice;
	Str15			cbValueText;
} SQLPutDataRec, *SQLPutDataRecPtr;

	Boolean GetSQLPutData( SQLPutDataRec * );


typedef struct		// #20
{
	Boolean			NullPcrowOutChecked;
} SQLRowCountRec, *SQLRowCountRecPtr;

	Boolean GetSQLRowCount( SQLRowCountRec * );


typedef struct		// #50
{
	short			fOptionChoice;
	short			vParamChoice;
	Str255			fOptionText;
	Str255			vParamText;
} SQLSetConnectOptionRec, *SQLSetConnectOptionRecPtr;

	Boolean GetSQLSetConnectOption( SQLSetConnectOptionRec * );


typedef struct		// #21
{
	short			szCursorChoice;
	short			cbCursorChoice;
	Str255			szCursorText;
	Str15			cbCursorText;
} SQLSetCursorNameRec, *SQLSetCursorNameRecPtr;

	Boolean GetSQLSetCursorName( SQLSetCursorNameRec * );


typedef struct		// #22
{
	Boolean			NullPcbValuePointerChecked;
	short			fCTypeChoice;
	short			fSqlTypeChoice;
	short			rgbValueChoice;
	Str15			iparText;
	Str15			cbColDefText;
	Str15			ibScaleText;
	Str15			cbValMaxText;
	Str255			fcTypeText;
	Str255			fSqlTypeText;
	Str255			rgbValueText;
} SQLSetParamRec, *SQLSetParamRecPtr;

	Boolean GetSQLSetParam( SQLSetParamRec * );


typedef struct		// #68
{
	short			fRefreshChoice;
	short			fLockChoice;
	Str15			irowText;
	Str255			fRefreshText;
	Str255			fLockText;
} SQLSetPosRec, *SQLSetPosRecPtr;

Boolean GetSQLSetPos( SQLSetPosRec * );


typedef struct		// #69
{
	short			fConcurrencyChoice;
	short			crowKeysetChoice;
	Str255			fConcurrencyText;
	Str255			crowKeysetText;
	Str15			crowRowsetText;
} SQLSetScrollOptionsRec, *SQLSetScrollOptionsRecPtr;

Boolean GetSQLSetScrollOptions( SQLSetScrollOptionsRec * );


typedef struct		// #51
{
	short			fOptionChoice;
	short			vParamChoice;
	Str255			fOptionText;
	Str255			vParamText;
} SQLSetStmtOptionRec, *SQLSetStmtOptionRecPtr;

	Boolean GetSQLSetStmtOption( SQLSetStmtOptionRec * );


typedef struct		// #52
{
	short			QualifierChoice,	OwnerChoice,	NameChoice;
	short			cbQualifierChoice,	cbOwnerChoice,	cbNameChoice;
	short			fColTypeChoice;
	short			fNullableChoice;
	short			fScopeChoice;

	Str255			fColTypeText;
	Str255			QualifierText,		OwnerText,		NameText;
	Str15			cbQualifierText,	cbOwnerText,	cbNameText;
	Str255			fScopeText;
	Str255			fNullableText;
} SQLSpecialColumnsRec, *SQLSpecialColumnsRecPtr;

	Boolean GetSQLSpecialColumns( SQLSpecialColumnsRec * );


typedef struct		// #53
{
	short			QualifierChoice;
	short			OwnerChoice;
	short			NameChoice;
	short			cbQualifierChoice;
	short			cbOwnerChoice;
	short			cbNameChoice;
	short			fUniqueChoice;
	short			fAccuracyChoice;

	Str255			QualifierText;
	Str255			OwnerText;
	Str255			NameText;
	Str15			cbQualifierText;
	Str15			cbOwnerText;
	Str15			cbNameText;
	Str255			fUniqueText;
	Str255			fAccuracyText;
} SQLStatisticsRec, *SQLStatisticsRecPtr;

	Boolean GetSQLStatistics( SQLStatisticsRec * );


typedef struct		// #70
{
	short			QualifierChoice;
	short			OwnerChoice;
	short			NameChoice;
	short			cbQualifierChoice;
	short			cbOwnerChoice;
	short			cbNameChoice;

	Str255			QualifierText;
	Str255			OwnerText;
	Str255			NameText;
	Str15			cbQualifierText;
	Str15			cbOwnerText;
	Str15			cbNameText;
} SQLTablePrivilegesRec, *SQLTablePrivilegesRecPtr;

	Boolean GetSQLTablePrivileges( SQLTablePrivilegesRec * );


typedef struct		// #54
{
	short			QualifierChoice,	OwnerChoice,	NameChoice,		TypeChoice;
	short			cbQualifierChoice,	cbOwnerChoice,	cbNameChoice,	cbTypeChoice;

	Str255			QualifierText,		OwnerText,		NameText,		TypeText;
	Str15			cbQualifierText,	cbOwnerText,	cbNameText,		cbTypeText;
} SQLTablesRec, *SQLTablesRecPtr;

	Boolean GetSQLTables( SQLTablesRec * );


typedef struct
{
	Boolean			NullHenvChecked;
	Boolean			NullHdbcChecked;
	short			fTypeChoice;
	Str255			fTypeText;
} SQLTransactRec, *SQLTransactRecPtr;

	Boolean GetSQLTransact( SQLTransactRec * );


typedef struct
{
	short			FPpcbValueChoice;
	Str15			iparText;
	Str255			rgbValueText;
	Str255			pcbValueText;
} FillParamRec, *FillParamRecPtr;

	Boolean GetFillParam( FillParamRec * );


typedef struct
{
	short			DataSourceChoice;
	Str255			UserIDText;
	Str255			PasswordText;
	Str255			DataSourceText;
} FullConnectRec, *FullConnectRecPtr;

	Boolean GetFullConnect( FullConnectRec * );
