
	/*
	** EXECUTE.C - This is the module containing the code for SQL for
	** executing SQL Commands.
	**
	** (C) Copyright 1991, 1992 By Microsoft Corp.
	*/


#include "sample.h"


	//  Execute a prepared SQL statement

SQL_API RETCODE SQLExecute( HSTMT )			// statement to execute.
{
	return SQL_SUCCESS;
}


	//  Performs the equivalent of SQLPrepare, followed by SQLExecute.

SQL_API RETCODE SQLExecDirect( HSTMT, UCHAR*, SDWORD )
{
	return SQL_SUCCESS;
}


	//  Returns the SQL string as modified by the driver.

SQL_API RETCODE SQLNativeSql( HDBC, UCHAR*, SDWORD, UCHAR*, SDWORD, SDWORD* )
{
	return SQL_SUCCESS;
}


	//  Supplies parameter data at execution time.  Used in conjuction with
	//  SQLPutData.

SQL_API RETCODE SQLParamData( HSTMT, PTR* )
{
	return SQL_SUCCESS;
}


	//  Supplies parameter data at execution time.  Used in conjunction with
	//  SQLParamData.

SQL_API RETCODE SQLPutData( HSTMT, PTR, SDWORD )
{
	return SQL_SUCCESS;
}


SQL_API RETCODE SQLCancel( HSTMT )		// Statement to cancel.
{
	return SQL_SUCCESS;
}
