/*
 *	DialogUtilities.h
 *
 *	(c) Apple Computer, Inc 1993
 */

#ifndef __DialogUtilities__
#define __DialogUtilities__

#ifndef __DIALOGS__
#include <Dialogs.h>
#endif

#ifndef __TYPES__
#include <Types.h>
#endif

/*
 * dialog event handling
 */

void			MovableDialog		(ModalFilterProcPtr filterProc, short *itemHit);
pascal Boolean	StandardFilter		(DialogPtr dialog, EventRecord *event, short *itemHit);

/*
 * dialog item handling
 */

void			SetDUserItem		(DialogPtr dialog, short item, ProcPtr drawProc);
void			EnableDItem			(DialogPtr dialog, short item, Boolean enable);
void			GetDText			(DialogPtr dialog, short item, char *text);
void			SetDText			(DialogPtr dialog, short item, char *text);
void			SetDRadioButton		(DialogPtr dialog, short btn, short firstBtn, short lastBtn);
short			GetDRadioButton		(DialogPtr dialog, short firstBtn, short lastBtn);
void			OutlineDItem		(DialogPtr dialog, short item);
pascal void		DrawItemLineGray	(DialogPtr dialog, short item);
pascal void		DrawItemRect		(DialogPtr dialog, short item);

#endif __DialogUtilities__
