/*
	File:		CFrntDmp.cpp

	Contains:	Definitions to include in a CFront load/dump file.

	Written by:	Nick Pilch

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 3/17/94	CG		#1151392: Removed ConstDef.h.
		 <2>	 2/16/94	JA		Added AltPoint.h.
		 <5>	 12/6/93	NP		Removed Utility.h.
		 <4>	 12/3/93	T		removed OrdColl.h because it was breaking
									the compilation of Link.cp
		 <3>	 12/3/93	NP		Added some files.
		 <2>	 12/3/93	T		Rename XMPError.h to ErrorDef.h
		 <1>	11/12/93	NP		first checked in

	To Do:
*/

#ifndef _ALTPOINT_
#include "AltPoint.h"		/* Must be included before PlfmType.h */
#endif						/* so we have no choice but to precompile it */

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

#ifndef _ERRORDEF_
#include "ErrorDef.h"
#endif

#ifndef _PLFMDEF_
#include "PlfmDef.h"
#endif

#ifndef _EXCEPT_
#include "Except.h"
#endif

#ifndef _ISOSTR_
#include "ISOStr.h"
#endif

#ifndef _PASCLSTR_
#include "PasclStr.h"
#endif

#ifndef _XMPMEM_
#include "XMPMem.h"
#endif

#ifndef _STDDEFS_
#include "StdDefs.h"
#endif

