/*
	File:		FWSclBar.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1+>	 3/17/94	DS		Add CDECL to dtor for CScrollbar

	To Do:
*/

#ifndef _FWSCLBAR_
#define _FWSCLBAR_

#ifndef _FWVIEW_
#include "FWView.h"
#endif


//========================================================================================
// Foward class declarations
//========================================================================================

class FW_CControlMgrHelper;


//========================================================================================
// CLASS FW_CScrollBar
//========================================================================================

#define kFW_CScrollBarID "appl:FW_CScrollBar$class,1.0.0"

class FW_CScrollBar : public FW_CView
{
// ----- Initialization/destruction
public:
						FW_CScrollBar();
	virtual				~ CDECL FW_CScrollBar();
	
	void				InitScrollBar(CFacet* facet, FW_CView* enclosure,
									  XMPID identifier,
									  XMPTransform* transform, XMPShape* shape);
	void				InitScrollBar(FW_CView* enclosure,
									  XMPID identifier,
									  XMPTransform* transform, XMPShape* shape);

// ----- Update
public:
	virtual void 		Draw(XMPShape* area);

// ----- Mouse events
public:
	virtual XMPBoolean	MouseDown(const XMPPoint& where, XMPEventData event);
	
private:
	FW_CControlMgrHelper*		fControlMgrHelper;
};

//----------------------------------------------------------------------------------------
// FW_CView::InitView
//----------------------------------------------------------------------------------------

inline void FW_CScrollBar::InitScrollBar(FW_CView* enclosure, XMPID identifier,
										 XMPTransform* transform, XMPShape* shape)
{
	InitScrollBar(enclosure->GetFacet(), enclosure, identifier, transform, shape);
}

#endif
