/*
	File:		TextUtil.h

	Contains:	implementation of class CDrawTextInitiator

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _TEXTUTIL_
#define _TEXTUTIL_

#ifndef _FWUTIL_
#include "FWUtil.h"
#endif


//===================================================================================================
// Forward class declarations
//===================================================================================================

class CTextFacet;


//===================================================================================================
// CLASS CTextDrawInitiator
//===================================================================================================

class CTextDrawInitiator : public CDrawInitiator
{
public:
	CTextDrawInitiator(CTextFacet *facet, XMPShape* clipShape = kXMPNULL);
	virtual ~CTextDrawInitiator();
};

#endif
