/*
	File:		DrawDef.h

	Contains:	defines for DrawPart code and resources

	Written by:	Caia Grisar

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <8>	 3/28/94	CG		1150376: No longer support ASLM versioning.
		 <7>	  2/8/94	JA		Moved 'kNMAPIDxx' consts to DrawPart.r
		 <6>	 1/18/94	CG		Added define for file type.
		 <5>	 1/14/94	CG		Added defines for user strings.
		 <4>	 1/12/94	CG		Added kNMAPid1 and 2.
		 <3>	 12/6/93	CG		Clean up
		 <2>	11/18/93	CG		Moved kDrawPartID here.
		 <1>	11/16/93	CG		first checked in

	To Do:
*/

#ifndef _DRAWDEF_
#define _DRAWDEF_

#ifndef _STDDEFS_
	#include "StdDefs.h"
#endif _STDDEFS_

// Kind
#define kXMPKindTestDraw "Apple:Kind:TestDraw"

// ClassID
#define kDrawPartID "appl:drawpart$class"

// Editor User String
#define kDrawEditorUserString "Test Draw 1.0"

// Kind User String
#define kDrawKindUserString "Test Draw"

// Category User String
#define kDrawCategoryUserString "Graphics"

// Draw OSType
#define kDrawOSType 'DRAW'

#endif _DRAWDEF_