/*
	File:		DrawPart.h

	Contains:	Interface to OSL support routines for the DrawPart

	Written by:	Caia Grisar

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 12/9/93	eeh		added typeFrameProp
		 <2>	 12/1/93	CG		Added type defs for PartProp and
									EmbededPartProp.
		 <1>	11/16/93	CG		first checked in
	To Do:
*/

#ifndef _DRAWOBJ_
#define _DRAWOBJ_

#ifndef _PLFMDEF_
#include "PlfmDef.h"
#endif

//==============================================================================
// Constants
//==============================================================================

enum
{
	typeEmbededPartProp = 'eppr'
	,typePartProp 		= 'pprp'
	,typeFrameProp 		= 'frmp'
};

#endif // _DRAWOBJ_