/* @(#) somk/somitype.pub 2.2 5/3/93 15:04:19 [8/2/93 08:46:06] */

/*
 * 96F8647, 96F8648 (C) Copyright IBM Corp. 1992, 1993
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 */

/*
 *    SOMITYPE.PUB
 *    Public Version of Implementation-Related typedefs for C and C++
 *    Multiple Inheritance Version
 */

#ifndef somitype_h
#define somitype_h

/*  -- Public Object Instance Structure */
struct somMethodTabStruct;
typedef struct SOMAny_struct {
    struct somMethodTabStruct  *mtab;
    integer1 body[1];
} SOMAny;


/* -- For building lists of class objects */
typedef
    struct somClassList {
        SOMClass   *cls;
        struct somClassList *next;
    } somClassList, *somClasses;


/* -- Generic procedure pointer types */
#ifdef __IBMC__
#ifndef __cplusplus
  #pragma linkage( somMethodProc, system )
  #pragma linkage( somTP_somClassInitFunc, system)
#endif
#endif
typedef integer4 SOMLINK somMethodProc(void);
typedef somMethodProc *somMethodPtr;
typedef void SOMLINK somTP_somClassInitFunc(SOMClass *somSelf);


/* -- Public Method Table Structure */
typedef struct somMethodTabStruct {
    SOMClass 	  *classObject;
    void      	  *classInfo;
    somMethodProc *entries[1];		
} somMethodTab, *somMethodTabPtr;


/* -- For building lists of method tables */
typedef
    struct somMethodTabList {
        somMethodTab             *mtab;
        struct somMethodTabList  *next;
    } somMethodTabList, *somMethodTabs;


/* -- Public Method and Data Tokens */
typedef somToken somMToken;
typedef somToken somDToken;
typedef somToken somClassInfo;
typedef somToken SOMTokBuf;

/* -- Generic ClassData structure */
typedef 
   struct {
       SOMClass *classObject;
       somToken tokens[1];
   } somClassDataStructure, *somClassDataStructurePtr;

/* -- Generic Auxiliary Class Data Structure */
typedef 
   struct  {
       somMethodTabs parentMtab;
       somDToken instanceDataToken;
       somMethodPtr ptrs[1];
    } somCClassDataStructure, *somCClassDataStructurePtr;

#endif /* somitype_h */
