/* @(#) somc/somtcnst.h 2.4 5/24/93 15:45:13 [8/2/93 08:42:59] */

/*
 * 96F8647, 96F8648 (C) Copyright IBM Corp. 1992, 1993
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 */

/*
 * SOMTCNST.H
 * TypeCode constants as defined in CORBA for use with SOM
 */

#ifndef somtcnst_h
#define somtcnst_h

#ifdef somtcnst_xh
  #include <som.xh>
#else
  #include <som.h>
#endif /* somtcnst_xh */

/* CORBA 7.6.2, p.141 */
#define TC_null 		    ((TypeCode) &TC__null)
#define TC_void 		    ((TypeCode) &TC__void)
#define TC_short		    ((TypeCode) &TC__short)
#define TC_long 		    ((TypeCode) &TC__long)
#define TC_ushort		    ((TypeCode) &TC__ushort)
#define TC_ulong		    ((TypeCode) &TC__ulong)
#define TC_float		    ((TypeCode) &TC__float)
#define TC_double		    ((TypeCode) &TC__double)
#define TC_boolean		    ((TypeCode) &TC__boolean)
#define TC_char 		    ((TypeCode) &TC__char)
#define TC_octet		    ((TypeCode) &TC__octet)
#define TC_any			    ((TypeCode) &TC__any)
#define TC_TypeCode		    ((TypeCode) &TC__TypeCode)
#define TC_Principal		    ((TypeCode) &TC__Principal)
#define TC_Object		    ((TypeCode) &TC__Object)
#define TC_string		    ((TypeCode) &TC__string)
#define TC_NamedValue		    ((TypeCode) &TC__NamedValue)
#define TC_InterfaceDescription     ((TypeCode) &TC__InterfaceDescription)
#define TC_OperationDescription     ((TypeCode) &TC__OperationDescription)
#define TC_AttributeDescription     ((TypeCode) &TC__AttributeDescription)
#define TC_ParameterDescription     ((TypeCode) &TC__ParameterDescription)
#define TC_RepositoryDescription    ((TypeCode) &TC__RepositoryDescription)
#define TC_ModuleDescription	    ((TypeCode) &TC__ModuleDescription)
#define TC_ConstDescription	    ((TypeCode) &TC__ConstDescription)
#define TC_ConstantDescription	    ((TypeCode) &TC__ConstDescription)
#define TC_ExceptionDescription     ((TypeCode) &TC__ExceptionDescription)
#define TC_TypeDescription	    ((TypeCode) &TC__TypeDescription)
#define TC_FullInterfaceDescription ((TypeCode) &TC__FullInterfaceDescription)

SOMEXTERN somToken TC__null;
SOMEXTERN somToken TC__void;
SOMEXTERN somToken TC__short;
SOMEXTERN somToken TC__long;
SOMEXTERN somToken TC__ushort;
SOMEXTERN somToken TC__ulong;
SOMEXTERN somToken TC__float;
SOMEXTERN somToken TC__double;
SOMEXTERN somToken TC__boolean;
SOMEXTERN somToken TC__char;
SOMEXTERN somToken TC__octet;
SOMEXTERN somToken TC__any;
SOMEXTERN somToken TC__TypeCode;
SOMEXTERN somToken TC__Principal;
SOMEXTERN somToken TC__Object;
SOMEXTERN somToken TC__string;
SOMEXTERN somToken TC__NamedValue;
SOMEXTERN somToken TC__InterfaceDescription;
SOMEXTERN somToken TC__OperationDescription;
SOMEXTERN somToken TC__AttributeDescription;
SOMEXTERN somToken TC__ParameterDescription;
SOMEXTERN somToken TC__RepositoryDescription;
SOMEXTERN somToken TC__ModuleDescription;
SOMEXTERN somToken TC__ConstDescription;
SOMEXTERN somToken TC__ExceptionDescription;
SOMEXTERN somToken TC__TypeDescription;
SOMEXTERN somToken TC__FullInterfaceDescription;

#endif /* somtcnst_h */
