/* AppleEventUtils.h
 *------------------------------------------------------------*
 *	AppleEvent-related utility routines
 */

#include "Processes.h"
#include "AppleEvents.h"


/* GetProcessLocation uses PPCBrowser to allow the user to specify where a 
 *	process is running.  The given prompt will be shown at the top of the
 *	PPCBrowser dialog.
 */
OSErr GetProcessLocation(StringPtr prompt, 
						LocationNameRec *theLocation, 
						PortInfoRec *thePortInfo);


/* SendAppleEvent1Param sends an apple event with the given class and ID to the given location.
 *	The direct parameter is set to the given data before sending.
 */
OSErr SendAppleEvent1Param(LocationNameRec	*theLocation, 
							PortInfoRec		*thePortInfo, 
							AEEventClass	eventClass,
							AEEventID		eventID,
							DescType		dataType, 
							void			*dataPtr, 
							Size			dataSize);
