PROGRAM GraphicsApp;

USES
 ToolIntf, Types, 	GraphicsToolbox, GraphicsMacintosh, GraphicsDebugging, LayoutRoutines, MathRoutines, GraphicsRoutines, FontRoutines;

VAR
	myRectangle:	gxRectangle;
	myShape:			gxShape;
	looper:				integer;
	curColor:			gxColor;

BEGIN
	GXEnterGraphics;
	myRectangle.top := $640000; { ff(100) }
	myRectangle.left := $640000;
	myRectangle.right := $C80000; { ff(200) }
	myRectangle.bottom := $C80000;
	myShape := GXNewRectangle(@myRectangle);
	GXMoveShape(myShape, $640000, $640000);
	
	curColor.space := gxHSVSpace;
	curColor.profile := NIL;

	FOR looper := 1 TO 36 DO
		BEGIN
		GXRotateShape(myShape, $140000, $1200000, $1200000);
		curColor.hsv.hue := looper * 1500;
		curColor.hsv.saturation := 65535;
		curColor.hsv.value := 32767;
		GXSetShapeColor(myShape, @curColor);
		GXDrawShape(myShape);
		END;
		
	GXDisposeShape(myShape);
END.