{
 graphics:    
    math type definitions
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.

}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT MathTypes;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingMathTypes}
{$SETC UsingMathTypes := 1}




TYPE
CharArray = ARRAY [0..0] OF Char;
ByteArray = ARRAY [0..0] OF Byte;
IntegerArray = ARRAY [0..0] OF Integer;
LongIntArray = ARRAY [0..0] OF LongInt;
PointerArray = ARRAY [0..0] OF Ptr;
LongIntPointer = ^LongInt;

UnsignedInteger = 0..65535;
UnsignedIntegerPointer = ^UnsignedInteger;
UnsignedIntegerArray = ARRAY [0..0] OF UnsignedInteger;

{ UnsignedLongInt = 0..4294967295; }
UnsignedLong = LongInt;
UnsignedLongPointer = ^UnsignedLong;
UnsignedLongArray = ARRAY [0..0] OF UnsignedLong;

UnsignedLongInt = LongInt;
UnsignedLongIntPointer = ^UnsignedLongInt;
UnsignedLongIntArray = ARRAY [0..0] OF UnsignedLongInt;

{ Boolean = Byte; }
BooleanPointer = ^Boolean;
BooleanArray = ARRAY [0..0] OF Boolean;

{ Fixed = LongInt; }
FixedPointer = ^Fixed;
FixedArray = ARRAY [0..0] OF Fixed;

GxPoint = RECORD
	x, y: Fixed;
	END;
GxPointPointer = ^GxPoint;
GxPointArray = ARRAY [0..0] OF GxPoint;

{ Fract = LongInt; }
FractPointer = ^Fract;
FractArray = ARRAY [0..0] OF Fract;

GxColorValue = INTEGER;
GxColorValuePointer = ^GxColorValue;
GxColorValueArray = ARRAY [0..0] OF GxColorValue;

GxPolar = RECORD
	radius, angle: Fixed;
	END;
GxPolarPointer = ^GxPolar;
GxPolarArray = ARRAY [0..0] OF GxPolar;

GxWide = RECORD
	hi: LongInt;
	lo: UnsignedLong;
	END;
GxWidePointer = ^GxWide;
GxWideArray = ARRAY [0..0] OF GxWide;

GxMapping = RECORD
	map: ARRAY [0..3, 0..3] OF Fixed;
	END;
GxMappingPointer = ^GxMapping;
GxMappingArray = ARRAY [0..0] OF GxMapping;



{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
