/* graphics:
	macintosh interfaces
	by Cary Clark, Georgiann Delaney, Herb Derby, Michael Fairman, Pablo Fernicola, Dave Good, Josh Horwich, Barton House, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1994 Apple Computer, Inc.  All rights reserved.	*/

#pragma once

#ifndef graphicsMacintoshIncludes
	#define graphicsMacintoshIncludes

	#define gestaltGraphicsVersion			'grfx'		/* gestalt version selector */
	#define gestaltCurrentGraphicsVersion	0x00010000	/* the version described by these headers */

	#define gestaltGraphicsAttr			'gfxa'		/* gestalt attributes selector */
	#define gestaltGraphicsIsDebugging		0x00000001
	#define gestaltGraphicsIsLoaded		0x00000002
	#define gestaltGraphicsIsPowerPC		0x00000004

	#ifndef graphicsLinkageIncludes
		#include "graphics linkage.h"
	#endif

	enum {
		defaultPollingHandlerFlags = 0x00,
		okToSwitchDuringPollFlag = 0x00,
		dontSwitchDuringPollFlag = 0x01
	};
	typedef long gxPollingHandlerFlags;
		
	#pragma procname gxPollingHandler
	typedef void (*gxPollingHandlerProcPtr)(long reference, gxPollingHandlerFlags flags);

	gxPollingHandlerProcPtr GXGetGraphicsPollingHandler(long *reference) GXInlineCode(0x245, gxNeedClient);
	void GXSetGraphicsPollingHandler(gxPollingHandlerProcPtr handler, long reference) GXInlineCode(0x246, gxNeedClient);

#endif
